<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2010 BVB Media BV - Bas van Beek <bvbmedia@gmail.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */
require_once(PATH_tslib.'class.tslib_pibase.php');
require_once(t3lib_extMgm::extPath('multishop').'pi1/classes/class.mslib_fe.php');
require_once(t3lib_extMgm::extPath('multishop').'pi1/classes/class.mslib_befe.php');
/**
 * Plugin 'multishop' for the 'multishop' extension.
 *
 * @author	BVB Media BV - Bas van Beek <bvbmedia@gmail.com>
 * @package	TYPO3
 * @subpackage	tx_multishop
 */
global $ms,$get,$server,$post;
class tx_multishop_pi1 extends tslib_pibase {
	var $cObj;    // reference to the calling object. 
	var $prefixId      = 'tx_multishop_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_multishop_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey        = 'multishop';	// The extension key.
	var $pi_checkCHash = true;
	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array			$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
 	/**
    * Init Function: here all the needed configuration values are stored in class variables
    *
    * @param    array   $conf: configuration array from TS
    * @return   void
	 */
	function init($conf)
	{
	  $this->conf = $conf; // Store configuration
	  $this->pi_setPiVarDefaults(); // Set default piVars from TS
	  $this->pi_initPIflexForm(); // Init FlexForm configuration for plugin
	  // Read extension configuration
	  $extConf = unserialize($GLOBALS['TYPO3_CONF_VARS']['EXT']['extConf'][$this->extKey]);
	  if (is_array($extConf))
	  {
		 $conf = t3lib_div::array_merge($extConf, $conf);
	  }
	  // Read TYPO3_CONF_VARS configuration
	  $varsConf = $GLOBALS['TYPO3_CONF_VARS']['EXTCONF'][$this->extKey];
	  if (is_array($varsConf))
	  {
		 $conf = t3lib_div::array_merge($varsConf, $conf);
	  }
	  // Read FlexForm configuration
	  if ($this->cObj->data['pi_flexform']['data'])
	  {
		 foreach ($this->cObj->data['pi_flexform']['data'] as $sheetName => $sheet)
		 {
			foreach ($sheet as $langName => $lang)
			{
			   foreach(array_keys($lang) as $key)
				{
				  $flexFormConf[$key] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], $key, $sheetName, $langName);
				  if (!$flexFormConf[$key])
				  {
						unset($flexFormConf[$key]);
				  }
			   }
			}
		 }
	  }
	  if (is_array($flexFormConf))
	  {
		 $conf = t3lib_div::array_merge($conf, $flexFormConf);
	  }
	  $this->conf = $conf;
	}	
	function ajax_main($content, $conf){
		/*
			this method is created for returning ajax content.
		*/
		$this->AJAX_MODE=1;
		global $ms,$get,$server,$post;		
		// Get the vhost full path (example: /var/www/html/domain.com/public_html/my_cms/)
		$this->DOCUMENT_ROOT=PATH_site;
		// Get the vhost full path to multishop (example: /var/www/html/domain.com/public_html/my_cms/typo3conf/ext/multishop/)
		$this->DOCUMENT_ROOT_MS=PATH_site.t3lib_extMgm::siteRelPath($this->extKey);
		$this->HTTP_HOST = t3lib_div::getIndpEnv('HTTP_HOST');
		// Get the site full URL (example: http://domain.com/my_cms/)
		$this->FULL_HTTP_URL = t3lib_div::getIndpEnv('TYPO3_SITE_URL');
		// Get the multishop full URL (example: http://domain.com/my_cms/typo3/ext/multishop or http://domain.com/my_cms/typo3conf/ext/multishop)
		$this->FULL_HTTP_URL_MS=t3lib_div::getIndpEnv('TYPO3_SITE_URL').t3lib_extMgm::siteRelPath($this->extKey);		
		set_include_path($this->DOCUMENT_ROOT_MS.PATH_SEPARATOR.$this->DOCUMENT_ROOT_MS.'scripts/');			
		// load language cookie for the backend
		$post = t3lib_div::_POST();
		$this->cookie = $GLOBALS['TSFE']->fe_user->getKey('ses', 'tx_multishop_cookie');		
		if ($this->cookie['multishop_admin_language'])
		{
			$this->LLkey=$this->cookie['multishop_admin_language'];
			$this->config['config']['language']=$this->cookie['multishop_admin_language'];
		}
		// load language cookie for the backend eof			
		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_initPIflexForm();
		$this->pi_USER_INT_obj = 1;
		// this will convert any string which is supplied as $_SERVER['REMOTE_ADDR'] into a valid ip address
		$this->REMOTE_ADDR = t3lib_div::getIndpEnv('REMOTE_ADDR');
		if ($this->conf['method']) 	$this->method 			= $this->conf['method'];
		else						$this->method 			= $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'method', 'sDEFAULT');
		// shop pid
		$this->shop_pid 		= $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'page_uid', 'sDEFAULT');	
		if (!$this->shop_pid and $this->conf['shop_pid'] > 0)	$this->shop_pid=$this->conf['shop_pid'];
		if(!$this->shop_pid)	$this->shop_pid	=$GLOBALS["TSFE"]->id;
		// shop pid eof
		$this->admin_group 		= $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'admin_group', 'sDEFAULT');
		// var for the tabbed navigation menu
		$this->maxDELIMITED		= $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'maxDELIMITED', 's_listing');
		$this->lang=$GLOBALS['TSFE']->config['config']['language'];
		$this->sys_language_uid=$GLOBALS['TSFE']->config['config']['sys_language_uid'];
		if (!isset($this->sys_language_uid)) $this->sys_language_uid=0;
		if (!$GLOBALS['TSFE']->config['config']['baseURL'])
		{
			echo '<h1>config.baseURL='.$this->FULL_HTTP_URL.' is not set yet. Please go to the Typo3 template setup field editor and add it.</h1>';
			die();
		}	
		include_once('application_top_once.php');
		include('application_top_always.php');	
		// if cache module is enabled and a admin is logged in temporary disable the caching module
		if ($ms['MODULES']['META_TITLE'] and !$GLOBALS['TSFE']->additionalHeaderData['title'])			$GLOBALS['TSFE']->additionalHeaderData['title'] 			= '<title>'.htmlspecialchars($ms['MODULES']['META_TITLE']).'</title>';	
		if ($ms['MODULES']['META_DESCRIPTION'] and !$GLOBALS['TSFE']->additionalHeaderData['description'])		$GLOBALS['TSFE']->additionalHeaderData['description'] 		= '<meta name="description" content="'.htmlspecialchars($ms['MODULES']['META_DESCRIPTION']).'" />';		
		if ($ms['MODULES']['CACHE_FRONT_END'] and $this->ADMIN_USER) $ms['MODULES']['CACHE_FRONT_END']=0;		
		$format=explode("x",$ms['MODULES']['CATEGORY_IMAGE_SIZE_NORMAL']);
		$ms['category_image_formats']['normal']['width']	=$format[0];
		$ms['category_image_formats']['normal']['height']	=$format[1];
		$format=explode("x",$ms['MODULES']['PRODUCT_IMAGE_SIZE_50']);
		$ms['product_image_formats'][50]['width']				=$format[0];
		$ms['product_image_formats'][50]['height']			=$format[1];
		$format=explode("x",$ms['MODULES']['PRODUCT_IMAGE_SIZE_100']);
		$ms['product_image_formats'][100]['width']			=$format[0];
		$ms['product_image_formats'][100]['height']			=$format[1];
		$format=explode("x",$ms['MODULES']['PRODUCT_IMAGE_SIZE_200']);
		$ms['product_image_formats'][200]['width']			=$format[0];
		$ms['product_image_formats'][200]['height']			=$format[1];
		$format=explode("x",$ms['MODULES']['PRODUCT_IMAGE_SIZE_300']);
		$ms['product_image_formats'][300]['width']			=$format[0];
		$ms['product_image_formats'][300]['height']			=$format[1];
		$format=explode("x",$ms['MODULES']['PRODUCT_IMAGE_SIZE_ENLARGED']);
		$ms['product_image_formats']['enlarged']['width']	=$format[0];
		$ms['product_image_formats']['enlarged']['height']	=$format[1];
		require('ajax_pages/core.php');
	}	
	function main($content, $conf){
		global $ms,$get,$server,$post;		
		// Get the vhost full path (example: /var/www/html/domain.com/public_html/my_cms/)
		$this->DOCUMENT_ROOT=PATH_site;
		// Get the vhost full path to multishop (example: /var/www/html/domain.com/public_html/my_cms/typo3conf/ext/multishop/)
		$this->DOCUMENT_ROOT_MS=PATH_site.t3lib_extMgm::siteRelPath($this->extKey);
		$this->HTTP_HOST = t3lib_div::getIndpEnv('HTTP_HOST');
		// Get the site full URL (example: http://domain.com/my_cms/)
		$this->FULL_HTTP_URL = t3lib_div::getIndpEnv('TYPO3_SITE_URL');		
		// Get the multishop full URL (example: http://domain.com/my_cms/typo3/ext/multishop or http://domain.com/my_cms/typo3conf/ext/multishop)
		$this->FULL_HTTP_URL_MS=t3lib_div::getIndpEnv('TYPO3_SITE_URL').t3lib_extMgm::siteRelPath($this->extKey);
		set_include_path($this->DOCUMENT_ROOT_MS.PATH_SEPARATOR.$this->DOCUMENT_ROOT_MS.'scripts/');
/*		
		if ($this->conf['forceHTTPS'])
		{
			$this->httpTypo3Path = preg_replace('/^(http|https)/', 'https', $this->httpTypo3Path);
			$this->extHttpPath = preg_replace('/^(http|https)/', 'https', $this->extHttpPath);
			$this->FULL_HTTP_URL = preg_replace('/^(http|https)/', 'https', $this->FULL_HTTP_URL);
			$this->hostURL = preg_replace('/^(http|https)/', 'https', $this->hostURL);
		}
*/			
		$post = t3lib_div::_POST();
		// load language cookie for the backend
		$this->cookie = $GLOBALS['TSFE']->fe_user->getKey('ses', 'tx_multishop_cookie');		
//		if (!isset($this->cookie['multishop_admin_language']) and !isset($post['multishop_admin_language'])) $post['multishop_admin_language']='';
		if (isset($post['multishop_admin_language']) and ($post['multishop_admin_language'] != $this->cookie['multishop_admin_language']))
		{
			if ($post['multishop_admin_language']=='default')  $post['multishop_admin_language'] = '';
			$this->cookie['multishop_admin_language'] = $post['multishop_admin_language'];
			$GLOBALS['TSFE']->fe_user->setKey('ses', 'tx_multishop_cookie', $this->cookie);
			$GLOBALS['TSFE']->storeSessionData();
		}	
		$this->cookie = $GLOBALS['TSFE']->fe_user->getKey('ses', 'tx_multishop_cookie');		
		if ($this->cookie['multishop_admin_language'])
		{
			$this->LLkey=$this->cookie['multishop_admin_language'];
			$this->config['config']['language']=$this->cookie['multishop_admin_language'];
		}
		// load language cookie for the backend eof		
		$this->conf = $conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_initPIflexForm();
		$this->pi_USER_INT_obj = 1;
		// this will convert any string which is supplied as $_SERVER['REMOTE_ADDR'] into a valid ip address
		$this->REMOTE_ADDR = t3lib_div::getIndpEnv('REMOTE_ADDR');
		if ($this->conf['method']) 	$this->method 			= $this->conf['method'];
		else						$this->method 			= $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'method', 'sDEFAULT');
		// shop pid
		$this->shop_pid 		= $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'page_uid', 'sDEFAULT');	
		if (!$this->shop_pid and $this->conf['shop_pid'] > 0)	$this->shop_pid=$this->conf['shop_pid'];
		if(!$this->shop_pid)	$this->shop_pid	=$GLOBALS["TSFE"]->id;	
		// shop pid eof		
		$this->admin_group 		= $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'admin_group', 'sDEFAULT');
		// var for the tabbed navigation menu
		$this->maxDELIMITED		= $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'maxDELIMITED', 's_listing');
		$this->lang=$GLOBALS['TSFE']->config['config']['language'];
		$this->sys_language_uid=$GLOBALS['TSFE']->config['config']['sys_language_uid'];
		if (!isset($this->sys_language_uid)) $this->sys_language_uid=0;
		if (!$GLOBALS['TSFE']->config['config']['baseURL'])
		{
			echo 'config.baseURL='.$this->FULL_HTTP_URL.' is not set yet. Please go to the Typo3 template setup field editor and add it.';
			die();
		}				
		include_once('application_top_once.php');
		include('application_top_always.php');			
		// if cache module is enabled and a admin is logged in temporary disable the caching module
		if ($ms['MODULES']['META_TITLE'] and !$GLOBALS['TSFE']->additionalHeaderData['title'])			$GLOBALS['TSFE']->additionalHeaderData['title'] 			= '<title>'.htmlspecialchars($ms['MODULES']['META_TITLE']).'</title>';	
		if ($ms['MODULES']['META_DESCRIPTION'] and !$GLOBALS['TSFE']->additionalHeaderData['description'])		$GLOBALS['TSFE']->additionalHeaderData['description'] 		= '<meta name="description" content="'.htmlspecialchars($ms['MODULES']['META_DESCRIPTION']).'" />';		
		if ($ms['MODULES']['CACHE_FRONT_END'] and $this->ADMIN_USER) $ms['MODULES']['CACHE_FRONT_END']=0;		
		if ($ms['MODULES']['CACHE_FRONT_END'])	require_once(t3lib_extMgm::extPath($this->extKey).'res/Cache_Lite-1.7.8/Lite.php');
		$format=explode("x",$ms['MODULES']['CATEGORY_IMAGE_SIZE_NORMAL']);
		$ms['category_image_formats']['normal']['width']	=$format[0];
		$ms['category_image_formats']['normal']['height']	=$format[1];
		$format=explode("x",$ms['MODULES']['PRODUCT_IMAGE_SIZE_50']);
		$ms['product_image_formats'][50]['width']				=$format[0];
		$ms['product_image_formats'][50]['height']			=$format[1];
		$format=explode("x",$ms['MODULES']['PRODUCT_IMAGE_SIZE_100']);
		$ms['product_image_formats'][100]['width']			=$format[0];
		$ms['product_image_formats'][100]['height']			=$format[1];
		$format=explode("x",$ms['MODULES']['PRODUCT_IMAGE_SIZE_200']);
		$ms['product_image_formats'][200]['width']			=$format[0];
		$ms['product_image_formats'][200]['height']			=$format[1];
		$format=explode("x",$ms['MODULES']['PRODUCT_IMAGE_SIZE_300']);
		$ms['product_image_formats'][300]['width']			=$format[0];
		$ms['product_image_formats'][300]['height']			=$format[1];
		$format=explode("x",$ms['MODULES']['PRODUCT_IMAGE_SIZE_ENLARGED']);
		$ms['product_image_formats']['enlarged']['width']	=$format[0];
		$ms['product_image_formats']['enlarged']['height']	=$format[1];
		// when having a multi category based url get the deepest categories_id and save it as $get['categories_id']		
		if (is_array($get['categories_id']))
		{
			$GLOBALS['categories_id_array']=$get['categories_id'];
			for ($x=5;$x>=0;$x--)
			{
				if ($get['categories_id'][$x])
				{
					$get['categories_id']=$get['categories_id'][$x];
					break;
				}	
			}		
		}	
		switch ($this->method)
		{
			case 'custom_script':
			if ($this->custom_script_location)
			{
				require($this->custom_script_location);		
			}
			break;
			case 'meta_tags':		
			// load the anti flooder
			include_once(t3lib_extMgm::extPath($this->extKey).'res/class.floodblocker.php');			
			$flb = new FloodBlocker (PATH_site.'uploads/tx_multishop/tmp');
			$flb->logs_timeout=5;
			$flb->rules = array (
			   1=>20
			);
			if (!$flb->CheckFlood()) die ('Flood detection: too many requests! Please try later.');
			// load the anti flooder eof	
			// application top things that are only runned the first time when the plugin is initiated
			if ($get['categories_id'] or $get['products_id'])
			{
				include('front_pages/includes/crumbar.php');
				if ($crum)
				{
					$GLOBALS["TYPO3_CONF_VARS"]["tx_multishop"]['crumbar_html']=$crum;
				}			
			}
			if (!$GLOBALS["TYPO3_CONF_VARS"]["tx_multishop_started"])
			{
				$GLOBALS["TYPO3_CONF_VARS"]["tx_multishop_started"]=1;
				if ((($post['products_id'] or $get['delete_products_id'] or $post['qty'] or $get['add_products_id']) and $get['tx_multishop_pi1']['page_section']=='shopping_cart') and !$GLOBALS['dont_update_cart']) mslib_fe::updateCart();			
				if ($get['categories_id']) 			$categories_id=$get['categories_id'];
				elseif ($product['categories_id']) 	$categories_id=$product['categories_id'];
				if ($categories_id) 						$GLOBALS["TYPO3_CONF_VARS"]['tx_multishop_data']['user_crumbar']=mslib_fe::Crumbar($categories_id);
			}
			// application top things that are only runned the first time when the plugin is initiated eof
			$meta_tags=array();
			if ($this->conf['includeCSS'])
			{
			$meta_tags['tx_multishop_pi1_more'] ='			
			<link rel="stylesheet" type="text/css" href="'.$this->FULL_HTTP_URL_MS.'js/'.$this->conf['highslide_folder'].'/highslide.css" media="screen" />
			';				
				$meta_tags['2_tx_multishop_pi1_css'] .='<link rel="stylesheet" type="text/css" href="'.$this->FULL_HTTP_URL_MS.'templates/global/css/core.css" media="screen" />'."\n";
				if ($this->conf['exampleCSS']) $meta_tags['tx_multishop_pi1_css'] .='<link rel="stylesheet" type="text/css" href="'.$this->FULL_HTTP_URL_MS.'templates/'.$this->conf['exampleCSS'].'/css/core.css" media="screen" />'."\n";
			}			
			if ($this->conf['includeJS'])
			{
				/*				<script type="text/javascript" src="'.$this->FULL_HTTP_URL_MS.'js/jquery-1.4.2.min.js"></script> */
				$meta_tags['1_jquery'] 	.='
				<script type="text/javascript" src="'.$this->FULL_HTTP_URL_MS.'js/jquery-1.6.3.min.js"></script>
				<script type="text/javascript" src="'.$this->FULL_HTTP_URL_MS.'js/jquery.cookie.js"></script>				
				<script type="text/javascript" src="'.$this->FULL_HTTP_URL_MS.'js/jquery.blockUI.js"></script>
				<link href="'.$this->FULL_HTTP_URL_MS.'js/jqui/css/smoothness/jquery-ui-1.8.custom.css" rel="stylesheet" type="text/css"/>
				<script src="'.$this->FULL_HTTP_URL_MS.'js/jqui/js/jquery-ui-1.8.custom.min.js"></script>					
				';
			}
			if ($this->conf['includejCarousel'])
			{
				$meta_tags['tx_multishop_pi1_jcarousel'] ='<script type="text/javascript" src="'.$this->FULL_HTTP_URL_MS.'js/jsor-jcarousel-0.2.4-0/lib/jquery.jcarousel.min.js"></script>';						
			}
			if ($ms['MODULES']['GOOGLE_ANALYTICS_ACCOUNT'])
			{
				$GLOBALS['TSFE']->additionalHeaderData[] ='
				<script type="text/javascript">
				
				  var _gaq = _gaq || [];
				  _gaq.push([\'_setAccount\', \''.$ms['MODULES']['GOOGLE_ANALYTICS_ACCOUNT'].'\']);
				  _gaq.push([\'_trackPageview\']);
				
				  (function() {
					var ga = document.createElement(\'script\'); ga.type = \'text/javascript\'; ga.async = true;
					ga.src = (\'https:\' == document.location.protocol ? \'https://ssl\' : \'http://www\') + \'.google-analytics.com/ga.js\';
					var s = document.getElementsByTagName(\'script\')[0]; s.parentNode.insertBefore(ga, s);
				  })();
				
				</script>	
				';
			}		
			if ($this->ADMIN_USER) 
			{
			 

			    if (strstr($this->conf['admin_template_folder'],"/"))
				{
					$path=$this->FULL_HTTP_URL.$this->conf['admin_template_folder'].'/css/admin.css';
				}
				else	$path=$this->FULL_HTTP_URL_MS.'templates/'.$this->conf['admin_template_folder'].'/css/admin.css';
				
                $meta_tags['tx_multishop_pi1_confirm'].='<link rel="stylesheet" type="text/css" href="'.$path.'" media="screen" />';	
                $meta_tags['tx_multishop_pi1_confirm'] 	.='<script type="text/javascript">
				function CONFIRM(label)
				{
								if (confirm(label))
								{
									return true;
								}
								else
								{
									return false;
								}
				}	
				</script>';	
                $meta_tags['tx_multishop_pi1_admin_menu']=mslib_fe::jQueryAdminMenu();
					
				//<link href="http://ajax.googleapis.com/ajax/libs/jqueryui/1.8/themes/base/jquery-ui.css" rel="stylesheet" type="text/css"/>
				
				
				
			}
			if (count($meta_tags)) $meta_tags['tx_multishop_pi1_more'] .='<script type="text/javascript">jQuery.noConflict();</script>';			
			if ($this->conf['includeJS'] or $this->conf['includeHighSlide'])
			{
//				if (!t3lib_extMgm::isLoaded('pw_highslide_gallery', 0))
//				{
							$meta_tags['tx_multishop_pi1_highslide'] ='
									<script type="text/javascript" src="'.$this->FULL_HTTP_URL_MS.'js/'.$this->conf['highslide_folder'].'/highslide-full.packed.js"></script>
									<script language="javascript" type="text/javascript">
									hs.cacheAjax = false;
									hs.allowMultipleInstances = false;									
									hs.loadingTitle = \'\';
									hs.focusTitle = \'\';
									hs.fullExpandTitle = \'\';
									hs.restoreTitle = \'\';
									hs.graphicsDir = \''.$this->FULL_HTTP_URL_MS.'js/'.$this->conf['highslide_folder'].'/graphics/\';
									hs.transitions = [\'expand\', \'\'];
									hs.outlineType = \'rounded-white\';
									hs.fadeInOut = false;
									hs.wrapperClassName = \'borderless\';
									hs.showCredits = false;
									hs.dimmingOpacity = 0.4;	
									if (hs.addSlideshow) hs.addSlideshow({
										interval: 5000,
										repeat: false,
										useControls: false,
										fixedControls: \'fit\',
										overlayOptions: {
											opacity: .75,
											position: \'bottom center\',
											hideOnMouseOut: false
										}
									});		
								';
switch ($this->lang)
{
	case 'nl':
	$meta_tags['tx_multishop_pi1_highslide'] .='
									hs.loadingText = \'Laden...\';
									hs.lang = {
									   loadingText :     \'Laden...\',
									   loadingTitle :    \'Klik om te annuleren\',
									   focusTitle :      \'Klik om naar voren te brengen\',
									   fullExpandTitle : \'Vergroot naar origineel\',
									   fullExpandText :  \'Volledige grootte\',
									   creditsText :     \'Powered bij <i>Highslide JS</i>\',
									   creditsTitle :    \'Ga naar de homepage van Highslide JS\',
									   previousText :    \'Vorige\',
									   previousTitle :   \'Vorige (linker pijl toets)\',
									   nextText :        \'Volgende\',
									   nextTitle :       \'Volgende (rechter pijl toets)\',
									   moveTitle :       \'Verplaats\',
									   moveText :        \'Verplaats\',
									   closeText :       \'Sluiten\',
									   closeTitle :      \'Sluiten (esc)\',
									   resizeTitle :     \'Verander grootte\',
									   playText :        \'Afspelen\',
									   playTitle :       \'Speel slidshow af (spatiebalk)\',
									   pauseText :       \'Pauze\',
									   pauseTitle :      \'Slideshow pauze (spatiebalk)\',
									   number :          \'Nummer %1 van %2\',									   
									   restoreTitle :    \'Klik om te sluiten, Klik en sleep om te verplaatsen. Gebruik pijltjes toetsen voor volgende vorige.\'
									};							
	';
	break;
	case 'no':
	$meta_tags['tx_multishop_pi1_highslide'] .='
									hs.loadingText = \'Lastar...\';	
									hs.lang = {
									   loadingText :     \'Lastar...\',
									   loadingTitle :    \'Klikk for å avbryte\',
									   focusTitle :      \'Klikk for å flytte fram\',
									   fullExpandText :  \'Full storleik\',
									   fullExpandTitle : \'Utvid til full storleik\',
									   creditsText :     \'Drive av <i>Highslide JS</i>\',
									   creditsTitle :    \'Gå til Highslide JS si heimeside\',
									   previousText :    \'Forrige\',
									   previousTitle :   \'Forrige (pil venstre)\',
									   nextText :        \'Neste\',
									   nextTitle :       \'Neste (pil høgre)\',
									   moveText :        \'Flytt\',
									   moveTitle :       \'Flytt\',
									   closeText :       \'Lukk\',
									   closeTitle :      \'Lukk (esc)\',
									   resizeTitle :     \'Endre storleik\',
									   playText :        \'Spel av\',
									   playTitle :       \'Vis biletserie (mellomrom)\',
									   pauseText :       \'Pause\',
									   pauseTitle :      \'Pause (mellomrom)\',  
									   number :          \'Bilete %1 av %2\',
									   restoreTitle :    \'Klikk for å lukke biletet, klikk og dra for å flytte. Bruk piltastane for forrige og neste.\'
									};						
	';
	break;	
	case 'fr':
	$meta_tags['tx_multishop_pi1_highslide'] .='
									hs.loadingText = \'Chargement...\';		
									hs.lang = { 
									   loadingText :     \'Chargement...\', 
									   loadingTitle :    \'Cliquer pour annuler\', 
									   focusTitle :      \'Cliquer pour amener au premier plan\', 
									   fullExpandTitle : \'Afficher à la taille réelle\', 
									   fullExpandText :  \'Taille réelle\', 
									   creditsText :     \'Développé sur <i>Highslide JS</i>\', 
									   creditsTitle :    \'Site Web de Highslide JS\', 
									   previousText :    \'Précédent\', 
									   previousTitle :   \'Précédent (flèche gauche)\', 
									   nextText :        \'Suivant\', 
									   nextTitle :       \'Suivant (flèche droite)\', 
									   moveTitle :       \'Déplacer\', 
									   moveText :        \'Déplacer\', 
									   closeText :       \'Fermer\', 
									   closeTitle :      \'Fermer (esc ou Echap)\', 
									   resizeTitle :     \'Redimensionner\', 
									   playText :        \'Lancer\', 
									   playTitle :       \'Lancer le diaporama (barre d\\\'espace)\', 
									   pauseText :       \'Pause\', 
									   pauseTitle :      \'Suspendre le diaporama (barre d\\\'espace)\',   
									   number :          \'Image %1 sur %2\',
									   restoreTitle :    \'Cliquer pour fermer l\\\'image, cliquer et faire glisser pour déplacer, utiliser les touches flèches droite et gauche pour suivant et précédent.\' 
									};			
	';
	break;	
	case 'es':
	$meta_tags['tx_multishop_pi1_highslide'] .='
									hs.loadingText = \'Cargando...\';			
									hs.lang = {
									   loadingText :     \'Cargando...\',
									   loadingTitle :    \'Click para cancelar\',
									   focusTitle :      \'Click para traer al frente\',
									   fullExpandTitle : \'Expandir al tamaño actual\',
									   fullExpandText :  \'Tamaño real\',
									   creditsText :     \'Potenciado por <i>Highslide JS</i>\',
									   creditsTitle :    \'Ir al home de Highslide JS\',
									   previousText :    \'Anterior\',
									   previousTitle :   \'Anterior (flecha izquierda)\',
									   nextText :        \'Siguiente\',
									   nextTitle :       \'Siguiente (flecha derecha)\',
									   moveTitle :       \'Mover\',
									   moveText :        \'Mover\',
									   closeText :       \'Cerrar\',
									   closeTitle :      \'Cerrar (esc)\',
									   resizeTitle :     \'Redimensionar\',
									   playText :        \'Iniciar\',
									   playTitle :       \'Iniciar slideshow (barra espacio)\',
									   pauseText :       \'Pausar\',
									   pauseTitle :      \'Pausar slideshow (barra espacio)\',
									   restoreTitle :    \'Click para cerrar la imagen, click y arrastrar para mover. Usa las flechas del teclado para avanzar o retroceder.\'
									};	
	';
	break;	
	case 'de':
	$meta_tags['tx_multishop_pi1_highslide'] .='
									hs.loadingText = \'Lade...\';				
									hs.lang = {
									   loadingText :     \'Lade...\',
									   loadingTitle :    \'Klick zum Abbrechen\',
									   focusTitle :      \'Klick um nach vorn zu bringen\',
									   fullExpandTitle : \'Zur Originalgröße erweitern\',
									   fullExpandText :  \'Vollbild\',
									   creditsText :     \'Powered by <i>Highslide JS</i>\',
									   creditsTitle :    \'Gehe zur Highslide JS Homepage\',
									   previousText :    \'Voriges\',
									   previousTitle :   \'Voriges (Pfeiltaste links)\',
									   nextText :        \'Nächstes\',
									   nextTitle :       \'Nächstes (Pfeiltaste rechts)\',
									   moveTitle :       \'Verschieben\',
									   moveText :        \'Verschieben\',
									   closeText :       \'Schließen\',
									   closeTitle :      \'Schließen (Esc)\',
									   resizeTitle :     \'Größe wiederherstellen\',
									   playText :        \'Abspielen\',
									   playTitle :       \'Slideshow abspielen (Leertaste)\',
									   pauseText :       \'Pause\',
									   pauseTitle :      \'Pausiere Slideshow (Leertaste)\',
									   restoreTitle :    \'Klick um das Bild zu schließen, klick und ziehe um zu verschieben. Benutze Pfeiltasten für vor und zurück.\'
									};
	';
	break;	
	case 'dn':
	$meta_tags['tx_multishop_pi1_highslide'] .='
									hs.loadingText = \'Henter...\';					
									hs.lang = { 
									   loadingText :     \'Henter...\', 
									   loadingTitle :    \'Klik for at stoppe\', 
									   focusTitle :      \'Klik for at bringe først på skærm\', 
									   fullExpandTitle : \'Vis i original størrelse\', 
									   fullExpandText :  \'Fuld størrelse\', 
									   creditsText :     \'Vist med  <i>Highslide JS</i>\', 
									   creditsTitle :    \'Gå til  Highslide JS\'s hjemmeside\', 
									   previousText :    \'Forrige\', 
									   previousTitle :   \'forrige (arrow left)\', 
									   nextText :        \'Næste\', 
									   nextTitle :       \'Næste (arrow right)\', 
									   moveTitle :       \'Flyt\', 
									   moveText :        \'Flyt\', 
									   closeText :       \'Luk\', 
									   closeTitle :      \'Luk (esc)\', 
									   resizeTitle :     \'Ændre størrelse\', 
									   playText :        \'Start\', 
									   playTitle :       \'Start slideshow (spacebar)\', 
									   pauseText :       \'Pause\', 
									   pauseTitle :      \'Pause slideshow (spacebar)\', 
									   restoreTitle :    \'Klik for at lukke billed, klik og træk for at flytte. Brug piletaster for at skifte forrige og næste billed.\' 
									};
	';
	break;		
	case 'it':
	$meta_tags['tx_multishop_pi1_highslide'] .='
									hs.loadingText = \'Caricamento in corso...\';						
									hs.lang = {
									  loadingText :     \'Caricamento in corso\',
									  loadingTitle :    \'Fare clic per annullare\',
									  focusTitle :      \'Fare clic per portare in avanti\',
									  fullExpandTitle : \'Visualizza dimensioni originali\',
									  fullExpandText :  \'Dimensione massima\',
									  creditsText :     \'Powered by <i>Highslide JS</i>\',
									  creditsTitle :    \'Vai al sito Web di Highslide JS\',
									  previousText :    \'Precedente\',
									  previousTitle :   \'Precedente (freccia sinistra)\',
									  nextText :        \'Successiva\',
									  nextTitle :       \'Successiva (freccia destra)\',
									  moveTitle :       \'Sposta\',
									  moveText :        \'Sposta\',
									  closeText :       \'Chiudi\',
									  closeTitle :      \'Chiudi (Esc)\',
									  resizeTitle :     \'Ridimensiona\',
									  playText :        \'Avvia\',
									  playTitle :       \'Avvia slideshow (barra spaziatrice)\',
									  pauseText :       \'Pausa\',
									  pauseTitle :      \'Pausa slideshow (barra spaziatrice)\',
									  restoreTitle :    \'Fare clic per chiudere l\\\'immagine, trascina per spostare. Frecce andare avanti e indietro.\'
									};
	';
	break;	
	default:
	break;
}
$meta_tags['tx_multishop_pi1_highslide'] .='
									</script>
							';	
//				}
			}	
			if (!$this->ajax_content)
			{
				ksort($meta_tags);
				$meta_tags_html='';
				foreach ($meta_tags as $item)
				{
					$meta_tags_html.=$item;
				}
				// the reason why we have to return the header tags as content is because this section is already mapped to the head tag
				// if we put it in additionalHeaderData the page.headerData order is ignored and it can give annoying conflicts
				return mslib_fe::processmeta($meta_tags_html);
			}
			break;
			case 'basket':
			$this->box_class="multishop_basket";
			$this->cObj->data['header']='<a href="'.mslib_fe::typolink($this->conf['shoppingcart_page_pid'],'&tx_multishop_pi1[page_section]=shopping_cart').'">'.$this->pi_getLL('basket').'</a>';
			$cart = $GLOBALS['TSFE']->fe_user->getKey('ses', 'tx_multishop_cart');
			$totalitems=0;
			if (count($cart['products']) >0)
			{
				foreach ($cart['products'] as $product)
				{
					if (is_numeric($product['qty'])) $totalitems=$totalitems+$product['qty'];
				}
			}
			$content.='<div class="multishop_basketbox">';	
			$content.=(($totalitems==1)?sprintf($this->pi_getLL('you_have_item_in_your_cart'),$totalitems):sprintf($this->pi_getLL('you_have_items_in_your_cart'),$totalitems)).'.';
			if ($totalitems > 0) $content.=' <a class="multishop_goto_checkout" href="'.mslib_fe::typolink($this->shop_pid,'&tx_multishop_pi1[page_section]=checkout').'">'.$this->pi_getLL('proceed_to_checkout').'</a>';
			$content.='</div>';
			/*
			<a href="'.mslib_fe::typolink($this->shop_pid,'&tx_multishop_pi1[page_section]=shopping_cart').'"> See all Products </a>
			*/
			$content .= '
				<div id="basketWrap">
					<div id="basketTitleWrap">
						<span id="notificationsLoader"></span>
					</div>
					<div id="basketItemsWrap">
						<ul>
						<li></li>
						</ul>
					</div>
				</div>';			
			break;
			case 'manufacturers':
			$str="SELECT m.manufacturers_id, m.manufacturers_name from tx_multishop_manufacturers m, tx_multishop_manufacturers_info mi where m.status=1 and language_id='".$this->sys_language_uid."' and m.manufacturers_id=mi.manufacturers_id order by m.sort_order";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			$manufacturers=array();	
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				$manufacturers[]=$row;
			}
			if (count($manufacturers) > 0)
			{
				$this->cObj->data['header']=$this->pi_getLL('manufacturers');
				$content.='<div id="multishop_manufacturersbox_'.$this->cObj->data['uid'].'">
					<ul id="manufacturers_sortable_'.$this->cObj->data['uid'].'">';
				foreach ($manufacturers as $row)
				{
					$link=mslib_fe::typolink($this->conf['search_page_pid'],'&tx_multishop_pi1[page_section]=manufacturers_products_listing&manufacturers_id='.$row['manufacturers_id']);				
					$content.='<li ';
					if ($this->ADMIN_USER) $content.='id="sortable_manufacturer_'.$row['manufacturers_id'].'" ';
					$content.=(($row['manufacturers_id']==$get['manufacturers_id'])?'class="active"':'').'><a href="'.$link.'">'.htmlspecialchars($row['manufacturers_name']).'</a>';					
				}
				$content.='</ul>
				</div>
				';
			}
			break;
			case 'categories':				
			$this->cObj->data['header']=$this->pi_getLL('catalog');
			$this->box_class="multishop_catalog_box";
			$this->maxDEPTH=$this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'maxDEPTH', 's_listing');
			$this->showHeader=$this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showHeader', 's_listing');
			$this->showifsub=$this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'showIfsub', 's_listing');			
			if ($ms['MODULES']['CACHE_FRONT_END'] and !$ms['MODULES']['CACHE_TIME_OUT_CATEGORIES_NAVIGATION_MENU']) $ms['MODULES']['CACHE_FRONT_END']=0;
			if ($ms['MODULES']['CACHE_FRONT_END'])
			{
				$options = array(
					'caching' => true,
					'cacheDir' => PATH_site.'uploads/tx_multishop/tmp/cache/',
					'lifeTime' => $ms['MODULES']['CACHE_TIME_OUT_CATEGORIES_NAVIGATION_MENU']
				);
				$Cache_Lite = new Cache_Lite($options);
				if ($GLOBALS['TSFE']->fe_user->user['uid'])
				{
					$prefix='1';									
				}
				else $prefix='';
				$string=$prefix.'_'.serialize($GLOBALS["TYPO3_CONF_VARS"]['tx_multishop_data']['user_crumbar']).$this->cObj->data['uid'];				
			}
			if (!$ms['MODULES']['CACHE_FRONT_END'] or !$content=$Cache_Lite->get($string))
			{
				
				$ms['add_this_button']='';	
				if ($ms['MODULES']['ADDTHIS_ACCOUNT'])
				{
				$ms['add_this_button']='					
				<!-- AddThis Button BEGIN -->
				<script type="text/javascript">var addthis_pub = "'.$ms['MODULES']['ADDTHIS_ACCOUNT'].'";</script>
				<a rel="nofollow" href="http://www.addthis.com/bookmark.php" onmouseover="return addthis_open(this, \'\', \''.$this->FULL_HTTP_URL.'\', \''.$GLOBALS['TSFE']->tmpl->sitetitle.'\')" onmouseout="addthis_close()" onclick="return addthis_sendto()"><img src="http://s7.addthis.com/static/btn/lg-bookmark-en.gif" width="125" height="16" border="0" alt="" /></a><script type="text/javascript" src="http://s7.addthis.com/js/152/addthis_widget.js"></script>
				<!-- AddThis Button END -->			
				';
				}
				if ($this->showifsub)
				{
// new
					if (is_numeric($get['categories_id']) and $ms['MODULES']['ACCORDION_MENU'])
					{
						$GLOBALS['TSFE']->additionalHeaderData[] = '
						<script type="text/javascript" src="'.$this->FULL_HTTP_URL_MS.'js/prototype/prototype.js"></script>
						<script type="text/javascript" src="'.$this->FULL_HTTP_URL_MS.'js/prototype/effects.js"></script>
						<script type="text/javascript" src="'.$this->FULL_HTTP_URL_MS.'js/prototype/accordion.js"></script>
						';
						$user_crumbar=$GLOBALS["TYPO3_CONF_VARS"]['tx_multishop_data']['user_crumbar'];
						if(is_array($user_crumbar) and count($user_crumbar))
						{
							$user_crumbar=array_reverse($user_crumbar);
						}
						$catlist=mslib_fe::getSubcatsOnly($get['categories_id']);
						
						if (count($catlist) >0)
						{
							
							$content.='<div id="multishop_catbox_'.$this->cObj->data['uid'].'">
								<ul id="vertical_container">';
							$item_counter=0;
							$item_counter_accordion=0;
							foreach ($catlist as $cat)
							{
								$item_counter++;
								
								// level 0
								// get all cats to generate multilevel fake url
								$nested_level=0;					
								$level=0;
								$cats=mslib_fe::Crumbar($cat['categories_id']);				
								$cats=array_reverse($cats);
								$where='';
								if (count($cats) > 0)
								{
									foreach ($cats as $item)
									{
										$where.="categories_id[".$level."]=".$item['id']."&";
										$level++;
									}
									$where=substr($where,0,(strlen($where)-1));
									$where.='&';
								}
								// get all cats to generate multilevel fake url eof					
								$link=mslib_fe::typolink($this->shop_pid,'&'.$where.'&tx_multishop_pi1[page_section]=products_listing');
								$actifsub=0;
								$act=0;
								if ($user_crumbar[$nested_level]['id'] == $cat['categories_id'])
								{
									if ($user_crumbar[($nested_level+1)])
									{
										$actifsub=1;
									}
									else
									{
										$act=1;
									}
								}
								$categories_name=htmlspecialchars($cat['categories_name']);					
								$content.='<li ';
								$class='';
								$class_h2 ='';
								
								
								$catlist2=mslib_fe::getSubcatsOnly($cat['categories_id']);
								if (count($catlist2) > 0){
									$class_h2 ='accordion_toggle';
									$num = $item_counter_accordion;
									
								} else {
									$class_h2 = "accordion_not_active";
								}
								
								
								if ($this->ADMIN_USER)  $content.='id="sortable_maincat_'.$cat['categories_id'].'" ';
								else 					$class.='item_'.$item_counter.' ';
								if ($actifsub or $act)  {
									$class.='active ';
									if (count($catlist2) > 0){
										$active_accordion = 'bottomAccordion.activate($$("#vertical_container .accordion_toggle")['.$num.']);';
									}
									
								} 
								if ($class_h2 =='accordion_toggle '){
									$item_counter_accordion++;
								}
								
								if ($ms['MODULES']['ACCORDION_MENU']){
										$GLOBALS['TSFE']->additionalHeaderData['accordion'] = '
								<script type="text/javascript">
									Event.observe(window, "load", loadAccordions, false);
									function loadAccordions() {
										var bottomAccordion = new accordion("vertical_container");									
										'. $active_accordion .'
									}
								</script>
								';
								
								}
							
								$content.=(($class)?'class="'.trim($class).'"':'').'><h2 class="'. $class_h2 .'"><a href="'.$link.'" class="ajax_link">'.$categories_name.'</a></h2>';
								// level 0 eof
								if ($this->maxDEPTH > $nested_level)
								{
									
									if (count($catlist2) > 0)
									{
										// level 1
										$content.='<ul class="accordion_content">';
										foreach ($catlist2 as $cat)
										{					
											$nested_level=1;
											// get all cats to generate multilevel fake url
											$level=0;
											$cats=mslib_fe::Crumbar($cat['categories_id']);				
											$cats=array_reverse($cats);
											$where='';
											if (count($cats) > 0)
											{
												foreach ($cats as $item)
												{
													$where.="categories_id[".$level."]=".$item['id']."&";
													$level++;
												}
												$where=substr($where,0,(strlen($where)-1));
												$where.='&';
											}
											// get all cats to generate multilevel fake url eof					
											$link=mslib_fe::typolink($this->shop_pid,'&'.$where.'&tx_multishop_pi1[page_section]=products_listing');
											$actifsub=0;
											$act=0;
											if ($user_crumbar[$nested_level]['id'] == $cat['categories_id'])
											{
												if ($user_crumbar[($nested_level+1)])
												{
													$categories_name=htmlspecialchars($cat['categories_name']);					
													$actifsub=1;
												}
												else
												{
													$categories_name=htmlspecialchars($cat['categories_name']);										
													$act=1;
												}
											}
											else
											{
												$categories_name=htmlspecialchars($cat['categories_name']);					
											}
											
											$catlist3=mslib_fe::getSubcatsOnly($cat['categories_id']);
											//level submenu 2 start
											
											if (count($catlist3) > 0){
												
												$content .= '<ul id="sub_container">
																<li><h2 class="sub_accordion_toggle"><a href="'.$link.'" class="ajax_link">'.$categories_name.'</a></h2>
																	<ul class="sub_accordion_content">';
												$cat_level_3 = "";
												foreach ($catlist3 as $cat)
												{
													$nested_level=1;
													// get all cats to generate multilevel fake url
													$level=0;
													$cats=mslib_fe::Crumbar($cat['categories_id']);				
													$cats=array_reverse($cats);
													$where='';
													if (count($cats) > 0)
													{
														foreach ($cats as $item)
														{
															$where.="categories_id[".$level."]=".$item['id']."&";
															$level++;
														}
														$where=substr($where,0,(strlen($where)-1));
														$where.='&';
													}
													// get all cats to generate multilevel fake url eof					
													$link=mslib_fe::typolink($this->shop_pid,'&'.$where.'&tx_multishop_pi1[page_section]=products_listing');
													$actifsub=0;
													$act=0;
													if ($user_crumbar[$nested_level]['id'] == $cat['categories_id'])
													{
														if ($user_crumbar[($nested_level+1)])
														{
															$categories_name=htmlspecialchars($cat['categories_name']);					
															$actifsub=1;
														}
														else
														{
															$categories_name=htmlspecialchars($cat['categories_name']);										
															$act=1;
														}
													}
													else
													{
														$categories_name=htmlspecialchars($cat['categories_name']);					
													}
													$cat_level_3 .= '<li><a href="'.$link.'" class="ajax_link">'.$categories_name.'</a></li>';
												}
													$content .= $cat_level_3 .'</ul></li></ul>';
												
											} else {
												$content.='<li '.(($actifsub or $act)?'class="subactive"':'').'><a href="'.$link.'" class="ajax_link">'.$categories_name.'</a>';
											}
											//level submenu 2 eof
											$content.='</li>';
										}
										$content.='</ul>';		
										// level 1 eof
									}
								}
								$content.='</li>';
							}
							$content.='</ul></div>     
								   
							';
							if ($this->ADMIN_USER)
							{
								$content.='					
								<script>
								  jQuery(document).ready(function() {
									var result = jQuery("#vertical_container").sortable({
									 cursor:     "move", 
										//axis:       "y", 
										update: function(e, ui) { 
											href = "'.mslib_fe::typolink(',2002','&tx_multishop_pi1[page_section]=menu').'"; 
											jQuery(this).sortable("refresh"); 
											sorted = jQuery(this).sortable("serialize", "id"); 
											jQuery.ajax({ 
													type:   "POST", 
													url:    href, 
													data:   sorted, 
													success: function(msg) { 
															//do something with the sorted data 
													} 
											}); 
										} 
									});
								  });
								  </script>					
								';
							}				
						}	
					}
					elseif (is_numeric($get['categories_id']))
					{
						$user_crumbar=$GLOBALS["TYPO3_CONF_VARS"]['tx_multishop_data']['user_crumbar'];
						if(is_array($user_crumbar) and count($user_crumbar))
						{
							$user_crumbar=array_reverse($user_crumbar);
						}						
						$nested_level=0;
						$catlist=mslib_fe::getSubcatsOnly($user_crumbar[$nested_level]['id']);
						if (!count($catlist))
						{
							$this->no_database_results=1;
						}
						else
						{
							$content.='<div id="multishop_catbox_'.$this->cObj->data['uid'].'">
								<ul id="catalog_sortable_'.$this->cObj->data['uid'].'">';
							foreach ($catlist as $cat)
							{
								// level 0
								// get all cats to generate multilevel fake url
								$nested_level=1;					
								$level=0;
								$cats=mslib_fe::Crumbar($cat['categories_id']);				
								$cats=array_reverse($cats);
								$where='';
								if (count($cats) > 0)
								{
									foreach ($cats as $item)
									{
										$where.="categories_id[".$level."]=".$item['id']."&";
										$level++;
									}
									$where=substr($where,0,(strlen($where)-1));
									$where.='&';
								}
								// get all cats to generate multilevel fake url eof					
								$link=mslib_fe::typolink($this->shop_pid,'&'.$where.'&tx_multishop_pi1[page_section]=products_listing');
								$actifsub=0;
								$act=0;
								if ($user_crumbar[$nested_level]['id'] == $cat['categories_id'])
								{
									if ($user_crumbar[($nested_level+1)])
									{
										$actifsub=1;
									}
									else
									{
										$act=1;
									}
								}
								$categories_name=htmlspecialchars($cat['categories_name']);					
								$content.='<li ';
								if ($this->ADMIN_USER) $content.='id="sortable_maincat_'.$cat['categories_id'].'" ';
								$content.=(($actifsub or $act)?'class="active"':'').'><a href="'.$link.'" class="ajax_link">'.$categories_name.'</a>';
								// level 0 eof
								if ($this->maxDEPTH > $nested_level or ($actifsub or $act))
								{							
									$catlist2=mslib_fe::getSubcatsOnly($cat['categories_id']);
									if (count($catlist2) > 0)
									{
										// level 1
										$content.='<ul>';
										foreach ($catlist2 as $cat)
										{					
											$nested_level=2;
											// get all cats to generate multilevel fake url
											$level=0;
											$cats=mslib_fe::Crumbar($cat['categories_id']);				
											$cats=array_reverse($cats);
											$where='';
											if (count($cats) > 0)
											{
												foreach ($cats as $item)
												{
													$where.="categories_id[".$level."]=".$item['id']."&";
													$level++;
												}
												$where=substr($where,0,(strlen($where)-1));
												$where.='&';
											}
											// get all cats to generate multilevel fake url eof					
											$link=mslib_fe::typolink($this->shop_pid,'&'.$where.'&tx_multishop_pi1[page_section]=products_listing');
											$actifsub=0;
											$act=0;
											if ($user_crumbar[$nested_level]['id'] == $cat['categories_id'])
											{
												if ($user_crumbar[($nested_level+1)])
												{
													$categories_name=htmlspecialchars($cat['categories_name']);					
													$actifsub=1;
												}
												else
												{
													$categories_name=htmlspecialchars($cat['categories_name']);										
													$act=1;
												}
											}
											else
											{
												$categories_name=htmlspecialchars($cat['categories_name']);					
											}
											if ($get['categories_id'] == $cat['categories_id']){
												
											}
											$content.='<li '.(($actifsub or $act)?'class="subactive"':'').'><a href="'.$link.'" class="ajax_link">'.$categories_name.'</a>';
											$content.='</li>';
										}
										$content.='</ul>';		
										// level 1 eof
									}
								}
								$content.='</li>';
							}
							$content.='</ul></div>';
							if ($this->ADMIN_USER)
							{
								$content.='					
								<script>
								  jQuery(document).ready(function() {
									var result = jQuery("#catalog_sortable_'.$this->cObj->data['uid'].'").sortable({
									 cursor:     "move", 
										//axis:       "y", 
										update: function(e, ui) { 
											href = "'.mslib_fe::typolink(',2002','&tx_multishop_pi1[page_section]=menu').'"; 
											jQuery(this).sortable("refresh"); 
											sorted = jQuery(this).sortable("serialize", "id"); 
											jQuery.ajax({ 
													type:   "POST", 
													url:    href, 
													data:   sorted, 
													success: function(msg) { 
															//do something with the sorted data 
													} 
											}); 
										} 
									});
								  });
								  </script>					
								';
							}				
						}
					}
					else
					{
						$this->no_database_results=1;					
					}
				}
				else
				{					
					if ($ms['MODULES']['ACCORDION_MENU'])
					{
						$GLOBALS['TSFE']->additionalHeaderData[] = '
						<script type="text/javascript" src="'.$this->FULL_HTTP_URL_MS.'js/prototype/prototype.js"></script>
						<script type="text/javascript" src="'.$this->FULL_HTTP_URL_MS.'js/prototype/effects.js"></script>
						<script type="text/javascript" src="'.$this->FULL_HTTP_URL_MS.'js/prototype/accordion.js"></script>
						';
						$user_crumbar=$GLOBALS["TYPO3_CONF_VARS"]['tx_multishop_data']['user_crumbar'];
						if(is_array($user_crumbar) and count($user_crumbar))
						{
							$user_crumbar=array_reverse($user_crumbar);
						}
						$catlist=mslib_fe::getSubcatsOnly($this->categoriesStartingPoint);
						
						if (count($catlist) >0)
						{
							
							$content.='<div id="multishop_catbox_'.$this->cObj->data['uid'].'">
								<ul id="vertical_container">';
							$item_counter=0;
							$item_counter_accordion=0;
							foreach ($catlist as $cat)
							{
								$item_counter++;
								
								// level 0
								// get all cats to generate multilevel fake url
								$nested_level=0;					
								$level=0;
								$cats=mslib_fe::Crumbar($cat['categories_id']);				
								$cats=array_reverse($cats);
								$where='';
								if (count($cats) > 0)
								{
									foreach ($cats as $item)
									{
										$where.="categories_id[".$level."]=".$item['id']."&";
										$level++;
									}
									$where=substr($where,0,(strlen($where)-1));
									$where.='&';
								}
								// get all cats to generate multilevel fake url eof					
								$link=mslib_fe::typolink($this->shop_pid,'&'.$where.'&tx_multishop_pi1[page_section]=products_listing');
								$actifsub=0;
								$act=0;
								if ($user_crumbar[$nested_level]['id'] == $cat['categories_id'])
								{
									if ($user_crumbar[($nested_level+1)])
									{
										$actifsub=1;
									}
									else
									{
										$act=1;
									}
								}
								$categories_name=htmlspecialchars($cat['categories_name']);					
								$content.='<li ';
								$class='';
								$class_h2 ='';
								
								
								$catlist2=mslib_fe::getSubcatsOnly($cat['categories_id']);
								if (count($catlist2) > 0){
									$class_h2 ='accordion_toggle';
									$num = $item_counter_accordion;
									
								} else {
									$class_h2 = "accordion_not_active";
								}
								
								
								if ($this->ADMIN_USER)  $content.='id="sortable_maincat_'.$cat['categories_id'].'" ';
								else 					$class.='item_'.$item_counter.' ';
								if ($actifsub or $act)  {
									$class.='active ';
									if (count($catlist2) > 0){
										$active_accordion = 'bottomAccordion.activate($$("#vertical_container .accordion_toggle")['.$num.']);';
									}
									
								} 
								if ($class_h2 =='accordion_toggle '){
									$item_counter_accordion++;
								}
								
								if ($ms['MODULES']['ACCORDION_MENU']){
										$GLOBALS['TSFE']->additionalHeaderData['accordion'] = '
								<script type="text/javascript">
									Event.observe(window, "load", loadAccordions, false);
									function loadAccordions() {
										var bottomAccordion = new accordion("vertical_container");									
										'. $active_accordion .'
									}
								</script>
								';
								
								}
							
								$content.=(($class)?'class="'.trim($class).'"':'').'><h2 class="'. $class_h2 .'"><a href="'.$link.'" class="ajax_link">'.$categories_name.'</a></h2>';
								// level 0 eof
								if ($this->maxDEPTH > $nested_level)
								{
									
									if (count($catlist2) > 0)
									{
										// level 1
										$content.='<ul class="accordion_content">';
										foreach ($catlist2 as $cat)
										{					
											$nested_level=1;
											// get all cats to generate multilevel fake url
											$level=0;
											$cats=mslib_fe::Crumbar($cat['categories_id']);				
											$cats=array_reverse($cats);
											$where='';
											if (count($cats) > 0)
											{
												foreach ($cats as $item)
												{
													$where.="categories_id[".$level."]=".$item['id']."&";
													$level++;
												}
												$where=substr($where,0,(strlen($where)-1));
												$where.='&';
											}
											// get all cats to generate multilevel fake url eof					
											$link=mslib_fe::typolink($this->shop_pid,'&'.$where.'&tx_multishop_pi1[page_section]=products_listing');
											$actifsub=0;
											$act=0;
											if ($user_crumbar[$nested_level]['id'] == $cat['categories_id'])
											{
												if ($user_crumbar[($nested_level+1)])
												{
													$categories_name=htmlspecialchars($cat['categories_name']);					
													$actifsub=1;
												}
												else
												{
													$categories_name=htmlspecialchars($cat['categories_name']);										
													$act=1;
												}
											}
											else
											{
												$categories_name=htmlspecialchars($cat['categories_name']);					
											}
											
											$catlist3=mslib_fe::getSubcatsOnly($cat['categories_id']);
											//level submenu 2 start
											
											if (count($catlist3) > 0){
												
												$content .= '<ul id="sub_container">
																<li><h2 class="sub_accordion_toggle"><a href="'.$link.'" class="ajax_link">'.$categories_name.'</a></h2>
																	<ul class="sub_accordion_content">';
												$cat_level_3 = "";
												foreach ($catlist3 as $cat)
												{
													$nested_level=1;
													// get all cats to generate multilevel fake url
													$level=0;
													$cats=mslib_fe::Crumbar($cat['categories_id']);				
													$cats=array_reverse($cats);
													$where='';
													if (count($cats) > 0)
													{
														foreach ($cats as $item)
														{
															$where.="categories_id[".$level."]=".$item['id']."&";
															$level++;
														}
														$where=substr($where,0,(strlen($where)-1));
														$where.='&';
													}
													// get all cats to generate multilevel fake url eof					
													$link=mslib_fe::typolink($this->shop_pid,'&'.$where.'&tx_multishop_pi1[page_section]=products_listing');
													$actifsub=0;
													$act=0;
													if ($user_crumbar[$nested_level]['id'] == $cat['categories_id'])
													{
														if ($user_crumbar[($nested_level+1)])
														{
															$categories_name=htmlspecialchars($cat['categories_name']);					
															$actifsub=1;
														}
														else
														{
															$categories_name=htmlspecialchars($cat['categories_name']);										
															$act=1;
														}
													}
													else
													{
														$categories_name=htmlspecialchars($cat['categories_name']);					
													}
													$cat_level_3 .= '<li><a href="'.$link.'" class="ajax_link">'.$categories_name.'</a></li>';
												}
													$content .= $cat_level_3 .'</ul></li></ul>';
												
											} else {
												$content.='<li '.(($actifsub or $act)?'class="subactive"':'').'><a href="'.$link.'" class="ajax_link">'.$categories_name.'</a>';
											}
											//level submenu 2 eof
											$content.='</li>';
										}
										$content.='</ul>';		
										// level 1 eof
									}
								}
								$content.='</li>';
							}
							$content.='</ul></div>     
								   
							';
							if ($this->ADMIN_USER)
							{
								$content.='					
								<script>
								  jQuery(document).ready(function() {
									var result = jQuery("#vertical_container").sortable({
									 cursor:     "move", 
										//axis:       "y", 
										update: function(e, ui) { 
											href = "'.mslib_fe::typolink(',2002','&tx_multishop_pi1[page_section]=menu').'"; 
											jQuery(this).sortable("refresh"); 
											sorted = jQuery(this).sortable("serialize", "id"); 
											jQuery.ajax({ 
													type:   "POST", 
													url:    href, 
													data:   sorted, 
													success: function(msg) { 
															//do something with the sorted data 
													} 
											}); 
										} 
									});
								  });
								  </script>					
								';
							}				
						}	
					}
					elseif ($this->maxDELIMITED)
					{
						$delimited_array=explode(",",$this->maxDELIMITED);						
						if (count($delimited_array) > 0)
						{
							// multi row tabnavigation menu
							$user_crumbar=$GLOBALS["TYPO3_CONF_VARS"]['tx_multishop_data']['user_crumbar'];
							if(is_array($user_crumbar) and count($user_crumbar))
							{
								$user_crumbar=array_reverse($user_crumbar);
							}
							$catlist=mslib_fe::getSubcatsOnly($this->categoriesStartingPoint);
							if (count($catlist) >0)
							{
								$item_counter=0;
								$item_counter_accordion=0;
								foreach ($catlist as $cat)
								{
									$tmpcontent='';								
									$item_counter++;
									// level 0
									// get all cats to generate multilevel fake url
									$nested_level=0;					
									$level=0;
									$cats=mslib_fe::Crumbar($cat['categories_id']);				
									$cats=array_reverse($cats);
									$where='';
									if (count($cats) > 0)
									{
										foreach ($cats as $item)
										{
											$where.="categories_id[".$level."]=".$item['id']."&";
											$level++;
										}
										$where=substr($where,0,(strlen($where)-1));
										$where.='&';
									}
									// get all cats to generate multilevel fake url eof					
									$link=mslib_fe::typolink($this->shop_pid,'&'.$where.'&tx_multishop_pi1[page_section]=products_listing');
									$actifsub=0;
									$act=0;
									if ($user_crumbar[$nested_level]['id'] == $cat['categories_id'])
									{
										if ($user_crumbar[($nested_level+1)])
										{
											$actifsub=1;
										}
										else
										{
											$act=1;
										}
									}
									$categories_name=htmlspecialchars($cat['categories_name']);					
									$tmpcontent.='<li ';
									$class='';
									$class_h2 ='';
									$catlist2=mslib_fe::getSubcatsOnly($cat['categories_id']);
									if (count($catlist2) > 0){
										$class_h2 ='main';
										$num = $item_counter_accordion;
										
									} else {
										$class_h2 = "main";
									}
									if ($this->ADMIN_USER)  $tmpcontent.='id="sortable_maincat_'.$cat['categories_id'].'"';
									else 					$class.='item_'.$item_counter.' ';
									if ($actifsub or $act)  {
										$class.='active ';
										if (count($catlist2) > 0){
											$active_accordion = 'bottomAccordion.activate($$("#vertical_container .accordion_toggle")['.$num.']);';
										}				
									} 
									$label='';
									$tmpcontent.=(($class)?' class="'.trim($class).'"':'').'><a href="'.$link.'" class="ajax_link">'.$label.''.$categories_name.'</a>';
									// level 0 eof
									$tmpcontent.='</li>';
									$items[]=$tmpcontent;
	
								}
								$content.='<div id="multishop_catbox_'.$this->cObj->data['uid'].'">
									';							
								$del_num=0;
								$real_num=0;
								foreach ($delimited_array as $delimited)
								{
									$del_num++;
									$content.='<div id="tabbertopnav_row_'.$del_num.'">
									<table cellpadding="0" cellspacing="0" border="0">
									<tr>
									<td>									
									<ul class="tabberttopnav_row">'."\n";
									for ($i=0;$i<$delimited;$i++)
									{
										$content.=$items[$real_num]."\n";
										$real_num++;
									}
									$content.='
									</ul>
									</td>
									</tr>
									</table>
								
									</div>'."\n";
								}
								$content.='</div>'."\n";	
							}
							// multi row tabnavigation menu eof
						}
					}
					else
					{
					// show default categories box
						$user_crumbar=$GLOBALS["TYPO3_CONF_VARS"]['tx_multishop_data']['user_crumbar'];
						if (count($user_crumbar))
						{
							$user_crumbar=array_reverse($user_crumbar);
						}
						$catlist=mslib_fe::getSubcatsOnly($this->categoriesStartingPoint);					
						if (count($catlist) >0)
						{
							$content.='<div id="multishop_catbox_'.$this->cObj->data['uid'].'">
								<ul id="vertical_container">';
							$item_counter=0;
							$item_counter_accordion=0;
							foreach ($catlist as $cat)
							{
								$item_counter++;
								// level 0
								// get all cats to generate multilevel fake url
								$nested_level=0;					
								$level=0;
								$cats=mslib_fe::Crumbar($cat['categories_id']);				
								$cats=array_reverse($cats);
								$where='';
								if (count($cats) > 0)
								{
									foreach ($cats as $item)
									{
										$where.="categories_id[".$level."]=".$item['id']."&";
										$level++;
									}
									$where=substr($where,0,(strlen($where)-1));
									$where.='&';
								}
								// get all cats to generate multilevel fake url eof					
								$link=mslib_fe::typolink($this->shop_pid,'&'.$where.'&tx_multishop_pi1[page_section]=products_listing');
								$actifsub=0;
								$act=0;
								if ($user_crumbar[$nested_level]['id'] == $cat['categories_id'])
								{
									if ($user_crumbar[($nested_level+1)])
									{
										$actifsub=1;
									}
									else
									{
										$act=1;
									}
								}
								$categories_name=htmlspecialchars($cat['categories_name']);					
								$content.='<li ';
								$class='';
								$class_h2 ='';
								$catlist2=mslib_fe::getSubcatsOnly($cat['categories_id']);
								if (count($catlist2) > 0){
									$class_h2 ='main';
									$num = $item_counter_accordion;
									
								} else {
									$class_h2 = "main";
								}
								if ($this->ADMIN_USER)  $content.='id="sortable_maincat_'.$cat['categories_id'].'"';
								else 					$class.='item_'.$item_counter.' ';
								if ($actifsub or $act)  {
									$class.='active ';
									if (count($catlist2) > 0){
										$active_accordion = 'bottomAccordion.activate($$("#vertical_container .accordion_toggle")['.$num.']);';
									}				
								} 
								$content.=(($class)?'class="'.trim($class).'"':'').'><a href="'.$link.'" class="ajax_link">'.$categories_name.'</a>';
								// level 0 eof
								if ($this->maxDEPTH > $nested_level)
								{				
									if (count($catlist2) > 0)
									{
										// level 1
										
										$content.='<ul class="sublevel">';
										foreach ($catlist2 as $cat)
										{					
											$nested_level=1;
											// get all cats to generate multilevel fake url
											$level=0;
											$cats=mslib_fe::Crumbar($cat['categories_id']);				
											$cats=array_reverse($cats);
											$where='';
											if (count($cats) > 0)
											{
												foreach ($cats as $item)
												{
													$where.="categories_id[".$level."]=".$item['id']."&";
													$level++;
												}
												$where=substr($where,0,(strlen($where)-1));
												$where.='&';
											}
											// get all cats to generate multilevel fake url eof					
											$link=mslib_fe::typolink($this->shop_pid,'&'.$where.'&tx_multishop_pi1[page_section]=products_listing');
											$actifsub=0;
											$act=0;
											if ($user_crumbar[$nested_level]['id'] == $cat['categories_id'])
											{
												if ($user_crumbar[($nested_level+1)])
												{
													$categories_name=htmlspecialchars($cat['categories_name']);					
													$actifsub=1;
												}
												else
												{
													$categories_name=htmlspecialchars($cat['categories_name']);										
													$act=1;
												}
											}
											else
											{
												$categories_name=htmlspecialchars($cat['categories_name']);					
											}
											
											$catlist3=mslib_fe::getSubcatsOnly($cat['categories_id']);
											//level submenu 2 start
											if (count($catlist3) > 0 and $this->maxDEPTH > 2){
												$content .= '<li><a href="'.$link.'">'.$categories_name.'</a>
																<ul class="sub_active">';
												$cat_level_3 = "";
												foreach ($catlist3 as $cat)
												{
													$nested_level=1;
													// get all cats to generate multilevel fake url
													$level=0;
													$cats=mslib_fe::Crumbar($cat['categories_id']);				
													$cats=array_reverse($cats);
													$where='';
													if (count($cats) > 0)
													{
														foreach ($cats as $item)
														{
															$where.="categories_id[".$level."]=".$item['id']."&";
															$level++;
														}
														$where=substr($where,0,(strlen($where)-1));
														$where.='&';
													}
													// get all cats to generate multilevel fake url eof					
													$link=mslib_fe::typolink($this->shop_pid,'&'.$where.'&tx_multishop_pi1[page_section]=products_listing');
													$actifsub=0;
													$act=0;
													if ($user_crumbar[$nested_level]['id'] == $cat['categories_id'])
													{
														if ($user_crumbar[($nested_level+1)])
														{
															$categories_name=htmlspecialchars($cat['categories_name']);					
															$actifsub=1;
														}
														else
														{
															$categories_name=htmlspecialchars($cat['categories_name']);										
															$act=1;
														}
													}
													else
													{
														$categories_name=htmlspecialchars($cat['categories_name']);					
													}
													$cat_level_3 .= '<li><a href="'.$link.'">'.$categories_name.'</a></li>';
												}
												$content .= $cat_level_3 .'</ul>';
												
											} else {
												$content.='<li '.(($actifsub or $act)?'class="subactive"':'').'><a href="'.$link.'">'.$categories_name.'</a>';
											}
											//level submenu 2 eof
											$content.='</li>';
										}
										$content.='</ul>';		
										// level 1 eof
									}
								}
								$content.='</li>';
							}
							$content.='</ul></div>     
								   
							';
							if ($this->ADMIN_USER)
							{
								$content.='					
								<script>
								  jQuery(document).ready(function() {
									var result = jQuery("#vertical_container").sortable({
									 cursor:     "move", 
										//axis:       "y", 
										update: function(e, ui) { 
											href = "'.mslib_fe::typolink(',2002','&tx_multishop_pi1[page_section]=menu').'"; 
											jQuery(this).sortable("refresh"); 
											sorted = jQuery(this).sortable("serialize", "id"); 
											jQuery.ajax({ 
													type:   "POST", 
													url:    href, 
													data:   sorted, 
													success: function(msg) { 
															//do something with the sorted data 
													} 
											}); 
										} 
									});
								  });
								  </script>					
								';
							}	
						}			
					// show default categories box eof		
					}					
				}
				if (!$content)
				{
					// no content. lets show a nice addthis box
					$this->showBoxless=1;
					$content.='<div id="multishop_add_this">'.
						$ms['add_this_button']
					.'</div>';
				}
				if ($ms['MODULES']['CACHE_FRONT_END'])	$Cache_Lite->save($content);	
			}
			break;	
			case 'search':
				$this->contentType = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'contentType', 's_search');
				switch ($this->contentType)
				{
					case 'searchform_with_keyword_and_category_dropdown_menu':
						include('front_pages/searchform_with_keyword_and_category_dropdown_menu.php');
					break;					
					case 'ultrasearch':
						include_once('front_pages/ultrasearch.php');
					break;								
					case 'price_filter_navigation_box':
					if ($ms['MODULES']['PRICE_FILTER_BOX_STEPPINGS'])
					{
						$this->box_class="multishop_price_filter_box";
						if ($ms['MODULES']['CACHE_FRONT_END'] and !$ms['MODULES']['CACHE_TIME_OUT_CATEGORIES_NAVIGATION_MENU']) $ms['MODULES']['CACHE_FRONT_END']=0;
						if ($ms['MODULES']['CACHE_FRONT_END'])
						{
							$options = array(
								'caching' => true,
								'cacheDir' => PATH_site.'uploads/tx_multishop/tmp/cache/',
								'lifeTime' => $ms['MODULES']['CACHE_TIME_OUT_CATEGORIES_NAVIGATION_MENU']
							);
							$Cache_Lite = new Cache_Lite($options);
							$string='price_filter_'.$server['REQUEST_URI'].$server['QUERY_STRING'].$this->cObj->data['uid'];
						}
						if (!$ms['MODULES']['CACHE_FRONT_END'] or !$content=$Cache_Lite->get($string))
						{		
							$array=explode(";",$ms['MODULES']['PRICE_FILTER_BOX_STEPPINGS']);
							$array[]=$this->pi_getLL('show_all');
							$content.='<ul>';
							if (count($GLOBALS["TYPO3_CONF_VARS"]['tx_multishop_data']['user_crumbar']) >0)
							{
								// get all cats to generate multilevel fake url
								$level=0;
								$cats=$GLOBALS["TYPO3_CONF_VARS"]['tx_multishop_data']['user_crumbar'];
								if(is_array($cats) and count($cats))
								{
									$cats=array_reverse($cats);
								}
								$where='';
								if (count($cats) > 0)
								{
									foreach ($cats as $cat)
									{
										$where.="categories_id[".$level."]=".$cat['id']."&";
										$level++;
									}
									$where=substr($where,0,(strlen($where)-1));
									$where.='&';
								}
								// get all cats to generate multilevel fake url eof
							}
							else $where='';
							$get['skeyword'] = $_REQUEST['skeyword'];	
							$get['skeyword'] = trim($get['skeyword']);
							$get['skeyword'] = $GLOBALS['TSFE']->csConvObj->utf8_encode($get['skeyword'], $GLOBALS['TSFE']->metaCharset);
							$get['skeyword'] = $GLOBALS['TSFE']->csConvObj->entities_to_utf8($get['skeyword'],TRUE);
							$get['skeyword'] = mslib_fe::RemoveXSS($get['skeyword']);
							if ($get['skeyword']) $where.='&skeyword='.urlencode($get['skeyword']).'&';
							foreach ($array as $item)
							{
								if ($item !=$this->pi_getLL('show_all')) $label=$item.' euro';
								else
								{
									$label=$this->pi_getLL('show_all');
								}
								$content.='<li'.($get['price_filter']==$item?' class="active"':'').'><a href="'.mslib_fe::typolink($this->conf['search_page_pid'],'&tx_multishop_pi1[page_section]=products_search&'.$where.'price_filter='.urlencode($item)).'" class="ajax_link">'.$label.'</a></li>'."\n";
							}
							$content.='
							</ul>
							';
							if ($ms['MODULES']['CACHE_FRONT_END'])	$Cache_Lite->save($content);
						}
					}
					break;					
					case 'searchform_with_manufacturers_dropdown_menu':
					$content.='
						<form action="index.php" method="get" name="products_searchform">
						<input name="id" type="hidden" value="'.$this->conf['search_page_pid'].'" />
						<input name="tx_multishop_pi1[page_section]" type="hidden" value="products_search" />
						
						<div class="form-fieldset">
						<select name="manufacturers_id" id="manufacturers_dropdown_menu"><option value="">'.htmlspecialchars($this->pi_getLL('manufacturers')).'</option>						
						';
						$str="SELECT * from tx_multishop_manufacturers m, tx_multishop_manufacturers_info mi where m.manufacturers_id=mi.manufacturers_id and m.status=1 order by m.sort_order,m.manufacturers_name";
						
                        $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
						$manufacturers=array();	
						while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
						{
							$manufacturers[]=$row;
						}
						if (count($manufacturers) > 0)
						{
							foreach ($manufacturers as $manufacturer)
							{
								$content.='<option value="'.$manufacturer['manufacturers_id'].'"'.($get['manufacturers_id']==$manufacturer['manufacturers_id']?' selected':'').'>'.htmlspecialchars($manufacturer['manufacturers_name']).'</option>'."\n";
							}
						}
						$content.='</select>						
						</div>
						</form>
						<script>
							jQuery("#manufacturers_dropdown_menu").change(function() {
							   jQuery(this).closest("form").submit();
							});						
						</script>
					';						
					break;
					case 'default':
					default:
					if ($this->conf['includejAutocomplete'])
					{						
						$GLOBALS['TSFE']->additionalHeaderData[]='
						<script type="text/javascript">jQuery.noConflict();</script>
							<script type="text/javascript">
								  jQuery(document).ready(function() {
									var sendData;														  
									jQuery("#skeyword").bind("focus",function(){
										jQuery("#page").val(0);
									})
									jQuery("#skeyword").bind("keydown.autocomplete",function(e){
										// dont process special keys
										var skipKeys = [ 13,38,40,37,39,27,32,17,18,9,16,20,91,93,8,36,35,45,46,33,34,144,145,19 ];
										if (jQuery.inArray(e.keyCode, skipKeys) != -1) sendData = false;
										else sendData = true;																													
									})							
									jQuery("#skeyword").autocomplete({
										//console.log(this);
										minLength: 1,
										delay: 0,
										open: function(event, ui){
										  jQuery(".ui-autocomplete li.ui-menu-item:odd a").addClass("ui-menu-item-alternate");
										},										
										source: function( request, response ) {
												if (sendData){										
												jQuery.ajax({
													url: "'. mslib_fe::typolink($this->shop_pid.',2002','&tx_multishop_pi1[page_section]=ajax_products_search') .'",
													dataType: "json",
													data: {
														q: jQuery("#skeyword").val(), page: jQuery("#page").val()
													},
													success: function( data ) {
														var index = 1;
														 if(data.products != null){
															response( jQuery.map( data.products, function( item ) {
																index = index + 1;
																 
																	if (index == 6) {
																		return {
																			label: item.Title,
																			value: item.Name,
																			link: item.Link,
																			skeyword: item.skeyword,
																			page: item.Page,
																			prod: item.Product
																		}
																	} else {
																		return {
																			label: "<div class=\"ajax_products_image_wrapper\">"+item.Image + "</div><div class=\"ajax_products_search_item\">" + item.Title  + item.Desc + item.Price + "</div>",
																			value: item.Name,
																			link: item.Link,
																			skeyword: item.skeyword,
																			page: item.Page,
																			prod: item.Product
																		}
																	}
																 
																})
															);
														 } //end if data
														//alert(index);
													}
												});
												} // and if sendData
											},
										select: function(event, ui ) {
														 jQuery("#skeyword").val(ui.item.skeyword);
														 jQuery("#page").val(ui.item.page);
														//console.log(ui);
														//alert(ui.toSource());
														var link = "'.$this->FULL_HTTP_URL.'" + ui.item.link ; 
														//alert(link);
														if (ui.item.prod == true){
															open(link,\'_self\',\'resizable,location,menubar,toolbar,scrollbars,status\');
														} else {
															jQuery("#skeyword").autocomplete("search");
														}
														
													},
										focus: function(event, ui) {
											jQuery("#skeyword").val(ui.item.skeyword);
											jQuery("#page").val(0);
											return false;
										}	
									}).data(\'autocomplete\')._renderItem = function (ul, item) {
										return jQuery("<li></li>").data("item.autocomplete", item).append(jQuery("<a></a>").html(item.label)).appendTo(ul);
										};
								  });
							</script>';		
					}					
					$content.='
						<form action="index.php" method="get" name="products_searchform">
						<input name="id" type="hidden" value="'.$this->conf['search_page_pid'].'" />
						<input name="tx_multishop_pi1[page_section]" type="hidden" value="products_search" />						
						<div class="form-fieldset">
							<label for="skeyword">'.$this->pi_getLL('keyword').':</label>
							<input name="skeyword" type="text" value="'.htmlspecialchars(mslib_fe::RemoveXSS($get['skeyword'])).'" id="skeyword" />
							<input name="page" type="hidden" value="0" id="page" />						
							<input name="Submit" type="submit" value="'.htmlspecialchars($this->pi_getLL('search')).'" />
						</div>
						</form>
					';							
					break;
				}
			break;				
			case 'specials':
				$this->section_code = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'section_code', 's_specials');
				$this->box_class='multishop_specials';
				$this->contentType = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'contentType', 's_specials');
				$this->limit = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'speciallimit', 's_specials');		
				$content.=mslib_fe::SpecialsBox($this->contentType,$this->limit,$this->showCatalogFromPage,$this->cObj->data['uid']);
			break;
			case 'products':
				$this->contentType = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'contentType', 's_products_listing');
				switch ($this->contentType)
				{
					case 'products_new':
						include_once('front_pages/products_new.php');
					break;
					case 'products_modified':
						include_once('front_pages/products_modified.php');
					break;
					case 'products_upcoming':
						include_once('front_pages/products_upcoming.php');
					break;
				}
			break;	
			case 'misc':
//			case 'ajax_remote_search':
				$this->contentMisc = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'contentType', 's_misc');
				switch ($this->contentMisc){
					case 'ajax_remote_search':
						$content.='<input name="skeywords" id="skeywords" type="text" /><div id="searchForm"></div>';
						$content.='
						<script type="text/javascript">
						// validate username
						jQuery(document).ready(function () {
						  var searchForm = jQuery(\'#searchForm\');
						  jQuery(\'#skeywords\').keyup(function () {
							var t = this; 
							if (this.value != this.lastValue) {
							  if (this.timer) clearTimeout(this.timer);
							  searchForm.removeClass(\'error\').html(\'<img src="'.$this->FULL_HTTP_URL_MS.'templates/images/loading2.gif" height="16" width="16" /> loading...\');
							  this.timer = setTimeout(function () {
								jQuery.ajax({
								  url: \''.mslib_fe::typolink(',2002','&tx_multishop_pi1[page_section]=ajax_remote_search').'\',
								  data: \'&skeyword=\' + t.value,
								  dataType: \'json\',
								  type: \'post\',
								  success: function (j) {
									searchForm.html(j.msg);
								  }
								});
							  }, 200);
							  this.lastValue = this.value;
							}
						  });
						});
						</script>				
						';
						break;
					case 'create_account':
						include_once('front_pages/includes/accounts/register.php');
					break;
					case 'edit_account':
						include_once('front_pages/includes/accounts/edit_account.php');
					break;
				}
				
			break;
			case 'coreshop':
			require('core.php');
//			mslib_befe::RunMultishopUpdate();
			if ($this->conf['show_powered_by_multishop'])
			{
				$content.='
				<div class="align_center" id="typo3multishop_logo">
					<a href="http://www.typo3multishop.com/?utm_source=Typo3Website&utm_medium=cpc&utm_term=Typo3Multishop&utm_content=Listing&utm_campaign=Typo3Multishop" title="Powered by Typo3 Multishop" target="_blank"><img src="'.$this->FULL_HTTP_URL_MS.'templates/images/powered_by_typo3multishop.png" border="0" alt="Powered by Typo3 Multishop" title="Powered by Typo3 Multishop"></a>
				</div>
				';
			}
			break;
		}
		if ($this->hideIfNoResults and $this->no_database_results)
		{
			// when the content element in typo3 has been configured with hideIfNoResults = true then hide the content if there is no data fetched from the database
			$this->hideHeader=1;
			return '';
		}
		if ($this->showBoxless)
		{
			$this->hideHeader=1;
			return $this->pi_wrapInBaseClass($content);
		}		
		elseif ($this->addBox or $this->box_class)
		{
			if ($this->hideHeader)
			{
				$this->cObj->data['header']='';
			}
			$content=mslib_fe::typobox($this->cObj->data['header'],$content,$this->box_class);
		}
		elseif (!$this->hideHeader)
		{
			$content = $this->cObj->cObjGetSingle(
				$GLOBALS['TSFE']->tmpl->setup['lib.']['stdheader'],
				$GLOBALS['TSFE']->tmpl->setup['lib.']['stdheader.']
			) . $content;
		}	
		restore_include_path();
		return $this->pi_wrapInBaseClass($content);
	}
}
if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/multishop/pi1/class.tx_multishop_pi1.php'])
{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/multishop/pi1/class.tx_multishop_pi1.php']);
}
?>