<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2010 BVB Media BV - Bas van Beek <bvbmedia@gmail.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */
global $ms,$get,$server,$post; 
class mslib_befe
{
	/*
		Back-end / Front-end functions
	*/
	// load local front-end module config
	function loadConfiguration ($multishop_page_uid='')
	{
		if (!$multishop_page_uid or $multishop_page_uid==$this->shop_pid)
		{			
			static $settings;
			if (is_array($settings))
			{
				// the settings are already loaded before so lets return them.
				return $settings;
			}
			// first check if we already loaded the configuration before
		}
		$settings=array();
		$query = $GLOBALS['TYPO3_DB']->SELECTquery(
						'*',         // SELECT ...
						'tx_multishop_configuration_values',     // FROM ...
						'page_uid="'.$multishop_page_uid.'"',    // WHERE...
						'',            // GROUP BY...
						'',    // ORDER BY...
						''            // LIMIT ...
		);
		$res = $GLOBALS['TYPO3_DB']->sql_query($query);
		if ($GLOBALS['TYPO3_DB']->sql_num_rows($res) > 0)
		{
			while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))
			{
				if (isset($row['configuration_value']) and $row['configuration_value'] != '') $settings['LOCAL_MODULES'][$row['configuration_key']]=$row['configuration_value'];
			}	
		}
		// load local front-end module config eof
		// load global front-end module config
		$query = $GLOBALS['TYPO3_DB']->SELECTquery(
						'*',         // SELECT ...
						'tx_multishop_configuration',     // FROM ...
						'',    // WHERE...
						'',            // GROUP BY...
						'',    // ORDER BY...
						''            // LIMIT ...
		);
		$res = $GLOBALS['TYPO3_DB']->sql_query($query);
		if ($GLOBALS['TYPO3_DB']->sql_num_rows($res) > 0)
		{
			while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))
			{
				if (isset($row['configuration_value'])) $settings['GLOBAL_MODULES'][$row['configuration_key']]=$row['configuration_value'];
			}	
		}
		// load global front-end module config eof
		// merge global with local front-end module config
		foreach ($settings['GLOBAL_MODULES'] as $key => $value)
		{
			if (isset($settings['LOCAL_MODULES'][$key]))	$settings[$key]=$settings['LOCAL_MODULES'][$key];
			else											$settings[$key]=$value;
		}
		// merge global with local front-end module config eof	
		if ($settings['COUNTRY_ISO_NR'])
		{
			if ($settings['COUNTRY_ISO_NR']==528)
			{
				// dutch
				$settings['CURRENCY']='&#8364;';
			}
			else $settings['CURRENCY']=mslib_befe::loadCurrency($settings['COUNTRY_ISO_NR']);
		}								 
		return $settings;
	}
	/* this method resizes the thumbnail images for the category	
	example input:
	/var/www/vhosts/multishop.com/httpdocs/upload/tx_multishop/images/categories/original/my,
	my-photo.jpg,
	PATH_site.t3lib_extMgm::siteRelPath($this->extKey)	
	example output: my-photo.jpg
	*/
	function resizeCategoryImage ($original_path,$filename,$module_path,$run_in_background=0) 
	{
		if ($filename)
		{
			global $ms;
			if ($run_in_background) $suffix_exec_param=' &> /dev/null & ';
			$commands=array();			
			$maxwidth=$ms['category_image_formats']['normal']['width'];
			$maxheight=$ms['category_image_formats']['normal']['height'];
			$folder=mslib_befe::getImagePrefixFolder($filename);
			$dirs=array();
			$dirs[]=PATH_site.$ms['image_paths']['categories']['normal'].'/'.$folder;
			foreach ($dirs as $dir)
			{
				if (!is_dir($dir))
				{
					t3lib_div::mkdir($dir,0777);
				}
			}
			$target=PATH_site.$ms['image_paths']['categories']['normal'].'/'.$folder.'/'.$filename;
			copy($original_path,$target);
			$gfxConf = $GLOBALS['TYPO3_CONF_VARS']['GFX'];
			$commands[] = t3lib_div::imageMagickCommand('convert', '-quality 90 -resize "'.$maxwidth.'x'.$maxheight.'>" "'.$target .'" "'.$target .'"', $gfxConf['im_path_lzw']);
			if ($ms['MODULES']['CATEGORY_IMAGE_SHAPED_CORNERS'] and file_exists($GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite'))
			{
				$commands[]=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity NorthWest '.$module_path.'templates/images/curves/lb.png "'.$target .'" "'.$target .'"';
				$commands[]=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity NorthEast '.$module_path.'templates/images/curves/rb.png "'.$target .'" "'.$target .'"';
				$commands[]=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity SouthWest '.$module_path.'templates/images/curves/lo.png "'.$target .'" "'.$target .'"';
				$commands[]=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity SouthEast '.$module_path.'templates/images/curves/ro.png "'.$target .'" "'.$target .'"';
	/*			
				echo $line1.'<br>';
				echo $line2.'<br>';
				echo $line3.'<br>';
				echo $line4.'<br>';
				die();
	*/			
			}
			if (count($commands))
			{
				// background running is not working on all boxes well, so we reverted it				
//				$final_command="(".implode($commands," && ").") ".$suffix_exec_param;
//				t3lib_utility_Command::exec($final_command);	
				foreach ($commands as $command)
				{
					exec($command);
				}
			}	
			return $filename;
		}
	}
	/* this method returns a relative path plus the inserted filename	
	example input: 'my-photo.jpg','products',100
	example output: upload/tx_multishop/images/products/100/my/my-photo.jpg
	*/
	function getImagePath($filename,$type,$width=100)
	{
		global $ms;
		$folder=$ms['image_paths'][$type][$width].'/'.mslib_befe::getImagePrefixFolder($filename);
		return $folder.'/'.$filename;
	}
	/* this method returns a substracted prefix folder.	
	example input: my-photo.jpg
	example output: my
	*/
	function getImagePrefixFolder($filename)
	{
		$array=explode(".",$filename);
		$folder_name=substr(preg_replace("/\.+?$/is","",trim($array[0])),0,3);
		$folder_name=preg_replace("/\-$/","",$folder_name);
		return strtolower($folder_name);
	}	
	function resizeProductImage ($original_path,$filename,$module_path,$run_in_background=0) 
	{
		global $ms;
		if ($filename)
		{		
			if ($run_in_background) $suffix_exec_param=' &> /dev/null & ';
			$commands=array();		
			$params='';
			if ($GLOBALS['TYPO3_CONF_VARS']['GFX']['im_version_5']=='im6') $params.='-strip';			
			$folder=mslib_befe::getImagePrefixFolder($filename);
			$dirs=array();
			$dirs[]=PATH_site.$ms['image_paths']['products']['100'].'/'.$folder;
			$dirs[]=PATH_site.$ms['image_paths']['products']['200'].'/'.$folder;
			$dirs[]=PATH_site.$ms['image_paths']['products']['300'].'/'.$folder;
			$dirs[]=PATH_site.$ms['image_paths']['products']['50'].'/'.$folder;
			$dirs[]=PATH_site.$ms['image_paths']['products']['normal'].'/'.$folder;
			foreach ($dirs as $dir)
			{
				if (!is_dir($dir))
				{
					t3lib_div::mkdir($dir,0777);
				}
			}
			$target=PATH_site.$ms['image_paths']['products']['300'].'/'.$folder.'/'.$filename;
			copy($original_path,$target);
			// 300 thumbnail settings
			$maxwidth=$ms['product_image_formats'][300]['width'];
			$maxheight=$ms['product_image_formats'][300]['height'];
			$gfxConf = $GLOBALS['TYPO3_CONF_VARS']['GFX'];
			$commands[] = t3lib_div::imageMagickCommand('convert', '-quality 90 -resize "'.$maxwidth.'x'.$maxheight.'>" "'.$target .'" "'.$target .'"', $gfxConf['im_path_lzw']);	
			if ($ms['MODULES']['PRODUCT_IMAGE_SHAPED_CORNERS'])
			{
				$commands[]=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity NorthWest '.$module_path.'templates/images/curves/lb.png "'.$target .'" "'.$target .'"';
				$commands[]=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity NorthEast '.$module_path.'templates/images/curves/rb.png "'.$target .'" "'.$target .'"';
				$commands[]=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity SouthWest '.$module_path.'templates/images/curves/lo.png "'.$target .'" "'.$target .'"';
				$commands[]=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity SouthEast '.$module_path.'templates/images/curves/ro.png "'.$target .'" "'.$target .'"';
			}	
			$target=PATH_site.$ms['image_paths']['products']['200'].'/'.$folder.'/'.$filename;
			copy($original_path,$target);
			// 200 thumbnail settings
			$maxwidth=$ms['product_image_formats'][200]['width'];
			$maxheight=$ms['product_image_formats'][200]['height'];
			$commands[] = t3lib_div::imageMagickCommand('convert', '-quality 90 -resize "'.$maxwidth.'x'.$maxheight.'>" "'.$target .'" "'.$target .'"', $gfxConf['im_path_lzw']);
			if ($ms['MODULES']['PRODUCT_IMAGE_SHAPED_CORNERS'])
			{
				$commands[]=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity NorthWest '.$module_path.'templates/images/curves/lb.png "'.$target .'" "'.$target .'"';
				$commands[]=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity NorthEast '.$module_path.'templates/images/curves/rb.png "'.$target .'" "'.$target .'"';
				$commands[]=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity SouthWest '.$module_path.'templates/images/curves/lo.png "'.$target .'" "'.$target .'"';
				$commands[]=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -gravity SouthEast '.$module_path.'templates/images/curves/ro.png "'.$target .'" "'.$target .'"';
			}
			$target=PATH_site.$ms['image_paths']['products']['100'].'/'.$folder.'/'.$filename;				
			copy($original_path,$target);
			// 100 thumbnail settings
			$maxwidth=$ms['product_image_formats'][100]['width'];
			$maxheight=$ms['product_image_formats'][100]['height'];		
			$commands[]=t3lib_div::imageMagickCommand('convert', '-quality 90 -resize "'.$maxwidth.'x'.$maxheight.'>" "'.$target .'" "'.$target .'"', $gfxConf['im_path_lzw']);
			$target=PATH_site.$ms['image_paths']['products']['50'].'/'.$folder.'/'.$filename;				
			copy($original_path,$target);
			// 50 thumbnail settings
			$maxwidth=$ms['product_image_formats'][50]['width'];
			$maxheight=$ms['product_image_formats'][50]['height'];
			$commands[]=t3lib_div::imageMagickCommand('convert', '-quality 90 -resize "'.$maxwidth.'x'.$maxheight.'>" "'.$target .'" "'.$target .'"', $gfxConf['im_path_lzw']);
	
			$target=PATH_site.$ms['image_paths']['products']['normal'].'/'.$folder.'/'.$filename;				
			copy($original_path,$target);
			// normal thumbnail settings
			$maxwidth=$ms['product_image_formats']['enlarged']['width'];
			$maxheight=$ms['product_image_formats']['enlarged']['height'];	
			if (!$ms['MODULES']['PRODUCT_IMAGE_WATERMARK_TEXT'])
			{
				$commands[]=t3lib_div::imageMagickCommand('convert', '-quality 90 -resize "'.$maxwidth.'x'.$maxheight.'>" "'.$target .'" "'.$target .'"', $gfxConf['im_path_lzw']);
			}
			else
			{
				t3lib_utility_Command::exec(t3lib_div::imageMagickCommand('convert', '-quality 90 -resize "'.$maxwidth.'x'.$maxheight.'>" "'.$target .'" "'.$target .'"', $gfxConf['im_path_lzw']));
				$newsize=@getimagesize($target);
				$text_width=$ms['MODULES']['PRODUCT_IMAGE_WATERMARK_WIDTH'];
				$text_height=$ms['MODULES']['PRODUCT_IMAGE_WATERMARK_HEIGHT'];
				if ($newsize[0] > $maxwidth) 	$final_width=$maxwidth;
				else							$final_width=$newsize[0];		
				if ($newsize[1] > $maxheight) 	$final_height=$maxheight;
				else							$final_height=$newsize[1];			
				switch ($ms['MODULES']['PRODUCT_IMAGE_WATERMARK_POSITION'])
				{
					case 'north-east':
					$pos_x=($final_width-$text_width);
					$pos_y=(25);
					break;				
					case 'south-east':
					$pos_x=($final_width-$text_width);
					$pos_y=($final_height-5);
					break;	
					case 'south-west':
					$pos_x='2';
					$pos_y=($final_height-5);
					break;
					case 'north-west':
					$pos_x='2';
					$pos_y=(25);
					break;			
				}		
				if (is_numeric($ms['MODULES']['PRODUCT_IMAGE_WATERMARK_FONT_SIZE']) && $ms['MODULES']['PRODUCT_IMAGE_WATERMARK_TEXT'] && ($newsize[0] > $text_width && $newsize[1] > $text_height))
				{
					$ms['MODULES']['PRODUCT_IMAGE_WATERMARK_TEXT']=$ms['MODULES']['PRODUCT_IMAGE_WATERMARK_TEXT'];
					if (strstr($ms['MODULES']['PRODUCT_IMAGE_WATERMARK_FONT_FILE'],"..")) die('error in PRODUCT_IMAGE_WATERMARK_FONT_FILE value');
					else 
					{
						if (strstr($ms['MODULES']['PRODUCT_IMAGE_WATERMARK_FONT_FILE'],"/"))	$font_file=PATH_site.$ms['MODULES']['PRODUCT_IMAGE_WATERMARK_FONT_FILE'];
						else	$font_file=$module_path.'templates/images/fonts/'.$ms['MODULES']['PRODUCT_IMAGE_WATERMARK_FONT_FILE'];
					}
	
					$tmppath=$this->DOCUMENT_ROOT.'/uploads/tx_multishop/tmp/cache';				
					$commands[]=t3lib_div::imageMagickCommand('convert', '-resize '.$final_width.'x'.$final_height.' xc:black -font "'.$font_file.'" -pointsize '.$ms['MODULES']['PRODUCT_IMAGE_WATERMARK_FONT_SIZE'].' -fill white -draw "text '.$pos_x.','.$pos_y.' \''.$ms['MODULES']['PRODUCT_IMAGE_WATERMARK_TEXT'].'\'" -shade '.$text_width.'x'.($text_height-30).'  "'.$tmppath.'/beveled_'.$savenametest.'.jpg"', $gfxConf['im_path_lzw']);
					$commands[]=t3lib_div::imageMagickCommand('convert', '-resize '.$final_width.'x'.$final_height.' xc:black -font "'.$font_file.'" -pointsize '.$ms['MODULES']['PRODUCT_IMAGE_WATERMARK_FONT_SIZE'].' -fill white -draw "text '.$pos_x.','.$pos_y.' \''.$ms['MODULES']['PRODUCT_IMAGE_WATERMARK_TEXT'].'\'" -shade '.$text_width.'x'.$text_height.'  -negate -normalize  "'.$tmppath.'/beveled_mask_'.$savenametest.'.jpg"', $gfxConf['im_path_lzw']);
					$commands[]=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -compose CopyOpacity "'.$tmppath.'/beveled_mask_'.$savenametest.'.jpg'.'" "'.$tmppath.'/beveled_'.$savenametest.'.jpg'.'" "'.$tmppath.'/beveled_trans_'.$savenametest.'.png"';
					$commands[]=$GLOBALS['TYPO3_CONF_VARS']['GFX']["im_path"].'composite -quality 75 "'.$tmppath.'/beveled_trans_'.$savenametest.'.png" "'.$target .'" "'.$target.'"';
					$commands[]="rm -f ".$tmppath.'/beveled_'.$savenametest.'.jpg';
					$commands[]="rm -f ".$tmppath.'/beveled_mask_'.$savenametest.'.jpg';
					$commands[]="rm -f ".$tmppath.'/beveled_trans_'.$savenametest.'.png';
	/*
					echo '<img src="'.$this->FULL_HTTP_URL.'uploads/tx_multishop/tmp/cache/beveled_'.$savenametest.'.jpg">';
					echo '<img src="'.$this->FULL_HTTP_URL.'uploads/tx_multishop/tmp/cache/beveled_mask_'.$savenametest.'.jpg">';
					echo '<img src="'.$this->FULL_HTTP_URL.'uploads/tx_multishop/tmp/cache/beveled_trans_'.$savenametest.'.png">
					<img src="'.$this->FULL_HTTP_URL.''.$ms['image_paths']['products']['normal'].'/'.$folder.'/'.$filename.'">
					<BR>';
					echo $line1.'<BR><BR>';
					echo $line2.'<BR><BR>';
					echo $line3.'<BR><BR>';
					echo $line4.'<BR><BR>';
					die();
	*/						
				}
			}
			if (count($commands))
			{
				// background running is not working on all boxes well, so we reverted it
//				$final_command="(".implode($commands," && ").") ".$suffix_exec_param;
//				t3lib_utility_Command::exec($final_command);	
				foreach ($commands as $command)
				{
					exec($command);
				}
			}
			return $filename;
		}
	} 
	function countProducts ($page_uid)
	{
		$data	= $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('count(1) as total','tx_multishop_products','page_uid=\''.$page_uid.'\'','');		
		$row=$data[0];
		if (!isset($row['total'])) $row['total']=0;
		return $row['total'];
	}
	function countOrders ($page_uid)
	{
		$data	= $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('count(1) as total','tx_multishop_orders','page_uid=\''.$page_uid.'\'','');		
		$row=$data[0];
		if (!isset($row['total'])) $row['total']=0;
		return $row['total'];
	}
	function countCustomerAddresses($page_uid)
	{
		$data	= $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('count(1) as total','tt_address','pid=\''.$page_uid.'\'','');		
		$row=$data[0];
		if (!isset($row['total'])) $row['total']=0;
		return $row['total'];
	}
	function countCustomers ($page_uid)
	{
		$data	= $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('count(1) as total','fe_users','pid=\''.$page_uid.'\'','');		
		$row=$data[0];
		if (!isset($row['total'])) $row['total']=0;
		return $row['total'];
	}
	function countCategories ($page_uid)
	{
		$data	= $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('count(1) as total','tx_multishop_categories','page_uid=\''.$page_uid.'\'','');		
		$row=$data[0];
		if (!isset($row['total'])) $row['total']=0;
		return $row['total'];
	}
	function countManufacturers ($page_uid)
	{
//		$data	= $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('count(1) as total','tx_multishop_manufacturers','page_uid=\''.$page_uid.'\'','');		
		$data	= $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('count(1) as total','tx_multishop_manufacturers','','');		
		$row=$data[0];
		if (!isset($row['total'])) $row['total']=0;
		return $row['total'];
	}
	function countImportJobs ($page_uid)
	{
		$data	= $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('count(1) as total','tx_multishop_import_jobs','page_uid=\''.$page_uid.'\'','');		
		$row=$data[0];
		if (!isset($row['total'])) $row['total']=0;
		return $row['total'];
	}
	function deleteProductImage ($file_name)
	{
		global $ms;	
		if ($file_name)
		{
			foreach ($ms['image_paths']['products'] as $key => $value)
			{
				$folder_name=mslib_befe::getImagePrefixFolder($file_name);
				$path=PATH_site.$value.'/'.$folder_name.'/'.$file_name;
				if (file_exists($path))
				{
					if (unlink($path))
					{
						$path=PATH_site.$value.'/'.$folder_name.'/'.$file_name;
						@unlink($path);
					}
				}
			}
		}
	}
	function deleteProduct ($products_id)
	{
		global $ms;
		if (is_numeric($products_id))
		{
			$row=mslib_fe::getProduct($products_id,'','',1);
			if (is_numeric($row['products_id']))
			{
				for ($x=0;$x<=4;$x++)
				{
					$i=$x;
					if ($i==0) $i='';				
					$filename=$row['products_image'.$i];
					mslib_befe::deleteProductImage($filename);
				}
				$tables=array();
				$tables[]='tx_multishop_products';
				$tables[]='tx_multishop_products_flat';
				$tables[]='tx_multishop_products_description';
				$tables[]='tx_multishop_products_to_categories';
				$tables[]='tx_multishop_products_attributes';
				$tables[]='tx_multishop_specials';
				$tables[]='tx_multishop_undo_products';
				$tables[]='tx_multishop_products_faq';
				$tables[]='tx_multishop_products_to_extra_options';
				foreach ($tables as $table)
				{
					$query = $GLOBALS['TYPO3_DB']->DELETEquery($table, 'products_id='.$products_id);
					$res = $GLOBALS['TYPO3_DB']->sql_query($query);					
				}
				$qry	= $GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_multishop_products_to_relative_products','products_id='.$products_id.' or relative_product_id='.$products_id);					
				return 1;
			}
		}
	}
	function deleteCategory ($categories_id)
	{
		global $ms;
		if (is_numeric($categories_id))
		{			
			$str="SELECT * from tx_multishop_categories where categories_id='".$categories_id."'";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				// first check if the category has subcategories to delete them as well
				$subcategories_query = $GLOBALS['TYPO3_DB']->sql_query("select categories_id from tx_multishop_categories where parent_id = '" . $row['categories_id'] . "'");
				while ($subcategory = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($subcategories_query))
				{
					mslib_befe::deleteCategory($subcategory['categories_id']);
				}
				// remove any found products
				$products_query=$GLOBALS['TYPO3_DB']->sql_query("SELECT *,p.staffel_price as staffel_price, tr.tx_rate as tax_rate, IF(s.status, s.specials_new_products_price, p.products_price) as final_price from tx_multishop_products p left join tx_multishop_specials s on p.products_id = s.products_id left join static_taxes tr on p.tax_id = tr.uid, tx_multishop_products_description pd, tx_multishop_products_to_categories p2c, tx_multishop_categories c, tx_multishop_categories_description cd where p2c.categories_id='".$categories_id."' and p.products_id=pd.products_id and p.products_id=p2c.products_id and p2c.categories_id=c.categories_id and p2c.categories_id=cd.categories_id");
				while ($product = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($products_query))
				{
					mslib_befe::deleteProduct($product['products_id']);
				}				
				// finally delete the category
				$filename=$row['categories_image'];
				mslib_befe::deleteCategoryImage($filename);
				$tables=array();
				$tables[]='tx_multishop_categories';
				$tables[]='tx_multishop_categories_description';
				$tables[]='tx_multishop_products_to_categories';
				foreach ($tables as $table)
				{
					$query = $GLOBALS['TYPO3_DB']->DELETEquery($table, 'categories_id='.$categories_id);
					$res = $GLOBALS['TYPO3_DB']->sql_query($query);					
				}
			}	  
		}
	} 	
	function deleteCategoryImage ($file_name)
	{
		global $ms;	
		foreach ($ms['image_paths']['categories'] as $key => $value)
		{
			$path=PATH_site.$value.'/'.$file_name;
			if (unlink($path)) return 1;			
		}						
	}
	function deleteManufacturer($id)
	{
		if (is_numeric($id))
		{
			$qry	= $GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_multishop_manufacturers','manufacturers_id='.$id);	
			$qry	= $GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_multishop_manufacturers_cms','manufacturers_id='.$id);	
			$qry	= $GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_multishop_manufacturers_info','manufacturers_id='.$id);  
		}
	} 		
	function deltree($path) {
	  if (is_dir($path)) {
			if (version_compare(PHP_VERSION, '5.0.0') < 0) {
			  $entries = array();
			if ($handle = opendir($path)) {
			  while (false !== ($file = readdir($handle))) $entries[] = $file;
	
			  closedir($handle);
			}
			} else {
			  $entries = scandir($path);
			  if ($entries === false) $entries = array(); // just in case scandir fail...
			}
	
		 foreach ($entries as $entry) {
			if ($entry != '.' && $entry != '..') {
			  mslib_befe::deltree($path.'/'.$entry);
			}
		 }
	
		 return rmdir($path);
	  } else {
			return unlink($path);
	  }
	}
	function doesExist($table,$field,$value,$more='')
	{
		$query="SELECT * FROM ".$table." WHERE ".$field."='".addslashes($value)."' ".$more;
		$res = $GLOBALS['TYPO3_DB']->sql_query($query);
		if ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))
		{
			return $row;
		}
	}	
	/*
	Some PHP compilations doesnt have the exif_imagetype function. In that case we provide our own alternative
	*/
	function exif_imagetype ($filename)
	{
		if ((list($width,$height,$type,$attr) = getimagesize($filename)) !== false) return $type;
		return false;
	}
	function convertConfiguration($ms)
	{
		// bit lame code, but this is for subdirectory hosted typo3 installations. Compatible for front and back-end.
		/*
		$paths=explode("/",$_SERVER['PHP_SELF']);
		if (count($paths) > 2) 			$prefix=$paths[1].'/';
		else							$prefix='';
		*/
		// not completely tested. reverting temporary
		$prefix='';
		$ms['image_paths']['products']['50']			=$prefix.'uploads/tx_multishop/images/products/50';
		$ms['image_paths']['products']['100']			=$prefix.'uploads/tx_multishop/images/products/100';
		$ms['image_paths']['products']['200']			=$prefix.'uploads/tx_multishop/images/products/200';
		$ms['image_paths']['products']['300']			=$prefix.'uploads/tx_multishop/images/products/300';
		$ms['image_paths']['products']['original']		=$prefix.'uploads/tx_multishop/images/products/original';
		$ms['image_paths']['products']['normal']		=$prefix.'uploads/tx_multishop/images/products/normal';
		$ms['image_paths']['categories']['original']	=$prefix.'uploads/tx_multishop/images/categories/original';
		$ms['image_paths']['categories']['normal']		=$prefix.'uploads/tx_multishop/images/categories/normal';
		$ms['image_paths']['manufacturers']['original']	=$prefix.'uploads/tx_multishop/images/manufacturers/original';
		$ms['image_paths']['manufacturers']['normal']	=$prefix.'uploads/tx_multishop/images/manufacturers/normal';		
		$format=explode("x",$ms['MODULES']['CATEGORY_IMAGE_SIZE_NORMAL']);
		$ms['category_image_formats']['normal']['width']	=$format[0];
		$ms['category_image_formats']['normal']['height']	=$format[1];
		$format=explode("x",$ms['MODULES']['PRODUCT_IMAGE_SIZE_50']);
		$ms['product_image_formats'][50]['width']			=$format[0];
		$ms['product_image_formats'][50]['height']			=$format[1];
		$format=explode("x",$ms['MODULES']['PRODUCT_IMAGE_SIZE_100']);
		$ms['product_image_formats'][100]['width']			=$format[0];
		$ms['product_image_formats'][100]['height']			=$format[1];
		$format=explode("x",$ms['MODULES']['PRODUCT_IMAGE_SIZE_200']);
		$ms['product_image_formats'][200]['width']			=$format[0];
		$ms['product_image_formats'][200]['height']			=$format[1];
		$format=explode("x",$ms['MODULES']['PRODUCT_IMAGE_SIZE_300']);
		$ms['product_image_formats'][300]['width']			=$format[0];
		$ms['product_image_formats'][300]['height']			=$format[1];
		$format=explode("x",$ms['MODULES']['PRODUCT_IMAGE_SIZE_ENLARGED']);
		$ms['product_image_formats']['enlarged']['width']	=$format[0];
		$ms['product_image_formats']['enlarged']['height']	=$format[1];						
		return $ms;
	}
	// method for logging changes to specific tables
	function addUndo($id,$table)
	{
		if (is_numeric($id) and $table)
		{
			$undo_tables=array();
			$undo_tables['tx_multishop_products']='tx_multishop_undo_products';		
			$str="SELECT * FROM `".$table."` where products_id='".$id."'";					
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			$row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry);
			$row['crdate']=time();
			$query = $GLOBALS['TYPO3_DB']->INSERTquery($undo_tables[$table], $row);
			$res = $GLOBALS['TYPO3_DB']->sql_query($query);		
			return $row;
		}
	}
	function ms_implode($char,$array,$fix='',$prefix,$addslashes=false)
	{
		$lem = array_keys($array);
		$char = htmlentities($char);
		for($i=0;$i<sizeof($lem);$i++) {
		  if($addslashes){
			  if ($array[$lem[$i]])			$str .= $prefix.$fix.(($i == sizeof($lem)-1) ? addslashes($array[$lem[$i]]).$fix : addslashes($array[$lem[$i]]).$fix.$char);
		  }else{
			  if ($array[$lem[$i]])			$str .= $prefix.$fix.(($i == sizeof($lem)-1) ? $array[$lem[$i]].$fix : $array[$lem[$i]].$fix.$char);
		  }
		}
		return $str;
	}	
	// function for saving the importer products images
	function saveImportedProductImages ($products_id,$input,$item,$oldproduct=array())
	{
		if (is_numeric($products_id))
		{
			global $server,$ms;
			for ($i=1;$i<4;$i++)
			{
				if ($i==1) 	$colname='products_image';
				else		$colname='products_image'.($i-1);				
				if(!$oldproduct[$colname])
				{
					if (strstr($input[($i-1)],'http://'))
					{
						if (strstr($input[($i-1)],'*')) $item[($i+3)] =str_replace("*",$item[($i+3)],$input[($i-1)]);
						else $item[($i+3)] =$input[($i-1)].$item[($i+3)];
					}
					if ($item[($i+3)])
					{
						$plaatje1=$item[($i+3)];
						$data=file_get_contents($plaatje1);
						if ($data)
						{
							$plaatje1_name=$products_id.'-'.($i+3).'-'.time();							
							$tmpfile=PATH_site.'uploads/tx_multishop/tmp/'.$plaatje1_name;
							file_put_contents($tmpfile,$data);					
							$plaatje1=$tmpfile;
							if (($extentie1=exif_imagetype($plaatje1)) && $plaatje1_name <> '')
							{
								$extentie1=image_type_to_extension($extentie1, false);
								$ext=$extentie1;
								$ix=0;	
								$filename=mslib_fe::rewritenamein($item[0]).'.'.$ext;
								$folder=mslib_befe::getImagePrefixFolder($filename);
								if (!is_dir(PATH_site.$ms['image_paths']['products']['original'].'/'.$folder))
								{
									t3lib_div::mkdir(PATH_site.$ms['image_paths']['products']['original'].'/'.$folder,0777);
								}
								$folder.='/';
								$target=PATH_site.$ms['image_paths']['products']['original'].'/'.$folder.$filename;
								if (file_exists($target))
								{
									do
									{		
										$filename=mslib_fe::rewritenamein($item[0]).($ix > 0?'-'.$ix:'').'.'.$ext;	
										$folder=mslib_befe::getImagePrefixFolder($filename);									
										if (!is_dir(PATH_site.$ms['image_paths']['products']['original'].'/'.$folder))
										{
											t3lib_div::mkdir(PATH_site.$ms['image_paths']['products']['original'].'/'.$folder,0777);
										}
										$folder.='/';
										$target=PATH_site.$ms['image_paths']['products']['original'].'/'.$folder.$filename;
										$ix++;
									} while (file_exists($target));
								}	
								// end
								$products_image=$path.'/'.$naam;
								// backup original
								$target=PATH_site.$ms['image_paths']['products']['original'].'/'.$folder.$filename;
								copy($tmpfile,$target);																				
								// backup original eof										
								$products_image_name=mslib_befe::resizeProductImage($target,$filename,PATH_site.t3lib_extMgm::siteRelPath($this->extKey),1);
								$item['img'][$i]=$products_image_name;
							}
							else $item['img'][$i]='';
						}
						else $item['img'][$i]='';
						if ($tmpfile and file_exists($tmpfile)) @unlink($tmpfile);
					}
					else $item['img'][$i]='';
				}	else $item['img'][$i]='';
			}
			if (count($item['img']) >0)
			{
				$array=array();
				for ($i=1;$i<4;$i++)
				{
					if ($item['img'][$i])
					{
						if ($i==1) 	$colname='products_image';
						else		$colname='products_image'.($i-1);
						$array[$colname]=$item['img'][$i];
					}
				}
				if (count($array) >0)
				{	
					if ($array['products_image'])
					{
						$array['contains_image']=1;
					}
					else $array['contains_image']=0;
					$query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_products', 'products_id='.$products_id,$array);
					$res = $GLOBALS['TYPO3_DB']->sql_query($query);					
				}
			}	
		}
	}
	// method for adding a product to the flat table for maximum speed
	function convertProductToFlat ($products_id,$table_name='tx_multishop_products_flat')
	{
		global $ms;
		if ($table_name=='tx_multishop_products_flat')
		{
			$str="DELETE FROM `tx_multishop_products_flat` where products_id='".$products_id."';";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		}
		// retrieving the products record
		$str="SELECT *, pd.language_id, p2c.sort_order, p.staffel_price as staffel_price, tr.tx_rate as tax_rate, IF(s.status, s.specials_new_products_price, p.products_price) as final_price from tx_multishop_products p left join tx_multishop_specials s on p.products_id = s.products_id left join tx_multishop_manufacturers m on p.manufacturers_id=m.manufacturers_id left join static_taxes tr on p.tax_id = tr.uid, tx_multishop_products_description pd, tx_multishop_products_to_categories p2c, tx_multishop_categories c, tx_multishop_categories_description cd where p.products_status=1 and p.page_uid='".$this->shop_pid."' and p2c.products_id='".$products_id."' and p.products_id=pd.products_id and p.products_id=p2c.products_id and p2c.categories_id=c.categories_id and p2c.categories_id=cd.categories_id and pd.language_id=cd.language_id order by pd.language_id";
		$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		$rows=$GLOBALS['TYPO3_DB']->sql_num_rows($qry);
		if ($rows)
		{
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{			
				// retrieving the categories path
				$flat_product=array();
				$flat_product['language_id']					=	$row['language_id'];
				$flat_product['products_id']					=	$products_id;
				$flat_product['products_name']					=	$row['products_name'];
				$flat_product['products_model']					=	$row['products_model'];
				$flat_product['ean_code']						=	$row['ean_code'];
				$flat_product['products_description']			=	$row['products_description'];
				$flat_product['products_shortdescription']		=	$row['products_shortdescription'];
				$flat_product['products_extra_description']		=	$row['products_extra_description'];
				$flat_product['products_quantity']				=	$row['products_quantity'];
				$flat_product['products_price']					=	$row['products_price'];
				$flat_product['products_viewed']				=	$row['products_viewed'];
				$flat_product['staffel_price']					=	$row['staffel_price'];
				$flat_product['specials_new_products_price']	=	$row['specials_new_products_price'];
				if ($row['specials_new_products_price'])
				{
					$flat_product['final_price'] = $row['specials_new_products_price'];
					$flat_product['sstatus'] = 1;
				}
				else											$flat_product['final_price'] = $row['products_price'];
				if ($server['HTTP_HOST']=='www.prijsvechter.nl')
				{			
					if ($flat_product['final_price'] < $row['products_price'])
					{
						$flat_product['final_price_difference']=$row['products_price']-$flat_product['final_price'];
					}
				}
				// now we are going to define the price filter start value, so we can search very fast on it
				$array=explode(";",$ms['MODULES']['PRICE_FILTER_BOX_STEPPINGS']);
				$total=count($array);
				$tel=0;
				foreach ($array as $item)
				{
					$tel++;				
					$cols=explode("-",$item);
					if ($flat_product['final_price'] <= $cols[1])
					{
						$flat_product['price_filter']=$cols[0];
						break;
					}
					if ($tel==$total)
					{
						if ($flat_product['final_price'] > $cols[1])	$flat_product['price_filter']=$cols[1];
					}
				}
				// now we are going to define the price filter start value, so we can search very fast on it eof
				$flat_product['products_multiplication']		=	$row['products_multiplication'];
				$flat_product['minimum_quantity']				=	$row['minimum_quantity'];
				$flat_product['maximum_quantity']				=	$row['maximum_quantity'];				
				$flat_product['products_date_available']		=	$row['products_date_available'];
				$flat_product['products_last_modified']			=	$row['products_last_modified'];
				$flat_product['tax_id']							=	$row['tax_id'];
				$flat_product['tax_rate']						=	$row['tax_rate'];
				$flat_product['categories_id']					=	$row['categories_id'];
				$flat_product['categories_name']				=	$row['categories_name'];
				$flat_product['manufacturers_id']				=	$row['manufacturers_id'];
				$flat_product['manufacturers_name']				=	$row['manufacturers_name'];
				$flat_product['products_negative_keywords']		=	$row['products_negative_keywords'];
				$flat_product['products_meta_title']			=	$row['products_meta_title'];
				$flat_product['products_meta_description']		=	$row['products_meta_description'];
				$flat_product['products_meta_keywords']			=	$row['products_meta_keywords'];
				$flat_product['products_url']					=	$row['products_url'];
				$flat_product['language_id']					=	$row['language_id'];
				if ($flat_product['categories_id'])
				{
					// get all cats to generate multilevel fake url
					$level=0;
					$cats=mslib_fe::Crumbar($flat_product['categories_id']);
					$cats=array_reverse($cats);
					$where='';
					if (count($cats) > 0)
					{
						$i=0;
						foreach ($cats as $cat)
						{
							$flat_product['categories_id_'.$i]			=	$cat['id'];
							$flat_product['categories_name_'.$i]		=	$cat['name'];
							$i++;
						}
					}
					// get all cats to generate multilevel fake url eof
				}
				$flat_product['contains_image']					=	$row['contains_image'];
				$flat_product['products_image']					=	$row['products_image'];
				$flat_product['products_image1']				=	$row['products_image1'];
				$flat_product['products_image2']				=	$row['products_image2'];
				$flat_product['products_image3']				=	$row['products_image3'];
				$flat_product['products_image4']				=	$row['products_image4'];
				$flat_product['products_date_added']			=	$row['products_date_added'];
				$flat_product['products_weight']				=	$row['products_weight'];
				$flat_product['sort_order']						=	$row['sort_order'];
				$flat_product['product_capital_price']			=	$row['product_capital_price'];
				$flat_product['page_uid']						=	$row['page_uid'];
				if ($ms['MODULES']['FLAT_DATABASE_EXTRA_ATTRIBUTE_OPTION_COLUMNS'] and is_array($ms['FLAT_DATABASE_ATTRIBUTE_OPTIONS']))
				{			
					foreach ($ms['FLAT_DATABASE_ATTRIBUTE_OPTIONS'] as $option_id => $array)
					{
						if ($option_id)
						{
							$option_values=mslib_fe::getProductsOptionValues($option_id,$flat_product['products_id']);
							if ($option_values[0]['products_options_values_name'])
							{
								$flat_product[$array[0]]			=	$option_values[0]['products_options_values_name'];
							}
						}			
					}
				}			
				$query = $GLOBALS['TYPO3_DB']->INSERTquery($table_name, $flat_product);
				$res = $GLOBALS['TYPO3_DB']->sql_query($query);
			}
			return $flat_product['products_id'];	
		}
	}	
	// method for scanning subfolders and retrieve their associated files
	function listdir($dir='.') { 
		if (!is_dir($dir)) { 
			return false; 
		} 		
		$files = array(); 
		mslib_befe::listdiraux($dir, $files); 	
		return $files; 
	} 	
	// method for scanning subfolders and retrieve their associated files
	function listdiraux($dir, &$files) { 
		$handle = opendir($dir); 
		while (($file = readdir($handle)) !== false) { 
			if ($file == '.' || $file == '..') { 
				continue; 
			} 
			$filepath = $dir == '.' ? $file : $dir . '/' . $file; 
			if (is_link($filepath)) 
				continue; 
			if (is_file($filepath)) 
				$files[] = $filepath; 
			else if (is_dir($filepath)) 
				mslib_befe::listdiraux($filepath, $files); 
		} 
		closedir($handle); 
	}	
	function tep_get_categories_select($categories_id='0', $aid='',$level=0,$selectedid='')
	{
		 $parent_categories_query = $GLOBALS['TYPO3_DB']->sql_query("SELECT cd.categories_name, c.categories_id, c.parent_id from tx_multishop_categories c, tx_multishop_categories_description cd where c.parent_id='" . $categories_id . "' and c.status=1 and c.categories_id=cd.categories_id and c.page_uid='".$this->shop_pid."' order by c.sort_order, cd.categories_name");
		$rows=$GLOBALS['TYPO3_DB']->sql_num_rows($parent_categories_query);
		while ($parent_categories = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($parent_categories_query))
		{
			$html .= '<option value="'.$parent_categories['categories_id'].'" '.(($selectedid==$parent_categories['categories_id']) ?'selected':'').'>';
			for ($i=0;$i<$level;$i++)	$html	.='--';
			$html	.= $parent_categories['categories_name'].'</option>';
			$strchk="select * from tx_multishop_categories where parent_id='".$parent_categories['categories_id']."'";
			$qrychk=$GLOBALS['TYPO3_DB']->sql_query($strchk);
			if ($GLOBALS['TYPO3_DB']->sql_num_rows($qrychk))
			{
				$html .=mslib_befe::tep_get_categories_select($parent_categories['categories_id'],$aid,($level+1),$selectedid);
			}
		}
		if (!$categories_id) $html .='</select>';
		return $html;
	}	
	function tep_get_chained_categories_select($categories_id='0', $aid='',$level=0,$selectedid='')
	{
		if (!$categories_id) $categories_id=0;
		$output=array();		
		$parent_categories_query = $GLOBALS['TYPO3_DB']->sql_query("SELECT cd.categories_name, c.categories_id, c.parent_id from tx_multishop_categories c, tx_multishop_categories_description cd where c.parent_id='" . $categories_id . "' and c.status=1 and c.categories_id=cd.categories_id and c.page_uid='".$this->shop_pid."' order by c.sort_order, cd.categories_name");
		$rows=$GLOBALS['TYPO3_DB']->sql_num_rows($parent_categories_query);
		while ($parent_categories = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($parent_categories_query))
		{
			$output[$level] .= '<option value="'.$parent_categories['categories_id'].'" '.(($selectedid==$parent_categories['categories_id']) ?'selected':'').' class="'.($level>0?''.$parent_categories['parent_id']:'').'">'.$parent_categories['categories_name'].'</option>';
			$strchk="select * from tx_multishop_categories where parent_id='".$parent_categories['categories_id']."'";
			$qrychk=$GLOBALS['TYPO3_DB']->sql_query($strchk);
			if ($GLOBALS['TYPO3_DB']->sql_num_rows($qrychk))
			{
				$tmp_array=mslib_befe::tep_get_chained_categories_select($parent_categories['categories_id'],$aid,($level+1),$selectedid);
				foreach ($tmp_array as $key => $value)
				{
					$output[$key].=$value;
				}				
			}
		}
		return $output;
	}	
	function array2json($arr)
	{
		if(function_exists('json_encode')) return json_encode($arr); //Lastest versions of PHP already has this functionality.
		$parts = array();
		$is_list = false;
	
		//Find out if the given array is a numerical array
		$keys = array_keys($arr);
		$max_length = count($arr)-1;
		if(($keys[0] == 0) and ($keys[$max_length] == $max_length)) {//See if the first key is 0 and last key is length - 1
			$is_list = true;
			for($i=0; $i<count($keys); $i++) { //See if each key correspondes to its position
				if($i != $keys[$i]) { //A key fails at position check.
					$is_list = false; //It is an associative array.
					break;
				}
			}
		}
		foreach($arr as $key=>$value) 
		{
			if(is_array($value)) { //Custom handling for arrays
				if($is_list) $parts[] = array2json($value); /* :RECURSION: */
				else $parts[] = '"' . $key . '":' . array2json($value); /* :RECURSION: */
			} else {
				$str = '';
				if(!$is_list) $str = '"' . $key . '":';
	
				//Custom handling for multiple data types
				if(is_numeric($value)) $str .= $value; //Numbers
				elseif($value === false) $str .= 'false'; //The booleans
				elseif($value === true) $str .= 'true';
				else $str .= '"' . addslashes($value) . '"'; //All other things
				// :TODO: Is there any more datatype we should be in the lookout for? (Object?)
	
				$parts[] = $str;
			}
		}
		$json = implode(',',$parts);
		if($is_list) return '[' . $json . ']';//Return numerical JSON
		return '{' . $json . '}';//Return associative JSON
	}
	function rebuildFlatDatabase ()
	{
		global $ms;
		$content.='<div class="main-heading"><h1>Rebuild Flat Database</h1></div>';
		$str="DROP TABLE IF EXISTS `tx_multishop_products_flat_tmp`;";
		$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		$str="CREATE TABLE `tx_multishop_products_flat_tmp` (
		  `products_id` int(11) NOT NULL AUTO_INCREMENT,
		  `language_id` TINYINT(2)  NOT NULL DEFAULT '0',
		  `products_name` varchar(255) NOT NULL,
		  `products_model` varchar(128) NOT NULL,
		  `products_shortdescription` varchar(255) NOT NULL,
		  `products_description` text NOT NULL,
		  `products_quantity` int(11) NOT NULL,
		  `products_price` decimal(10,4) NOT NULL,
		  `staffel_price` varchar(127) NOT NULL,
		  `ean_code` varchar(13) NOT NULL,
		  `sku_code` varchar(25) NOT NULL,
		  `specials_new_products_price` decimal(10,4) NOT NULL,
		  `final_price` decimal(10,4) NOT NULL,
		  `final_price_difference` decimal(10,4) NOT NULL,
		  `products_date_available` int(11) NOT NULL,
		  `products_last_modified` int(11) NOT NULL,
		  `tax_id` int(5) NOT NULL,
		  `tax_rate` decimal(4,3) NOT NULL,
		  `categories_id` int(5) NOT NULL,
		  `categories_name` varchar(150) NOT NULL,
		  `manufacturers_id` int(5) NOT NULL,
		  `manufacturers_name` varchar(32) NOT NULL,
		  `categories_id_0` int(5) NOT NULL,
		  `categories_name_0` varchar(150) NOT NULL,
		  `categories_id_1` int(5) NOT NULL,
		  `categories_name_1` varchar(150) NOT NULL,
		  `categories_id_2` int(5) NOT NULL,
		  `categories_name_2` varchar(150) NOT NULL,
		  `categories_id_3` int(5) NOT NULL,
		  `categories_name_3` varchar(150) NOT NULL,
		  `categories_id_4` int(5) NOT NULL,
		  `categories_name_4` varchar(150) NOT NULL,
		  `categories_id_5` int(5) NOT NULL,
		  `categories_name_5` varchar(150) NOT NULL,
		  `products_image` varchar(250) NOT NULL,
		  `products_image1` varchar(250) NOT NULL,
		  `products_image2` varchar(250) NOT NULL,
		  `products_image3` varchar(250) NOT NULL,
		  `products_image4` varchar(250) NOT NULL,
		  `products_viewed` int(11) NOT NULL,  
		  `products_date_added` int(11) NOT NULL,
		  `products_weight` decimal(5,2) NOT NULL,
		  `sort_order` int(11) NOT NULL,
		  `product_capital_price` decimal(10,4) NOT NULL,
		  `page_uid` int(11) NOT NULL,
		  `products_extra_description` text NOT NULL,
		  `products_negative_keywords` varchar(254) NOT NULL,
		  `products_meta_title` varchar(254) NOT NULL,
		  `products_meta_description` varchar(254) NOT NULL,
		  `products_meta_keywords` varchar(254) NOT NULL,
		  `products_url` varchar(255) NOT NULL,
		  `sstatus` tinyint(1) NOT NULL,
		  `price_filter` int(4) NOT NULL,
		  `contains_image` TINYINT(1) NOT NULL,
		  `products_multiplication` int(11) NOT NULL DEFAULT '0',
		  `minimum_quantity` int(11) NOT NULL DEFAULT '1',
		  `maximum_quantity` int(11) NOT NULL,
";
		if ($ms['MODULES']['FLAT_DATABASE_EXTRA_ATTRIBUTE_OPTION_COLUMNS'] and is_array($ms['FLAT_DATABASE_ATTRIBUTE_OPTIONS']))
		{		
			foreach ($ms['FLAT_DATABASE_ATTRIBUTE_OPTIONS'] as $option_id => $array)
			{
				if ($array[0] and $array[1])
				{
					$str.="		  `".$array[0]."` ".$array[1]." NOT NULL,"."\n";
					$additional_indexes.="KEY `".$array[0]."` (`".$array[0]."`),"."\n";
				}			
			}
		}
		$str.="PRIMARY KEY (`products_id`),
		  KEY `language_id` (`language_id`),
		  KEY `products_name_2` (`products_name`),
		  KEY `products_model` (`products_model`),
		  KEY `sstatus` (`sstatus`),
		  KEY `final_price_difference` (`final_price_difference`),
		  KEY `combined_cat_index` (`categories_id_0`,`categories_id_1`,`categories_id_2`,`categories_id_3`,`categories_id_4`,`categories_id_5`),
		  KEY `combined_specials` (`page_uid`,`sstatus`),
		  KEY `combined_categories_id` (`page_uid`,`categories_id`),
		  KEY `combined_one` (`page_uid`,`categories_id`,`sstatus`),
		  KEY `sort_order` (`sort_order`),
		  KEY `page_uid` (`page_uid`),
		  KEY `categories_id` (`categories_id`),
		  KEY `combined_three` (`page_uid`,`categories_id`,`sort_order`),
		  KEY `categories_id_0` (`categories_id_0`),
		  KEY `categories_id_3` (`categories_id_3`),
		  KEY `categories_id_2` (`categories_id_2`),
		  KEY `categories_id_1` (`categories_id_1`),
		  KEY `categories_id_4` (`categories_id_4`),
		  KEY `categories_id_5` (`categories_id_5`),
		  KEY `products_date_added` (`products_date_added`),
		  KEY `products_last_modified` (`products_last_modified`),
		  KEY `final_price` (`final_price`),
		  KEY `combined_four` (`sort_order`,`categories_id`),
		  KEY `combined_five` (`categories_id_0`,`categories_id_1`,`categories_id_2`,`categories_id_3`,`final_price`),
		  KEY `price_filter` (`price_filter`),
		  KEY `manufacturers_id` (`manufacturers_id`),
		  KEY `contains_image` (`contains_image`),
		  KEY `sku_code` (`sku_code`),
		  ".$additional_indexes."
		  FULLTEXT KEY `products_name` (`products_name`),
		  FULLTEXT KEY `products_model_2` (`products_model`),
		  FULLTEXT KEY `products_model_3` (`products_model`,`products_name`)
		  
		) TYPE=MyISAM ;
		";
		$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		$products=array();
		//$str="truncate tx_multishop_products_flat";
		//$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		$str="SELECT products_id from `tx_multishop_products` where products_status=1 order by sort_order";
		$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
		{	
			$products[]=$row['products_id'];
		}
		foreach ($products as $products_id)
		{
			mslib_befe::convertProductToFlat($products_id,'tx_multishop_products_flat_tmp');
		}
		$str="ANALYZE TABLE `tx_multishop_products_flat_tmp`";
		$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		$str="drop table `tx_multishop_products_flat`;";
		$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		// convert to memory table
		//$str="CREATE TABLE tx_multishop_products_flat ENGINE=MEMORY AS SELECT * FROM tx_multishop_products_flat_tmp";
		//$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		//$str="drop table `tx_multishop_products_flat_tmp`;";
		//$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		// if not using memory table rename the tmp table
		$str="RENAME TABLE `tx_multishop_products_flat_tmp` TO `tx_multishop_products_flat`;";
		$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
		return $content;
	}
	function convToUtf8($content)
	{ 
		if(!mb_check_encoding($content, 'UTF-8') 
			OR !($content === mb_convert_encoding(mb_convert_encoding($content, 'UTF-32', 'UTF-8' ), 'UTF-8', 'UTF-32'))) { 
	
			$content = mb_convert_encoding($content, 'UTF-8'); 
	
			if (mb_check_encoding($content, 'UTF-8')) { 
				// log('Converted to UTF-8'); 
			} else { 
				// log('Could not converted to UTF-8'); 
			} 
		} 
		return $content; 
	}
	function detect_encoding($string)
	{  
	  static $list = array('utf-8', 'windows-1251');
	  foreach ($list as $item) {
		$sample = iconv($item, $item, $string);
		if (md5($sample) == md5($string))
		  return $item;
	  }
	  return null;
	}		
	function loadCurrency($country_iso)
	{
		if (is_numeric($country_iso))
		{
			$data	= $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('cu_symbol_left',' static_currencies','cu_iso_nr=\''.$country_iso.'\'','');		
			return $data[0]['cu_symbol_left'];		
		}
	}
	function print_r($array)
	{
		echo '<pre>';
		print_r($array);
		echo '</pre>';
	}
	function Week($week)
	{
		$week = $week;
		$year = date('Y');
		$lastweek=$week-1;
		if ($lastweek==0){
			$week = 52;
			$year--;
		}
		$lastweek=sprintf("%02d", $lastweek);
		for ($i=1;$i<=7;$i++){
			$arrdays[] = strtotime("$year". "W$lastweek"."$i");
		}
		return $arrdays;
	}
	function RunMultishopUpdate ($multishop_page_uid='')
	{
		$settings=array();
		$query = $GLOBALS['TYPO3_DB']->SELECTquery(
						'*',         // SELECT ...
						'tx_multishop_configuration_values',     // FROM ...
						'page_uid="'.$multishop_page_uid.'"',    // WHERE...
						'',            // GROUP BY...
						'',    // ORDER BY...
						''            // LIMIT ...
		);
		$res = $GLOBALS['TYPO3_DB']->sql_query($query);
		if ($GLOBALS['TYPO3_DB']->sql_num_rows($res) > 0)
		{
			while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))
			{
				if (isset($row['configuration_value']) and $row['configuration_value'] != '') $settings['LOCAL_MODULES'][$row['configuration_key']]=$row['configuration_value'];
			}	
		}
		// load local front-end module config eof
		// load global front-end module config
		$query = $GLOBALS['TYPO3_DB']->SELECTquery(
						'*',         // SELECT ...
						'tx_multishop_configuration',     // FROM ...
						'',    // WHERE...
						'',            // GROUP BY...
						'',    // ORDER BY...
						''            // LIMIT ...
		);
		$res = $GLOBALS['TYPO3_DB']->sql_query($query);
		if ($GLOBALS['TYPO3_DB']->sql_num_rows($res) > 0)
		{
			while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))
			{
				if (isset($row['configuration_value'])) $settings['GLOBAL_MODULES'][$row['configuration_key']]=$row['configuration_value'];
			}	
		}
		// load global front-end module config eof
		// merge global with local front-end module config
		foreach ($settings['GLOBAL_MODULES'] as $key => $value)
		{
			if (isset($settings['LOCAL_MODULES'][$key]))	$settings[$key]=$settings['LOCAL_MODULES'][$key];
			else											$settings[$key]=$value;
		}
		// merge global with local front-end module config eof	
		if ($settings['COUNTRY_ISO_NR'])
		{
			if ($settings['COUNTRY_ISO_NR']==528)
			{
				// dutch
				$settings['CURRENCY']='&#8364;';
			}
			else $settings['CURRENCY']=mslib_befe::loadCurrency($settings['COUNTRY_ISO_NR']);
		}								 
		// check database
		$messages=array();
		$skip=0;
		$settings['update_database']=1;
//		if ($this->ADMIN_USER and !$skip) $settings['update_database']=1;
		set_time_limit(86400); 
		ignore_user_abort(true);		
		if ($settings['update_database'])
		{
			$str="select sku_code from tx_multishop_products limit 1";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{
				$str="ALTER TABLE  `tx_multishop_products` ADD  `sku_code` VARCHAR( 25 ) NOT NULL default ''";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
				$messages[]=$str;
				$str="ALTER TABLE  `tx_multishop_products_flat` ADD  `sku_code` VARCHAR( 25 ) NOT NULL default ''";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
				$messages[]=$str;
				$str="ALTER TABLE  `tx_multishop_undo_products` ADD  `sku_code` VARCHAR( 25 ) NOT NULL default ''";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
				$messages[]=$str;
				$str="ALTER TABLE  `tx_multishop_products` ADD INDEX `sku_code` (  `sku_code` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
			}			
			
			$str="select shipping_method_label from tx_multishop_orders limit 1";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{
				$str="ALTER TABLE  `tx_multishop_orders` ADD  `shipping_method_label` VARCHAR( 150 ) NOT NULL ,
ADD  `payment_method_label` VARCHAR( 150 ) NOT NULL ,
ADD  `discount` DECIMAL( 10, 4 ) NOT NULL";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
				$messages[]=$str;
			}			


			$str="select max_usage from tx_multishop_coupons limit 1";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{
				$str="ALTER TABLE  `tx_multishop_coupons` ADD  `crdate` INT( 11 ) NOT NULL ,
				ADD  `max_usage` INT( 11 ) NOT NULL,
				ADD  `discount_type` VARCHAR( 25 ) NOT NULL DEFAULT  'percentage'
				";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
				$messages[]=$str;
			}			
			$str="select id from tx_multishop_product_feeds limit 1";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{
				$str="CREATE TABLE `tx_multishop_product_feeds` (
				  `id` int(11) NOT NULL AUTO_INCREMENT,
				  `name` varchar(75) NOT NULL,
				  `page_uid` int(11) NOT NULL,
				  `crdate` int(11) NOT NULL,
				  `utm_source` varchar(75) NOT NULL,
				  `utm_medium` varchar(75) NOT NULL,
				  `utm_term` varchar(75) NOT NULL,
				  `utm_content` varchar(75) NOT NULL,
				  `utm_campaign` varchar(75) NOT NULL,
				  `fields` text NOT NULL,
				  `format` varchar(25) NOT NULL,
				  `delimiter` varchar(10) NOT NULL,
				  `code` varchar(150) NOT NULL,
				  `status` tinyint(1) NOT NULL DEFAULT '0',
				  PRIMARY KEY (`id`),
				  KEY `code` (`code`)
				) TYPE=MyISAM;
				";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
				$messages[]=$str;
			}			
			$str="describe `tx_multishop_payment_transactions`";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				if ($row['Field']=='transaction_id')
				{
					if ($row['Type']=='varchar(65)')
					{
						$str="ALTER TABLE  `tx_multishop_payment_transactions` CHANGE  `transaction_id`  `transaction_id` VARCHAR( 150 ) NOT NULL";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
						$messages[]=$str;							
					}
				}
			}
			$key='ADMIN_EDIT_ORDER_TYPE';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Admin Edit Order Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the admin edit order page. Example value: fileadmin/scripts/admin_edit_order)', 11, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$messages[]=$str;
			}
			$key='ADMIN_PRODUCTS_EDIT_TYPE';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Admin Products Edit Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the admin products edit page. Example value: fileadmin/scripts/admin_products_edit)', 11, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$messages[]=$str;
			}			
			$key='SHOPPING_CART_TYPE';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Shopping cart Type', '".$key."', '', 'Optional field (leave empty to use the default). Use this for customizing the shopping cart page. Example value: fileadmin/scripts/shopping_cart)', 11, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$messages[]=$str;
			}			
			$indexes=array();
			$table_name='tx_multishop_configuration_values';
			$str="show indexes from `".$table_name."` ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				$indexes[]=$rs['Key_name'];
			}
			if (!in_array('configuration_key',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_configuration_values` ADD INDEX `configuration_key` (  `configuration_key` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$messages[]=$str;	
				$str="ALTER TABLE  `tx_multishop_configuration_values` ADD INDEX `page_uid` (  `page_uid` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$messages[]=$str;	
				$str="ALTER TABLE  `tx_multishop_configuration_values` ADD FULLTEXT `configuration_value` (`configuration_value`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$messages[]=$str;	
				$str="ALTER TABLE  `tx_multishop_configuration_values` ADD INDEX  `admin_search` (  `configuration_key` ,  `page_uid` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$messages[]=$str;	
				$str="ALTER TABLE  `tx_multishop_configuration` ADD INDEX `configuration_title` (  `configuration_title` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$messages[]=$str;	
				$str="ALTER TABLE  `tx_multishop_configuration` ADD FULLTEXT `configuration_value` (`configuration_value`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$messages[]=$str;	
				$str="ALTER TABLE  `tx_multishop_configuration` ADD INDEX  `admin_search` (  `configuration_title` ,  `configuration_key` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$messages[]=$str;	
				$str="ALTER TABLE  `fe_users` ADD INDEX  `disable` (`disable`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$messages[]=$str;	
				$str="ALTER TABLE  `fe_users` ADD INDEX  `deleted` (`deleted`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$messages[]=$str;	
				$str="ALTER TABLE  `fe_users` ADD INDEX  `admin_search` (`company`,`name`,`email`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$messages[]=$str;	
				$str="ALTER TABLE  `tx_multishop_orders` ADD INDEX `deleted` (  `deleted` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$messages[]=$str;	
				$str="ALTER TABLE  `tx_multishop_orders` ADD INDEX `crdate` (  `crdate` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$messages[]=$str;	
			}		
			$str="select * from tx_multishop_configuration_group where id='11'";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
			{
				$str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(11, 'Admin Settings', '', NULL, 1);";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
			}			
			$key='PRODUCT_EDIT_METHOD_FILTER';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product edit method filter', '".$key."', '0', 'Enables the shipping / payment methods filter on the product edit page.', 11, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$messages[]=$str;
			}			
			$str="select hide_in_cart from tx_multishop_products_options";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE `tx_multishop_products_options` ADD  `hide_in_cart` TINYINT( 1 ) NOT NULL DEFAULT '0', ADD INDEX (`hide_in_cart`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
			}			
			$str="describe `tx_multishop_products`";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				if ($row['Field']=='products_price')
				{
					if ($row['Type']=='decimal(8,2)')
					{
						$str="ALTER TABLE  `tx_multishop_products` CHANGE  `products_price`  `products_price` decimal(10,4) DEFAULT  '0.0000'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
						$messages[]=$str;							
						$str="ALTER TABLE  `tx_multishop_products_flat` CHANGE  `products_price`  `products_price` decimal(10,4) DEFAULT  '0.0000'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
						$messages[]=$str;							
						
						$str="ALTER TABLE  `tx_multishop_products_attributes` CHANGE  `options_values_price`  `options_values_price` decimal(10,4) DEFAULT  '0.0000'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
						$messages[]=$str;
						$str="ALTER TABLE  `tx_multishop_products_attributes` CHANGE  `dealer_price`  `dealer_price` decimal(10,4) DEFAULT  '0.0000'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
						$messages[]=$str;						
						$str="ALTER TABLE  `tx_multishop_specials` CHANGE  `dealer_price`  `dealer_price` decimal(10,4) DEFAULT  '0.0000'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);						
						$messages[]=$str;							
						$str="ALTER TABLE  `tx_multishop_specials` CHANGE  `specials_new_products_price`  `specials_new_products_price` decimal(10,4) DEFAULT  '0.0000'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);						
						$messages[]=$str;							
						$str="ALTER TABLE  `tx_multishop_specials` CHANGE  `specials_vanaf_price`  `specials_vanaf_price` decimal(10,4) DEFAULT  '0.0000'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);						
						$messages[]=$str;	
						$str="ALTER TABLE  `tx_multishop_orders_products_attributes` CHANGE  `options_values_price`  `options_values_price` decimal(10,4) DEFAULT  '0.0000'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);						
						$messages[]=$str;	
					}
				}
			}			
			$key='ULTRASEARCH';
			if (isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="delete from `tx_multishop_configuration` where configuration_key='".$key."';";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$messages[]=$str;
			}
			$key='ULTRASEARCH_TYPE';
			if (isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="delete from `tx_multishop_configuration` where configuration_key='".$key."';";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);					
				$messages[]=$str;
			}			
			$key='PRODUCTS_RELATIVES_TYPE';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Products Relatives Type', '".$key."', 'default', 'The lay-out type for displaying the products relatives on the products detail page.', 7, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$messages[]=$str;
			}						
			$str="select billing_address_number from tx_multishop_orders";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `tx_multishop_orders` ADD  `billing_address_number` varchar( 10 ) DEFAULT NULL";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
			}				
			$str="select delivery_address_number from tx_multishop_orders";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `tx_multishop_orders` ADD  `delivery_address_number` varchar( 10 ) DEFAULT NULL";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
			}				
			$str="select products_id from tx_multishop_products_method_mappings";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="CREATE TABLE  `tx_multishop_products_method_mappings` (
`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`products_id` INT( 11 ) NOT NULL ,
`method_id` INT( 11 ) NOT NULL ,
`type` VARCHAR( 25 ) NOT NULL ,
`negate` TINYINT( 1 ) NOT NULL ,
INDEX (  `products_id` ,  `method_id` ,  `type` , `negate` )
) ENGINE = MYISAM ;
";	
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
			}				
		

			$str="select sort_order from tx_multishop_products_options_values_to_products_options";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `tx_multishop_products_options_values_to_products_options` ADD  `sort_order` INT( 11 ) NOT NULL, ADD INDEX (  `sort_order` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
			}			
			$str="select minimum_quantity from tx_multishop_products";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `tx_multishop_products` ADD  `minimum_quantity` INT( 11 ) NOT NULL DEFAULT '1'";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
				$str="ALTER TABLE  `tx_multishop_products_flat` ADD  `minimum_quantity` INT( 11 ) NOT NULL DEFAULT '1'";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;						
			}
			$str="select maximum_quantity from tx_multishop_products";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `tx_multishop_products` ADD  `maximum_quantity` INT( 11 ) NOT NULL";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;	
				$str="ALTER TABLE  `tx_multishop_products_flat` ADD  `maximum_quantity` INT( 11 ) NOT NULL";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;					
			}			
			$key='DB_PRICES_INCLUDE_VAT';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Database prices are stored including VAT', '".$key."', '0', 'Enable this when you want to store the prices in the database including VAT.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'',''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;
			}			
			$key='SEARCH_ALSO_IN_PRODUCTS_DESCRIPTION';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Search also in products description', '".$key."', '0', 'This enables the search-engine to also search in the products description.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'',''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$messages[]=$str;
			}			
			$indexes=array();
			$table_name='tx_multishop_products_to_relative_products';
			$str="show indexes from `".$table_name."` ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				$indexes[]=$rs['Key_name'];
			}
			if (!in_array('pid_to_relative_id',$indexes))
			{
				$str="ALTER TABLE  `".$table_name."` ADD INDEX `pid_to_relative_id` (  `products_id`,`relative_product_id` )	";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$messages[]=$str;	
			}			
			if (!in_array('relative_to_pid_id',$indexes))
			{
				$str="ALTER TABLE  `".$table_name."` ADD INDEX `relative_to_pid_id` (  `relative_product_id`,`products_id` )	";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$messages[]=$str;	
			}				
			$str="describe tx_multishop_products_flat";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				if ($row['Field']=='language_id')
				{
					if ($row['Type']=='int(5)')
					{
						$str="ALTER TABLE  `tx_multishop_products_flat` CHANGE  `language_id`  `language_id` TINYINT( 2 ) NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
						$messages[]=$str;							
					}
				}
			}
			$str="describe tx_multishop_products";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				if ($row['Field']=='products_model')
				{
					if ($row['Type'] !='varchar(128)')
					{
						$str="ALTER TABLE  `tx_multishop_products` CHANGE  `products_model`  `products_model` varchar(128) NULL";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
						$messages[]=$str;							
						$str="ALTER TABLE  `tx_multishop_products_flat` CHANGE  `products_model`  `products_model` varchar(128) NULL";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
						$messages[]=$str;	
						$str="ALTER TABLE  `tx_multishop_orders_products` CHANGE  `products_model`  `products_model` varchar(128) NULL";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
						$messages[]=$str;	
					}
				}
			}			
			$str="describe tx_multishop_specials_sections";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				if ($row['Field']=='name')
				{
					if ($row['Type']=='varchar(15)')
					{
						$str="ALTER TABLE  `tx_multishop_specials_sections` CHANGE  `name`  `name` VARCHAR( 30 ) NULL DEFAULT NULL";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
						$messages[]=$str;							
					}
				}
			}	
			$str="select file_label from tx_multishop_orders_products";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `tx_multishop_orders_products` ADD `file_label` VARCHAR( 250 ) NOT NULL DEFAULT '', ADD `file_location` VARCHAR( 250 ) NOT NULL DEFAULT '', ADD `file_downloaded` INT(11) NOT NULL DEFAULT '0', ADD `file_download_code` VARCHAR( 32 ) NOT NULL DEFAULT '0', ADD `file_locked` TINYINT(1) NOT NULL DEFAULT '0', ADD INDEX (`file_download_code`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			

				$str="ALTER TABLE  `tx_multishop_products_description` ADD `file_label` VARCHAR( 250 ) NOT NULL DEFAULT '', ADD `file_location` VARCHAR( 250 ) NOT NULL DEFAULT ''";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
			}	


			$str="select products_multiplication from tx_multishop_products";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `tx_multishop_products` ADD  `products_multiplication` INT( 11 ) NOT NULL";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;
				$str="ALTER TABLE  `tx_multishop_products_flat` ADD  `products_multiplication` INT( 11 ) NOT NULL";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;				
			}	

			$str="select tx_multishop_discount from fe_groups";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `fe_groups` ADD  `tx_multishop_discount` INT( 2 ) NOT NULL,ADD INDEX (  `tx_multishop_discount` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
			}	
			$str="select code from tx_multishop_payment_transactions";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `tx_multishop_payment_transactions` ADD `code` VARCHAR( 35 ) NOT NULL";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
			}			
			$str="select tx_multishop_discount from fe_users";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `fe_users` ADD  `tx_multishop_discount` INT( 2 ) NOT NULL,ADD INDEX (  `tx_multishop_discount` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
			}	
			$str="select languages_id from tx_multishop_reviews_description limit 1";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($qry)
			{	
				$str="ALTER TABLE  `tx_multishop_reviews_description` CHANGE  `languages_id`  `language_id` TINYINT( 2 ) NOT NULL DEFAULT  '0'";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$str="ALTER TABLE  `tx_multishop_reviews_description` DROP  `languages_id`";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
			}			
			
			$str="select languages_id from tx_multishop_cms_description limit 1";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($qry)
			{	
				$str="ALTER TABLE  `tx_multishop_cms_description` CHANGE  `languages_id`  `language_id` TINYINT( 2 ) NOT NULL DEFAULT  '0'";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
				$str="ALTER TABLE  `tx_multishop_cms_description` DROP  `languages_id` ";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);				
				$messages[]=$str;																			
			}			
			$str="select languages_id from tx_multishop_manufacturers_cms limit 1";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($qry)
			{	
				$str="ALTER TABLE  `tx_multishop_manufacturers_cms` CHANGE  `languages_id`  `language_id` TINYINT( 2 ) NOT NULL DEFAULT  '0'";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
				$str="ALTER TABLE  `tx_multishop_manufacturers_cms` DROP  `languages_id` ";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);						
				$messages[]=$str;																			
			}			
			$str="select languages_id from tx_multishop_manufacturers_info limit 1";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($qry)
			{	
				$str="ALTER TABLE  `tx_multishop_manufacturers_info` CHANGE  `languages_id`  `language_id` TINYINT( 2 ) NOT NULL DEFAULT  '0'";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);					
				$messages[]=$str;							
				$str="ALTER TABLE  `tx_multishop_manufacturers_info` DROP  `languages_id` ";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);				
				$messages[]=$str;							
			}	
			$str="describe tx_multishop_configuration_values";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				if ($row['Field']=='configuration_value')
				{
					if ($row['Type']=='varchar(254)')
					{
						$str="ALTER TABLE `tx_multishop_configuration_values` CHANGE  `configuration_value`  `configuration_value` TEXT DEFAULT NULL";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
					}
				}
			}
		
			$key='DISABLE_PRODUCT_ATTRIBUTES_TAB_IN_EDITOR';
			$title='Disable product attributes tab in products editor';
			$description='Disables the product attributes tab in the products editor';
			$default_value='0';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', '".$title."', '".$key."', '".$default_value."', '".$description."', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'',''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$messages[]=$str;							
			}			
			$key='SPECIALS_LISTING_TYPE';
			$title='Specials Listing Type';
			$description='The lay-out type for displaying the listing of the specials';
			$default_value='default';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', '".$title."', '".$key."', '".$default_value."', '".$description."', 6, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$messages[]=$str;							
			}
			$str="select id from tx_multishop_payment_transactions";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="CREATE TABLE  `tx_multishop_payment_transactions` (
			`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
			`orders_id` INT( 11 ) NOT NULL ,
			`transaction_id` VARCHAR( 65 ) NOT NULL ,
			`psp` VARCHAR( 25 ) NOT NULL ,
			`crdate` INT( 11 ) NOT NULL ,
			`status` TINYINT( 1 ) NOT NULL ,
			INDEX (  `orders_id` ,  `transaction_id` ,  `crdate` ,  `status` )
			) ";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
			}	
			$key='PRICE_FILTER_BOX_STEPPINGS';
			$title='Price Filter Box Steppings';
			$description='Optional field. Defines the steppings of the price filter box.';
			$default_value='0-10;10-25;25-50;50-100;100-250;250-500;500-1000;1000-2000;2000-3000';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', '".$title."', '".$key."', '".$default_value."', '".$description."', 3, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$messages[]=$str;							
			}
			$key='SEND_ORDER_CONFIRMATION_LETTER_ALSO_TO';
			$title='Send Order Confirmation Letters also to';
			$description='Send the order confirmation letter also to the following e-mail addresses.';
			$default_value='';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', '".$title."', '".$key."', '".$default_value."', '".$description."', 3, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$messages[]=$str;							
			}				
			$str="describe tx_multishop_orders";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				if ($row['Field']=='payed')
				{
					if (!isset($row['Default']))
					{
						$str="ALTER TABLE  `tx_multishop_orders` CHANGE  `payed`  `payed` TINYINT( 1 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
						$messages[]=$str;
					}
				}
			}	
			$str="select custom_settings from tx_multishop_categories";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE `tx_multishop_categories` ADD  `custom_settings` TEXT NULL";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;			
			}		
			$str="select custom_settings from tx_multishop_products";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE `tx_multishop_products` ADD  `custom_settings` TEXT NULL";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;							
			}			
			$str="select start_date from tx_multishop_specials";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `tx_multishop_specials` ADD  `start_date` INT( 11 ) NOT NULL AFTER  `specials_last_modified`,ADD INDEX (  `start_date` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;							
			}	
			$str="select contains_image from tx_multishop_products";		
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `tx_multishop_products` ADD  `contains_image` TINYINT( 1 ) NOT NULL,ADD INDEX (  `contains_image` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;							
				$str="ALTER TABLE  `tx_multishop_products_flat` ADD  `contains_image` TINYINT( 1 ) NOT NULL,ADD INDEX (  `contains_image` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);				
				$messages[]=$str;							
			}	
			$key='SHOW_PRODUCTS_WITH_IMAGE_FIRST';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Show products with image first', '".$key."', '0', 'If this setting is enabled the products that contains an image will be shown first.', 7, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$messages[]=$str;							
			}	
			$key='CHECKOUT_ENABLE_STATE';
			$title='Enable state';
			$description='Show or hide the state/region inputfield.';
			$default_value=0;
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', '".$title."', '".$key."', '".$default_value."', '".$description."', 8, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$messages[]=$str;							
			}
			$key='CHECKOUT_ENABLE_BIRTHDAY';
			$title='Enable birthday';
			$description='Show or hide the birthday inputfield.';
			$default_value=0;
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', '".$title."', '".$key."', '".$default_value."', '".$description."', 8, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$messages[]=$str;							
			}			
			// old updates			
			$str="describe tx_multishop_products_options";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				if ($row['Field']=='products_options_id')
				{
					if ($row['Extra']!='auto_increment')
					{
						$str="ALTER TABLE  `tx_multishop_products_options` CHANGE  `products_options_id`  `products_options_id` INT( 11 ) NOT NULL AUTO_INCREMENT;";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);								
						$messages[]=$str;							
					}
				}
			}		 			
			$str="describe tx_multishop_categories";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				if ($row['Field']=='date_added')
				{
					if ($row['Type']=='datetime')
					{
						// date fixer
						$fields='tx_multishop_categories.date_added
						tx_multishop_categories.last_modified
						tx_multishop_configuration.last_modified
						tx_multishop_configuration.date_added
						tx_multishop_manufacturers.date_added
						tx_multishop_manufacturers.last_modified
						tx_multishop_manufacturers_info.date_last_click
						tx_multishop_modules.date
						tx_multishop_payment_methods.date
						tx_multishop_products.products_date_added
						tx_multishop_products.products_last_modified
						tx_multishop_products.products_date_available
						tx_multishop_products_flat.products_date_added
						tx_multishop_products_flat.products_date_available
						tx_multishop_reviews.date_added
						tx_multishop_reviews.last_modified
						tx_multishop_specials.specials_last_modified
						tx_multishop_specials.specials_date_added
						tx_multishop_specials.expires_date
						tx_multishop_specials.date_status_change
						tx_multishop_undo_products.products_last_modified
						tx_multishop_undo_products.products_date_added
						tx_multishop_undo_products.products_date_available
						tx_multishop_coupons.startdate
						tx_multishop_coupons.enddate			
						tx_multishop_shipping_methods.date
						tx_multishop_shipping_options.date
						tx_multishop_specials_sections.date
						';
						$array=explode("\n",$fields);
						$output=array();			
						foreach ($array as $item)
						{
							$item=trim($item);
							$var=explode(".",$item);
							if ($var[0] and $var[1])
							{
								$str="ALTER TABLE  `".$var[0]."` CHANGE  `".$var[1]."`  `".$var[1]."` INT( 11 ) DEFAULT 0;";
								$qry=$GLOBALS['TYPO3_DB']->sql_query($str);					
								$messages[]=$str;															
							}
						}
						break;
						// date fixer eof
					}
				}
			}
			$str="describe tx_multishop_products_options_values";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				if ($row['Field']=='products_options_values_id')
				{
					if ($row['Extra']!='auto_increment')
					{
						$str="ALTER TABLE  `tx_multishop_products_options_values` CHANGE  `products_options_values_id`  `products_options_values_id` INT( 11 ) NOT NULL AUTO_INCREMENT;";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);								
						$messages[]=$str;																					
					}
				}
			}
			$str="describe tx_multishop_products_options_values_to_products_options";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				if ($row['Field']=='products_options_values_to_products_options_id')
				{
					if ($row['Extra']!='auto_increment')
					{
						$str="ALTER TABLE `tx_multishop_products_options_values_to_products_options` CHANGE `products_options_values_to_products_options_id` `products_options_values_to_products_options_id` INT( 11 ) NOT NULL AUTO_INCREMENT";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);								
						$messages[]=$str;																					
					}
				}
			}			
			$str="select id from tx_multishop_orphan_files";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="CREATE TABLE `tx_multishop_orphan_files` (
				`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
				`type` VARCHAR( 50 ) NOT NULL ,
				`path` TEXT NOT NULL ,
				`file` VARCHAR(255) NOT NULL ,
				`orphan` TINYINT(1) NOT NULL DEFAULT '0',
				`checked` TINYINT(1) NOT NULL DEFAULT '0',
				`crdate` INT( 11 ) NOT NULL ,
				INDEX ( `type` ),
				INDEX ( `crdate`),
				INDEX ( `file`),
				INDEX ( `orphan`),
				INDEX ( `checked`),
				FULLTEXT (`path`)
				) ENGINE = MYISAM ;";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
			}	
			$str="select categories_url from tx_multishop_categories";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `tx_multishop_categories` ADD  `categories_url` VARCHAR( 254 ) NOT NULL";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
			}	
			$str="select content_footer from tx_multishop_categories_description";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `tx_multishop_categories_description` ADD  `content_footer` TEXT NOT NULL AFTER  `content`";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
			}				
			$str="select invoice_id from tx_multishop_invoices";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="CREATE TABLE `tx_multishop_invoices` (
				`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
				`invoice_id` VARCHAR(255) NOT NULL ,
				`invoice_inc` VARCHAR(11) NOT NULL ,
				`orders_id` INT( 11 ) NOT NULL ,
				`date` INT( 11 ) NOT NULL ,
				`status` INT( 11 ) NOT NULL 
				) ENGINE = MYISAM ;";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
			}					
			
			$str="select id from tx_multishop_specials_sections";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="CREATE TABLE  `tx_multishop_specials_sections` (
`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
`specials_id` INT( 11 ) NOT NULL ,
`date` int(11) NOT NULL,
`name` VARCHAR( 30 ) NOT NULL
)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
				$str="ALTER TABLE  `tx_multishop_specials_sections` ADD INDEX (  `date` ), ADD INDEX (  `specials_id` ), ADD INDEX (  `name` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
			}		
			$str="select status from tx_multishop_specials_sections";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `tx_multishop_specials_sections` ADD  `status` TINYINT( 1 ) NOT NULL";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
				$str="ALTER TABLE  `tx_multishop_specials_sections` ADD INDEX (  `status` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
				$str="ALTER TABLE  `tx_multishop_specials` CHANGE  `specials_id`  `specials_id` INT( 11 ) NOT NULL AUTO_INCREMENT";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$messages[]=$str;																			
			}	
			$key='FLAT_DATABASE';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Flat Database', '".$key."', '0', 'This module creates flat products and categories database tables for maximum speed. An essential module for webshops that contain more than 250.000 products.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$messages[]=$str;																			
			}
			$key='FLAT_DATABASE_EXTRA_ATTRIBUTE_OPTION_COLUMNS';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Flat Database extra attribute option columns', '".$key."', '', 'If you use the flat database module and you need the (single) attribute values inside a seperate table field in the flat table then define the attribute option id\'s here (example: 1:varchar(10);4:int(10);5:varchar(10);10:varchar(10)).', 3, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$messages[]=$str;																			
			}		
			$key='AFFILIATE_SHOP';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="delete from `tx_multishop_configuration` where configuration_key='".$key."';";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$str="delete from `tx_multishop_configuration` where configuration_title='iDEAL Test Stage';";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				$str="replace INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(3, 'Misc', '', NULL, 1);";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Affiliate Shop', '".$key."', '0', 'This module enables the webshop as affiliate shop (hiding the order/basket system).', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$key='CACHE_FRONT_END';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Cache front-end', '".$key."', '0', 'This module enables optimal caching features to the front-end. It will boost performance to big stores.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$key='PRODUCTS_SHORT_DESCRIPTION_CONTAINS_HTML_MARKUP';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Products short description contains HTML markup', '".$key."', '0', 'Defines whether we should save the content as plain text or by HTML markup.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}			
			$key='CACHE_TIME_OUT_LISTING_PAGES';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Cache time out for categories/products listing page', '".$key."', '3600', 'Specify the expiry time of the categories and products listing page cache files. Default: 3600. To turn this caching feature off specify: 0.', 3, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}	
			$key='CACHE_TIME_OUT_SEARCH_PAGES';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Cache time out for search page', '".$key."', '3600', 'Specify the expiry time of the search page cache files. Default: 3600. To turn this caching feature off specify: 0.', 3, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}	
			$key='CACHE_TIME_OUT_PRODUCTS_DETAIL_PAGES';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Cache time out for products detail page', '".$key."', '3600', 'Specify the expiry time of the products detail page cache files. Default: 3600. To turn this caching feature off specify: 0.', 3, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}		
			$key='CACHE_TIME_OUT_CATEGORIES_NAVIGATION_MENU';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Cache time out for the categories navigation menu', '".$key."', '3600', 'Specify the expiry time of the categories navigation menu cache files. Default: 3600. To turn this caching feature off specify: 0.', 3, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}		
			$key='COUNTRY_ISO_NR';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Webshop Country ISO Number', '".$key."', '0', 'The country where the webstore is located. Used to determine the local VAT classes.', 3, NULL, NULL, now(), NULL, 'tep_country_select_option(');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}
			$key='SHOW_INNER_FOOTER_NAV';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Show the footer navigation in the middle content', '".$key."', '0', 'This module enables the inner footer navigation.', 1, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$key='STORE_NAME';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Store Name', '".$key."', '', 'The name of the store.', 3, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$key='STORE_EMAIL';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Store E-mail', '".$key."', '', 'The e-mail address of the store owner.', 3, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			// update fixed
			
			$str="select `prefix_source_name` from tx_multishop_import_jobs ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE `tx_multishop_import_jobs` ADD `prefix_source_name` VARCHAR( 50 ) NOT NULL ";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$str="ALTER TABLE `tx_multishop_import_jobs` ADD INDEX ( `prefix_source_name` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$str="select `products_model` from tx_multishop_orders_products ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `tx_multishop_orders_products` ADD  `products_model` VARCHAR( 64 ) NOT NULL";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}	
			$str="select `deleted` from tx_multishop_orders ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `tx_multishop_orders` ADD  `deleted` TINYINT( 1 ) DEFAULT 0";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}				
			$str="select `key` from tx_multishop_configuration ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($qry)
			{	
				$str="ALTER TABLE `tx_multishop_configuration` CHANGE `key` `configuration_key` VARCHAR( 64 ) NOT NULL DEFAULT ''";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$str="select `depend_on_configuration_key` from tx_multishop_configuration ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE  `tx_multishop_configuration` ADD  `depend_on_configuration_key` VARCHAR( 64 ) NOT NULL";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}	
			$str="select id from tx_multishop_undo_products";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="CREATE TABLE `tx_multishop_undo_products` (
				  `id` int(11) NOT NULL AUTO_INCREMENT,
				  `crdate` int(11) NOT NULL,
				  `products_id` int(5) NOT NULL,
				  `products_quantity` int(4) NOT NULL DEFAULT '0',
				  `products_model` varchar(32) DEFAULT NULL,
				  `products_image` varchar(250) DEFAULT NULL,
				  `products_image1` varchar(250) DEFAULT NULL,
				  `products_image2` varchar(250) DEFAULT NULL,
				  `products_image3` varchar(250) DEFAULT NULL,
				  `products_image4` varchar(250) DEFAULT NULL,
				  `products_price` decimal(8,2) NOT NULL DEFAULT '0.00',
				  `products_date_added` int(11) DEFAULT NULL,
				  `products_last_modified` int(11) DEFAULT NULL,
				  `products_date_available` int(11) DEFAULT NULL,
				  `products_weight` decimal(5,2) NOT NULL DEFAULT '0.00',
				  `products_status` tinyint(1) NOT NULL DEFAULT '0',
				  `tax_id` int(5) NOT NULL DEFAULT '0',
				  `manufacturers_id` int(5) DEFAULT NULL,
				  `products_pdf` varchar(250) DEFAULT NULL,
				  `products_pdf1` varchar(250) DEFAULT '',
				  `products_pdf2` varchar(250) DEFAULT '',
				  `sort_order` tinyint(3) NOT NULL DEFAULT '0',
				  `buildyear` varchar(5) DEFAULT NULL,
				  `kilometers` varchar(7) DEFAULT NULL,
				  `extid` varchar(100) DEFAULT '0',
				  `dealer_price` decimal(8,2) DEFAULT NULL,
				  `staffel_price` varchar(127) DEFAULT NULL,
				  `pid` int(11) DEFAULT NULL,
				  `did` int(11) DEFAULT NULL,
				  `delivery_week` varchar(255) DEFAULT '0',
				  `products_legend` varchar(255) DEFAULT NULL,
				  `products_article_number` varchar(255) DEFAULT NULL,
				  `price_group_id` int(11) DEFAULT NULL,
				  `wrapper_type` varchar(10) DEFAULT '',
				  `source_id` int(2) DEFAULT '0',
				  `product_capital_price` decimal(8,2) DEFAULT '0.00',
				  `tip` tinyint(1) DEFAULT '0',
				  `minimum_order` int(3) DEFAULT '0',
				  `minimum_quantity` int(11) DEFAULT '1',
				  `maximum_quantity` int(11) DEFAULT '0',				  
				  `productfeed` tinyint(1) DEFAULT '0',
				  `gordijn_stof` tinyint(1) DEFAULT '0',
				  `gordijn_type` varchar(127) DEFAULT '',
				  `price_perset` varchar(255) DEFAULT NULL,
				  `gordijn_fabric` tinyint(1) DEFAULT '0',
				  `gordijn_fabric_size` decimal(5,2) DEFAULT '0.00',
				  `knipstal` tinyint(1) DEFAULT '0',
				  `products_shippingcost` decimal(8,2) DEFAULT '0.00',
				  `packages` varchar(255) DEFAULT '',
				  `is_package` tinyint(1) NOT NULL DEFAULT '0',
				  `root_oid` int(11) DEFAULT '0',
				  `attributes_values` tinyint(1) NOT NULL DEFAULT '0',
				  `is_topsell` tinyint(1) DEFAULT '0',
				  `m2_per_box` decimal(8,2) DEFAULT NULL,
				  `qty_per_box` tinyint(2) DEFAULT NULL,
				  `max_box_per_pallet` int(4) DEFAULT NULL,
				  `price_type` varchar(10) DEFAULT NULL,
				  `vendor_code` varchar(255) DEFAULT '',
				  `dealer_staffel_price` varchar(127) DEFAULT '',
				  `free_shippingcost` tinyint(1) DEFAULT '0',
				  `vanaf_price` decimal(8,2) DEFAULT '0.00',
				  `fake_url` varchar(255) DEFAULT NULL,
				  `oid` int(11) DEFAULT '0',
				  `ean_code` varchar(13) DEFAULT NULL,
				  `page_uid` int(11) NOT NULL DEFAULT '0',
				  PRIMARY KEY (`id`)
				)
				";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$str="ALTER TABLE  `tx_multishop_undo_products` ADD INDEX (  `products_id` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$str="ALTER TABLE  `tx_multishop_undo_products` ADD INDEX (  `crdate` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$str="select `code` from tx_multishop_import_jobs ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE `tx_multishop_import_jobs` ADD `code` VARCHAR( 16 ) NULL ";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$str="ALTER TABLE `tx_multishop_import_jobs` ADD INDEX ( `code` ) ";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$str="SELECT * from tx_multishop_import_jobs order by id desc";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				while ($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
				{			
					// fix the registered jobs that hasnt got any md5 code
					$updateArray=array();
					$updateArray['code']					=md5(uniqid());		
					$query = $GLOBALS['TYPO3_DB']->UPDATEquery('tx_multishop_import_jobs', 'id=\''.$row['id'].'\'',$updateArray);
					$res = $GLOBALS['TYPO3_DB']->sql_query($query);	
				}
			}
			
			$str="select `value` from tx_multishop_configuration ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($qry)
			{	
				$str="ALTER TABLE `tx_multishop_configuration` CHANGE `value` `configuration_value` VARCHAR( 64 ) NOT NULL DEFAULT ''";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$str="select `title` from tx_multishop_configuration ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($qry)
			{	
				$str="ALTER TABLE `tx_multishop_configuration` CHANGE `title` `configuration_title` VARCHAR( 64 ) NOT NULL DEFAULT ''";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$str="select `title` from tx_multishop_configuration_group ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($qry)
			{	
				$str="ALTER TABLE `tx_multishop_configuration_group` CHANGE `title` `configuration_title` VARCHAR( 64 ) NOT NULL DEFAULT ''";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}	
			$str="select products_tax_class_id from tx_multishop_products";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($qry)
			{	
				$str="ALTER TABLE `tx_multishop_products` CHANGE `products_tax_class_id` `tax_id` INT( 5 ) NOT NULL DEFAULT '0'";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$str="select page_id from tx_multishop_cms";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($qry)
			{	
				$str="ALTER TABLE `tx_multishop_cms` CHANGE `page_id` `page_uid` INT(11) NOT NULL DEFAULT '0'";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$str="select date_added from tx_multishop_cms";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($qry)
			{	
				$str="ALTER TABLE `tx_multishop_cms` CHANGE `date_added` `crdate` INT(11) NOT NULL DEFAULT '0'";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$str="select date_added from tx_multishop_orders_status_history";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($qry)
			{	
				$str="ALTER TABLE `tx_multishop_orders_status_history` CHANGE `date_added` `crdate` INT(11) NOT NULL DEFAULT '0'";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$str="select payed from tx_multishop_orders";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE `tx_multishop_orders` ADD `payed` TINYINT( 1 ) NOT NULL ";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$str="ALTER TABLE `tx_multishop_orders` ADD INDEX ( `payed` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$str="select by_phone from tx_multishop_orders";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE `tx_multishop_orders` ADD `by_phone` TINYINT( 1 ) NOT NULL DEFAULT '0'";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$str="ALTER TABLE `tx_multishop_orders` ADD INDEX ( `by_phone` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			
			$str="select option_attributes from tx_multishop_categories";
			 $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			 if (!$qry)
			 { 
			  $str="ALTER TABLE `tx_multishop_categories` ADD `option_attributes` varchar( 254 ) NOT NULL  DEFAULT ''";
			  $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			 }
			 
			$str="select * from tx_multishop_shipping_countries";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="CREATE TABLE `tx_multishop_shipping_countries` (
			  `id` int(11) NOT NULL auto_increment,
			  `page_uid` int(11) NOT NULL,
			  `cn_iso_nr` int(11) NOT NULL,
			  PRIMARY KEY  (`id`),
			  UNIQUE KEY `cn_iso_nr` (`cn_iso_nr`,`page_uid`)
			) ENGINE=MyISAM  ;";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$str="select * from tx_multishop_coupons";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="CREATE TABLE IF NOT EXISTS `tx_multishop_coupons` (
	  `id` int(11) NOT NULL AUTO_INCREMENT,
	  `code` varchar(250) DEFAULT '',
	  `discount` decimal(5,2) NOT NULL DEFAULT '0.00',
	  `status` tinyint(1) NOT NULL DEFAULT '0',
	  `startdate` date NOT NULL,
	  `enddate` date NOT NULL,
	  `times_used` int(5) NOT NULL,
	  PRIMARY KEY (`id`),
	  UNIQUE KEY `code` (`code`)
	) ENGINE=MyISAM ;
	";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$str="select endate from tx_multishop_coupons";		
			if ($qry=$GLOBALS['TYPO3_DB']->sql_query($str))
			{
				$str="ALTER TABLE `tx_multishop_coupons` CHANGE `endate` `enddate` DATE NOT NULL";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$str="ALTER TABLE `tx_multishop_coupons` CHANGE `status` `status` TINYINT( 1 ) NOT NULL DEFAULT '0'";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$str="ALTER TABLE `tx_multishop_coupons` ADD `times_used` INT( 5 ) NOT NULL ";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$str="ALTER TABLE `tx_multishop_coupons` ADD UNIQUE (`code` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$str="select * from tx_multishop_configuration_group where id='2'";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($GLOBALS['TYPO3_DB']->sql_num_rows($qry) > 0)
			{
				$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry);
				if ($row['configuration_title']=='Product Listing')
				{
					$str="UPDATE `tx_multishop_configuration_group` SET `configuration_title` = 'Image Settings' WHERE `id` =2;";
					$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				}	
				elseif ($row['configuration_title']=='Image Size Settings')
				{
					$str="UPDATE `tx_multishop_configuration_group` SET `configuration_title` = 'Image Settings' WHERE `id` =2;";
					$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				}			
			}	
			$str="select * from tx_multishop_configuration_group where id='3'";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($GLOBALS['TYPO3_DB']->sql_num_rows($qry) > 0)
			{
				$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry);
				if ($row['configuration_title']=='Misc')
				{
					$str="UPDATE `tx_multishop_configuration_group` SET `configuration_title` = 'Webshop Settings' WHERE `id` =3;";
					$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				}	
			}		
			$str="select * from tx_multishop_configuration where configuration_title='Store Name' and group_id='1'";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($GLOBALS['TYPO3_DB']->sql_num_rows($qry) > 0)
			{
				$str="UPDATE `tx_multishop_configuration` SET `group_id` =3 WHERE configuration_title='Store Name';";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
		// 12 july 2010
			$str="select `billing_phone` from tx_multishop_orders ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($qry)
			{	
				$str="ALTER TABLE `tx_multishop_orders` CHANGE `billing_phone` `billing_telephone` VARCHAR( 150 ) NULL DEFAULT NULL ";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}	
			$str="select `delivery_phone` from tx_multishop_orders ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($qry)
			{	
				$str="ALTER TABLE `tx_multishop_orders` CHANGE `delivery_phone` `delivery_telephone` VARCHAR( 150 ) NULL DEFAULT NULL ";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}		
			$str="select `billing_gender` from tx_multishop_orders ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE `tx_multishop_orders` ADD `billing_gender` CHAR( 1 ) NULL ";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}		
			$str="select `billing_birthday` from tx_multishop_orders ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE `tx_multishop_orders` ADD `billing_birthday` int( 11 ) NULL ";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}		
			$str="select `billing_email` from tx_multishop_orders ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE `tx_multishop_orders` ADD `billing_email` varchar( 254 ) NULL ";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}		
			$str="select `delivery_gender` from tx_multishop_orders ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE `tx_multishop_orders` ADD `delivery_gender` CHAR( 1 ) NULL ";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}		
			$str="select `delivery_email` from tx_multishop_orders ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$qry)
			{	
				$str="ALTER TABLE `tx_multishop_orders` ADD `delivery_email` varchar( 254 ) NULL 	";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$key='CATEGORIES_LISTING_SPECIALS_CATEGORIES_SUBLEVEL';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Show specials box till categories sublevel', '".$key."', '2', 'This value defines till which categories sublevel the specials scroller should be shown. Choose 0 to show the specials on each categories level.', 3, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}			


			$key='SHOW_PRICES_INCLUDING_VAT';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Show prices including VAT', '".$key."', '1', 'This setting defines whether we should show product prices including VAT or without.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}			
			$key='MANUAL_ORDER';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Enable the manual order', '".$key."', '0', 'This module enables the manual order.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			
			$key='INVOICE_PRINT';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'This module enable to print invoice order', '".$key."', '0', 'This module enable to print invoice order.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			
			$key='PACKING_LIST_PRINT';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'This module enable to print order packing list', '".$key."', '0', 'This module enable to print order packing list.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			
			$key='INVOICE_PREFIX';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Invoice prefix', '".$key."', '0', 'Invoice prefix.', 3, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
		$key='ACCORDION_MENU';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Accordion Menu', '".$key."', '0', 'Accordion menu.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
		$key='ACCORDION_SETUP_MODULES';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Accordion Setup Modules', '".$key."', '0', 'Accordion for setup modules.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
		
		// 12 july eof	
		//13 oct 2010 for fe_user
		$str="select address_number from fe_users";
		$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		if (!$qry)
		{	
			$str="ALTER TABLE `fe_users` ADD `address_number` VARCHAR( 150 ) NULL DEFAULT NULL";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		}
		$str="select mobile from fe_user";
		$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		if (!$qry)
		{	
			$str="ALTER TABLE `fe_users` ADD `mobile` VARCHAR( 150 ) NULL DEFAULT NULL";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		}
		$str="select attribute_image from tx_multishop_products_attributes";
		$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		if (!$qry)
		{	
			$str="ALTER TABLE `tx_multishop_products_attributes` ADD `attribute_image` VARCHAR( 150 ) NULL DEFAULT NULL";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		}
			
		$str="select * from tx_multishop_address_book";
		$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		if (!$qry)
		{	
			
			$str="CREATE TABLE IF NOT EXISTS `tx_multishop_address_book` (
			  `id_address_book` int(11) NOT NULL AUTO_INCREMENT,
			  `customer_id` int(5) NOT NULL,
			  `delivery_email` varchar(250) DEFAULT '',
			  `delivery_company` varchar(250) DEFAULT '',
			  `delivery_first_name` varchar(250) DEFAULT '',
			  `delivery_middle_name` varchar(250) DEFAULT '',
			  `delivery_last_name` varchar(250) DEFAULT '',
			  `delivery_telephone` varchar(250) DEFAULT '',
			  `delivery_mobile` varchar(250) DEFAULT '',
			  `delivery_gender` varchar(250) DEFAULT '',
			  `delivery_address` varchar(250) DEFAULT '',
			  `delivery_address_number` varchar(250) DEFAULT '',
			  `delivery_zip` varchar(250) DEFAULT '',
			  `delivery_city` varchar(250) DEFAULT '',
			  `delivery_country` varchar(250) DEFAULT '',
			  PRIMARY KEY (`id_address_book`),
			  UNIQUE KEY `code` (`customer_id`)
			);
			";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
		}
		//13 oct 2010 for fe_user eof
		
			$width='normal';
			$value="176x140";
			$key='CATEGORY_IMAGE_SIZE_'.strtoupper($width);
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Category image size', '".$key."', '".$value."', 'The maximum image size in pixels for the category image folder.', 2, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			
			}
			$width=50;
			$value="50x50";
			$key='PRODUCT_IMAGE_SIZE_'.strtoupper($width);
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product image size (".$width.")', '".$key."', '".$value."', 'The maximum ".$type." in pixels for the ".$width." image folder.', 2, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$width=100;
			$value="175x123";
			$key='PRODUCT_IMAGE_SIZE_'.strtoupper($width);
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product image size (".$width.")', '".$key."', '".$value."', 'The maximum ".$type." in pixels for the ".$width." image folder.', 2, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$width=200;
			$value="140x150";
			$key='PRODUCT_IMAGE_SIZE_'.strtoupper($width);
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product image size (".$width.")', '".$key."', '".$value."', 'The maximum ".$type." in pixels for the ".$width." image folder.', 2, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$width=300;
			$value="350x300";
			$key='PRODUCT_IMAGE_SIZE_'.strtoupper($width);
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product image size (".$width.")', '".$key."', '".$value."', 'The maximum ".$type." in pixels for the ".$width." image folder.', 2, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$width='enlarged';
			$value="600x400";
			$key='PRODUCT_IMAGE_SIZE_'.strtoupper($width);
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product image size (".$width.")', '".$key."', '".$value."', 'The maximum ".$type." in pixels for the ".$width." image folder.', 2, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			
			// meta
			$key='META_TITLE';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Meta Title', '".$key."', 'Webshop Title', 'The title of the webshop, used for the Meta Tags.', 3, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$key='META_DESCRIPTION';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Meta Description', '".$key."', 'Description of the webshop.', 'The description of the webshop, used for the Meta Tags.', 3, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$key='META_KEYWORDS';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Meta Keywords', '".$key."', 'keyword1, keyword2', 'The search words that are related to the webshop, used for the Meta Tags.', 3, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$str="select * from tx_multishop_configuration_group where id='4'";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
			{
				$str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(4, 'Webshop Plugins', '', NULL, 1);";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$str="select * from tx_multishop_configuration_group where id='8'";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
			{
				$str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(8, 'Checkout Settings', '', NULL, 1);";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
				$key='CHECKOUT_LENGTH_TELEPHONE_NUMBER';
				if (!isset($settings['GLOBAL_MODULES'][$key]))
				{
					$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Length telephone number', '".$key."', '10', 'The total chars of a valid telephone number.', 8, NULL, NULL, now(), NULL, '');";
					$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				}	
				$key='CHECKOUT_VALIDATE_FORM';
				if (!isset($settings['GLOBAL_MODULES'][$key]))
				{
					$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Validate Checkout Form', '".$key."', '1', 'Validate Checkout Form by JavaScript.', 8, NULL, NULL, now(), NULL, '');";
					$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				}					
				$key='CHECKOUT_REQUIRED_TELEPHONE';
				$title='Telephone Required';
				$description='Validate Checkout Form by JavaScript.';
				$default_value=1;
				if (!isset($settings['GLOBAL_MODULES'][$key]))
				{
					$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', '".$title."', '".$key."', '".$default_value."', '".$description."', 8, NULL, NULL, now(), NULL, '');";
					$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
				}						
			}		
			$str="select * from tx_multishop_configuration_group where id='9'";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
			{
				$str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(9, 'Orders Settings', '', NULL, 1);";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
			}
			$key='ORDERS_CUSTOM_EXPORT_SCRIPT';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Orders Custom Export Script', '".$key."', '', 'Optionally you can process the newly created orders by your custom script.', 9, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}				
			$key='ORDERS_PAYED_CUSTOM_SCRIPT';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Orders Payed Custom Script', '".$key."', '', 'Optionally you can process the payed order by your custom script.', 9, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}				
			$str="select * from tx_multishop_configuration_group where id='10'";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
			{
				$str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(10, 'Products Stock Settings', '', NULL, 1);";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
			}
		
			$key='SHOW_STOCK_LEVEL_AS_BOOLEAN';	
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Show stock level as boolean (yes/no)', '".$key."', '0', 'Instead of showing the total count of the products stock level, show stock as: yes or no.', 10, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''yes_without_image'',''yes_with_image'', ''no''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}			
			$key='GOOGLE_ANALYTICS_ACCOUNT';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Google Analytics Account', '".$key."', 'UA-16775241-1', 'Google Analytics is the enterprise-class web analytics solution that gives you rich insights into your website traffic and marketing effectiveness.', 4, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$key='ADDTHIS_ACCOUNT';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Addthis Account', '".$key."', 'typo3multishop', 'Add a Addthis button to your webshop. Addthis.com makes sharing your website urls easy.', 4, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$key='GOOGLE_ADWORDS_CONVERSION_CODE';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Google Adwords Conversion Code', '".$key."', '', 'Add a Google Adwords Conversion Code to the thank you page of the webshop. This makes it possible to calculate the success-ratio of your Google Adwords campaign.', 4, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$key='PRODUCT_IMAGE_WATERMARK_TEXT';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Watermark Text', '".$key."', '', 'Add a watermark to enlarged product images. Example value: typo3multishop.com', 2, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}	
			$key='PRODUCT_IMAGE_WATERMARK_WIDTH';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Watermark Width', '".$key."', '100', 'The width of the text. Example value: 100', 2, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}	
			$key='PRODUCT_IMAGE_WATERMARK_HEIGHT';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Watermark Height', '".$key."', '60', 'The height of the text. Example value: 60', 2, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}				
			$key='PRODUCT_IMAGE_WATERMARK_FONT_SIZE';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Watermark Font-size', '".$key."', '16', 'Specify the font-size (in pt) of the watermark. Example value: 16', 2, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$key='PRODUCT_IMAGE_WATERMARK_FONT_FILE';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Watermark Font File', '".$key."', 'nasaliza.ttf', 'Specify the font file for the watermarking. Example value: nasaliza.ttf', 2, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}			
			$key='PRODUCT_IMAGE_WATERMARK_POSITION';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Watermark Position', '".$key."', 'south-east', 'Choose the position of the watermark.', 2, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''north-east'', ''south-east'',''south-west'',''north-west''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$key='PRODUCT_IMAGE_SHAPED_CORNERS';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Image Shaped Corners', '".$key."', '0', 'Adds shaped corners to every thumbnailed product image.', 2, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}	
			$key='CATEGORY_IMAGE_SHAPED_CORNERS';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Category Image Shaped Corners', '".$key."', '0', 'Adds shaped corners to every category image.', 2, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}		
			// ok now we going to convert the table schemes
			// products description
			$from	='products_title_seo';
			$to	='products_meta_title';
			$str="select ".$from." from tx_multishop_products_description";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($qry)
			{	
				$str="ALTER TABLE `tx_multishop_products_description` CHANGE `".$from."` `".$to."` varchar(254) NOT NULL DEFAULT ''";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$from	='meta_description';
			$to	='products_meta_description';
			$str="select ".$from." from tx_multishop_products_description";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($qry)
			{	
				$str="ALTER TABLE `tx_multishop_products_description` CHANGE `".$from."` `".$to."` varchar(254) NOT NULL DEFAULT ''";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$from	='products_keywords';
			$to	='products_meta_keywords';
			$str="select ".$from." from tx_multishop_products_description";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if ($qry)
			{	
				$str="ALTER TABLE `tx_multishop_products_description` CHANGE `".$from."` `".$to."` varchar(254) NOT NULL DEFAULT ''";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$key='PRODUCTS_LISTING_LIMIT';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Products Listing Limiting', '".$key."', '18', 'The total number of displayed products per page.', 3, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$key='CHECKOUT_TYPE';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Checkout Type', '".$key."', 'multistep', 'Choose which checkout process should be used (ie: multistep).', 3, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$key='SHOW_PRICES_WITH_AND_WITHOUT_VAT';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Show product prices with and without VAT', '".$key."', '0', 'If products contain VAT the price including and excluding VAT will be shown.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}	
			$str="select * from tx_multishop_configuration_group where id='5'";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
			{
				$str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(5, 'Categories Listing', '', NULL, 1);";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$str="select * from tx_multishop_configuration_group where id='6'";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
			{
				$str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(6, 'Products Listing', '', NULL, 1);";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$key='CATEGORIES_LISTING_TYPE';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Categories Listing Type', '".$key."', 'grid', 'The lay-out type for displaying the categories listing.', 5, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$key='PRODUCTS_LISTING_TYPE';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Products Listing Type', '".$key."', 'grid', 'The lay-out type for displaying the products listing.', 6, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$key='PRODUCTS_LISTING_AUTOCORRECTION_TYPE';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Products Listing Autocorrection Type', '".$key."', 'default', 'The lay-out type for displaying the products listing in the autocorrection module.', 6, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}			
			$str="select * from tx_multishop_configuration_group where id='7'";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
			{
				$str="INSERT INTO `tx_multishop_configuration_group` (`id`, `configuration_title`, `description`, `sort_order`, `visible`) VALUES(7, 'Products Detail Page', '', NULL, 1);";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$key='PRODUCTS_DETAIL_PAGE_PAGINATION';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Product Pagination', '".$key."', '0', 'Show\'s a button Previous and Next on the products detail page to go to the next or previous product within the same category.', 7, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$key='PRODUCTS_DETAIL_TYPE';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			 {
			  $str="INSERT INTO `tx_multishop_configuration` (`configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('Products Detail Type', 'PRODUCTS_DETAIL_TYPE', 'default', 'The lay-out type for displaying the products detail page.', 7, NULL, NULL, now(), NULL, '');";
			  $qry=$GLOBALS['TYPO3_DB']->sql_query($str);  
			 }
			 
			$key='STAFFEL_PRICE_MODULE';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
			  $str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Staffel Prices', '".$key."', '0', 'Enable staffel prices to your webshop.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
			  $qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			}
			$key='ULTRASEARCH_FIELDS';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Ultrasearch Fields', '".$key."', '', 'Define which fields you\'d like to show in the ultrasearch form. (example: 1:list;2:radio;3:checkbox;price_filter:0-1000)', 3, NULL, NULL, now(), NULL, '');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}			
			$key='COUPONS';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Coupon Code', '".$key."', '0', 'Activate coupon code.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
		
			$key='ORDER_EDIT';
			if (!isset($settings['GLOBAL_MODULES'][$key]))
			{
				$str="INSERT INTO `tx_multishop_configuration` (`id`, `configuration_title`, `configuration_key`, `configuration_value`, `description`, `group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES('', 'Admin Order Edit', '".$key."', '0', 'Enables you to edit orders.', 3, NULL, NULL, now(), NULL, 'tep_cfg_select_option(array(''1'', ''0''),');";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}
			$sql = "describe tx_multishop_shipping_countries_to_zones";
			$qry = $qry=$GLOBALS['TYPO3_DB']->sql_query($sql);
			while ($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				if ($rs['Field'] == 'cn_iso_nr') 
				{
					if ($rs['Type'] =='int(4)')
					{
						$str="ALTER TABLE `tx_multishop_shipping_countries_to_zones` CHANGE `cn_iso_nr` `cn_iso_nr` INT( 11 ) NULL DEFAULT NULL";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
						break;
					}
				}
			}
			$sql = "describe tx_multishop_products_description";
			$qry = $qry=$GLOBALS['TYPO3_DB']->sql_query($sql);
			while ($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				$colname='products_shortdescription';
				if ($rs['Field'] == $colname) 
				{
					if ($rs['Type'] =='text')
					{
						$str="ALTER TABLE `tx_multishop_products_description` CHANGE `".$colname."` `".$colname."` VARCHAR(255) NULL DEFAULT ''";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
						break;
					}
				}
				$colname='products_negative_keywords';
				if ($rs['Field'] == $colname) 
				{
					if ($rs['Type'] =='text')
					{
						$str="ALTER TABLE `tx_multishop_products_description` CHANGE `".$colname."` `".$colname."` VARCHAR(255) NULL DEFAULT ''";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
						break;
					}
				}
				$colname='promotext';
				if ($rs['Field'] == $colname) 
				{
					if ($rs['Type'] =='text')
					{
						$str="ALTER TABLE `tx_multishop_products_description` CHANGE `".$colname."` `".$colname."` VARCHAR(255) NULL DEFAULT ''";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
						break;
					}
				}				
			}
			$sql = "describe tx_multishop_orders";
			$qry = $qry=$GLOBALS['TYPO3_DB']->sql_query($sql);
			while ($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				if ($rs['Field'] == 'crdate') 
				{
					if ($rs['Type'] =='date')
					{
						$str="ALTER TABLE `tx_multishop_orders` CHANGE `crdate` `crdate` INT( 11 ) NULL";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
						break;
					}
				}
			}	
			$str="SELECT * from tx_multishop_import_jobs limit 1";
			if (!$qry=$GLOBALS['TYPO3_DB']->sql_query($str))
			{	
				$str="CREATE TABLE `tx_multishop_import_jobs` (
				`id` INT( 11 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
				`name` VARCHAR( 254 ) NOT NULL ,
				`period` INT( 11 ) NOT NULL ,
				`last_run` INT( 11 ) NOT NULL ,
				`data` TEXT NOT NULL ,
				`status` TINYINT( 1 ) NOT NULL ,
				`page_uid` INT( 11 ) NOT NULL,
				`categories_id` INT( 5 ) NULL,
				INDEX ( `last_run` , `status` , `page_uid`,`categories_id` ) 
				) ;";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);		
			}	
			$str="describe tx_multishop_products";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				if ($rs['Field']=='products_id')
				{
					if ($rs['Type'] =='int(5)')
					{
						$str="ALTER TABLE  `tx_multishop_products` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL AUTO_INCREMENT";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
						$str="ALTER TABLE  `tx_multishop_products_description` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
						
						$str="ALTER TABLE  `tx_multishop_products_attributes` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
						$str="ALTER TABLE  `products_attributes_id` CHANGE  `products_attributes_id`  `products_attributes_id` INT( 11 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
						$str="ALTER TABLE  `tx_multishop_products_attributes_extra` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
						$str="ALTER TABLE  `tx_multishop_products_options` CHANGE  `products_options_id`  `products_options_id` INT( 11 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
						$str="ALTER TABLE  `tx_multishop_products_options_values` CHANGE  `products_options_values_id`  `products_options_values_id` INT( 11 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);				
						
						$str="ALTER TABLE  `tx_multishop_products_options_values_extra` CHANGE  `products_options_values_extra_id`  `products_options_values_extra_id` INT( 11 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
						
						$str="ALTER TABLE  `tx_multishop_products_options_values_to_products_options` CHANGE  `products_options_values_to_products_options_id`  `products_options_values_to_products_options_id` INT( 11 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);					
						$str="ALTER TABLE  `tx_multishop_products_to_categories` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);										
						$str="ALTER TABLE  `tx_multishop_products_to_relative_products` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);															
						$str="ALTER TABLE  `tx_multishop_products_to_relative_products` CHANGE  `relative_product_id`  `relative_product_id` INT( 11 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);															
						$str="ALTER TABLE  `tx_multishop_reviews` CHANGE  `reviews_id`  `reviews_id` INT( 11 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);															
						$str="ALTER TABLE  `tx_multishop_reviews` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);															
						$str="ALTER TABLE  `tx_multishop_reviews_description` CHANGE  `reviews_id`  `reviews_id` INT( 11 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);															
						$str="ALTER TABLE  `tx_multishop_specials` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
						$str="ALTER TABLE  `tx_multishop_specials` CHANGE  `specials_id`  `specials_id` INT( 11 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);	
	
						$str="ALTER TABLE  `tx_multishop_undo_products` CHANGE  `products_id`  `products_id` INT( 11 ) NOT NULL DEFAULT  '0'";
						$qry=$GLOBALS['TYPO3_DB']->sql_query($str);															
						break;
					}
				}
			}		

			$indexes=array();
			$table_name='tx_multishop_products';
			$str="show indexes from `".$table_name."` ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				$indexes[]=$rs['Key_name'];
			}
			for ($i=0;$i<5;$i++)
			{
				$index=$i;
				if ($index==0) $index='';
				if (!in_array('products_image'.$index,$indexes))
				{
					$str="ALTER TABLE `".$table_name."` ADD INDEX `products_image".$index."` (`products_image".$index."`)";
					$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				}					
			}						
			// add combined indexes for maxium speed
			$indexes=array();
			$table_name='tx_multishop_products_options';
			$str="show indexes from `".$table_name."` ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				$indexes[]=$rs['Key_name'];
			}			
			if (!in_array('products_options_name',$indexes))
			{
				$str="ALTER TABLE  `".$table_name."` ADD INDEX `products_options_name` (  `language_id`,`products_options_name` )	";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}
			// add full text index to products_model for maxium speed
			$indexes=array();
			$table_name='tx_multishop_products_description';
			$str="show indexes from `".$table_name."` where Index_type='FULLTEXT' and Key_name ='products_model_2'";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			if (!$GLOBALS['TYPO3_DB']->sql_num_rows($qry))
			{
				$str="ALTER TABLE  `".$table_name."` ADD FULLTEXT `products_model_2` (`products_model` )	";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);							
			}
			$indexes=array();
			$table_name='tx_multishop_products_options_values';
			$str="show indexes from `".$table_name."` ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				$indexes[]=$rs['Key_name'];
			}
			if (!in_array('products_options_values_name',$indexes))
			{
				$str="ALTER TABLE  `".$table_name."` ADD INDEX `products_options_values_name` (  `products_options_values_name` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}
// delete double keys
			$indexes=array();
			$table_name='tx_multishop_coupons';
			$str="show indexes from `".$table_name."` ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				$indexes[]=$rs['Key_name'];
			}
			if (in_array('code_10',$indexes))
			{
				for ($i=2;$i<65;$i++)
				{
					$str="ALTER TABLE  `tx_multishop_coupons` DROP INDEX  `code_".$i."`";
					$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				}
				$str="ALTER TABLE  `tx_multishop_coupons` ADD INDEX (  `status` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$str="ALTER TABLE  `tx_multishop_coupons` ADD INDEX (  `startdate` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$str="ALTER TABLE  `tx_multishop_coupons` ADD INDEX (  `enddate` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$str="ALTER TABLE  `tx_multishop_coupons` ADD INDEX (  `times_used` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$str="ALTER TABLE  `tx_multishop_invoices` ADD INDEX (  `orders_id` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$str="ALTER TABLE  `tx_multishop_invoices` ADD INDEX (  `status` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$str="ALTER TABLE  `tx_multishop_invoices` ADD INDEX (  `invoice_id` ) ";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$str="ALTER TABLE  `tx_multishop_invoices` ADD INDEX (  `date` ) ";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$str="ALTER TABLE  `tx_multishop_orders_products` ADD INDEX (  `products_name` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$str="ALTER TABLE  `tx_multishop_orders_products_attributes` ADD INDEX (  `orders_id` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$str="ALTER TABLE  `tx_multishop_orders_products_attributes` ADD INDEX (  `orders_products_id` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
				$str="ALTER TABLE  `tx_multishop_orders_status_history` ADD INDEX (  `crdate` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			


			}
// delete double keys eof
			if (!in_array('combined_one',$indexes))
			{
				$str="ALTER TABLE  `".$table_name."` ADD INDEX `combined_one` (`language_id`,`products_options_values_name` )";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}	
			$indexes=array();
			$table_name='tx_multishop_categories';
			$str="show indexes from `".$table_name."` ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				$indexes[]=$rs['Key_name'];
			}
			if (!in_array('combined_one',$indexes))
			{
				$str="ALTER TABLE  `".$table_name."` ADD INDEX `combined_one` (`page_uid`,`status`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}	
			if (!in_array('combined_two',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_categories` ADD INDEX  `combined_two` (`page_uid`,`status`,`categories_id`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}	
			if (!in_array('combined_three',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_categories` ADD INDEX  `combined_three` (`page_uid`,`status`,`parent_id`)	";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}	
			$indexes=array();
			$table_name='tx_multishop_categories_description';
			$str="show indexes from `".$table_name."` ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				$indexes[]=$rs['Key_name'];
			}
			if (!in_array('combined_one',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_categories_description` ADD INDEX  `combined_one` (  `language_id`,`categories_name`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}	
			if (!in_array('combined_two',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_categories_description` ADD INDEX  `combined_two` (  `language_id`,`categories_id`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}	
			if (!in_array('combined_three',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_categories_description` ADD INDEX  `combined_three` (  `language_id`,`categories_id`,`categories_name`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}
			$indexes=array();
			$table_name='tx_multishop_products';
			$str="show indexes from `".$table_name."` ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				$indexes[]=$rs['Key_name'];
			}
			if (!in_array('combined_one',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_one` (`page_uid`,`products_status`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}	
			if (!in_array('combined_two',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_two` (`page_uid`,`products_status`,`products_id`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}	
			if (!in_array('combined_three',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_three` (`page_uid`,`products_status`,`sort_order`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}
			if (!in_array('combined_four',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_four` (`page_uid`,`products_status`,`products_model`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}	
			if (!in_array('combined_five',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_five` (`page_uid`,`products_status`,`products_date_added`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}	
			if (!in_array('combined_six',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_six` (`page_uid`,`products_status`,`products_last_modified`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}
			if (!in_array('combined_seven',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_seven` (`page_uid`,`products_status`,`products_date_available`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}	
			if (!in_array('combined_eight',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_eight` (`page_uid`,`products_status`,`extid`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}	
			if (!in_array('combined_nine',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_products` ADD INDEX  `combined_nine` (`page_uid`,`products_status`,`products_price`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}
			$indexes=array();
			$table_name='tx_multishop_products_description';
			$str="show indexes from `".$table_name."` ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				$indexes[]=$rs['Key_name'];
			}
			if (!in_array('combined_one',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_products_description` ADD INDEX  `combined_one` (  `language_id`,`products_name`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}	
			if (!in_array('combined_two',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_products_description` ADD INDEX  `combined_two` (  `language_id`,`products_id`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}	
			if (!in_array('combined_three',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_products_description` ADD INDEX  `combined_three` (  `language_id`,`products_id`,`products_name`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}
			if (!in_array('combined_seven',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_products_description` ADD INDEX  `combined_seven` (  `language_id`,`products_meta_keywords`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}	
			if (!in_array('combined_eight',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_products_description` ADD INDEX  `combined_eight` (  `language_id`,`products_name`,`products_description`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}				
			$indexes=array();
			$table_name='tx_multishop_specials';
			$str="show indexes from `".$table_name."` ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				$indexes[]=$rs['Key_name'];
			}
			if (!in_array('combined_one',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_specials` ADD INDEX  `combined_one` (`page_uid`,`status`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}	
			if (!in_array('combined_two',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_specials` ADD INDEX  `combined_two` (`page_uid`,`status`,`specials_new_products_price`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}	
			if (!in_array('combined_three',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_specials` ADD INDEX  `combined_three` (`page_uid`,`status`,`expires_date`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}
			if (!in_array('combined_four',$indexes))
			{
				$str="ALTER TABLE  `tx_multishop_specials` ADD INDEX  `combined_four` (`page_uid`,`status`,`expires_date`,`specials_new_products_price`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}
			$indexes=array();
			$table_name='tx_multishop_products_description';
			$str="show indexes from `".$table_name."` ";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			while ($rs = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry))
			{
				$indexes[]=$rs['Key_name'];
			}
			if (!in_array('combined_four',$indexes))
			{
				$str="ALTER TABLE `tx_multishop_products_description` ADD FULLTEXT  `combined_four` (`products_name` ,`products_description`)";
				$qry=$GLOBALS['TYPO3_DB']->sql_query($str);			
			}				
			// end combined indexes
			// delete duplicates
			$str="ALTER IGNORE TABLE tx_multishop_configuration ADD UNIQUE INDEX dupidx (configuration_key);";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			$str="ALTER TABLE tx_multishop_configuration DROP INDEX dupidx;";
			$qry=$GLOBALS['TYPO3_DB']->sql_query($str);
			
		} 	// check database eof
		// delete duplicates eof
		// load default vars for upgrade purposes eof
		if (!count($messages)) $content='Nothing updated. You are already using the latest version.';
		else $content=addslashes(str_replace("\n","",implode("<br />",$messages)));
		return $content;
	}	
	function getMethodsByProduct ($products_id)
	{
		if (is_numeric($products_id))
		{
			$query = $GLOBALS['TYPO3_DB']->SELECTquery(
							'*',         // SELECT ...
							'tx_multishop_products_method_mappings',     // FROM ...
							'products_id='.$products_id,    // WHERE...
							'',            // GROUP BY...
							'',    // ORDER BY...
							''            // LIMIT ...
			);
			$res = $GLOBALS['TYPO3_DB']->sql_query($query);
			if ($GLOBALS['TYPO3_DB']->sql_num_rows($res) > 0)
			{
				$array=array();			
				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))
				{
					$array[$row['type']][]=$row['method_id'];
				}
				return $array;
			}
		}
	}
}
if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/multishop/pi1/classes/class.mslib_befe.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/multishop/pi1/classes/class.mslib_befe.php"]);
}
?>