<?php
if ($vars['test']=='true') {
	if ($vars['adyen_payment_hpp_mode'] == 'single') {
		$ms['url']	='https://test.adyen.com/hpp/pay.shtml';
	} else {
		$ms['url']	='https://test.adyen.com/hpp/select.shtml';
	}
	
} else {
	if ($vars['adyen_payment_hpp_mode'] == 'single') {
		$ms['url']	='https://live.adyen.com/hpp/pay.shtml';
	} else {
		$ms['url']	='https://live.adyen.com/hpp/select.shtml';
	}
}

/*
   ========================================================================================
   ========================================================================================
   ====== This PHP code provides a payment form for the Adyen Hosted Payment Pages ========
   ====== Version 0.3                                                              ========
   ========================================================================================
   ========================================================================================
*/

/* ========================================================================================
   ==================================  account details  ===================================
   ========================================================================================
	$skinCode
		The skin to be used
	$merchantAccount
		The merchant account we want to process this payment with.
	$sharedSecret
		The shared HMAC key.
*/
	$skinCode 			= $vars['adyen_payment_skincode'];
	$merchantAccount    = $vars['adyen_payment_merchant'];
	$sharedSecret       = $vars['adyen_payment_key'];            // shared HMAC secret for TEST environment
    //  $sharedSecret       = "liveKeyx";            // shared HMAC secret for LIVE environment


/* ========================================================================================
   ===========================  payment-specific details  ============================
   ========================================================================================
	$merchantReference
		This reference will be used in all communication to you about the status of the payment.
	$paymentAmmount
		The payment amount is specified in minor units.
	$currencyCode
		The currency in which the payment is processed.
	$shipBefore
		The date by which the goods or services specified in order must be shipped or rendered.
	$orderDataRaw
		Order Data is a fragment of HTML which will be displayed to the customer on a 
        'review payment' page just before final confirmation of the payment
	$sessionValidity
		The final time by which a payment needs to have been made.
    $shopperReference
        The unique reference to this (registered?) shopper
    $shopperEmail
        The email of the shopper
*/

$sql_country_iso2 = "select tx_multishop_countries_iso_code_2 from countries where countries_name = '".$order['country']."'";
$qry_country_iso2 = mysql_query($sql_country_iso2);
$rs_country_iso2 = mysql_fetch_assoc($qry_country_iso2);

$transaction_id=mslib_fe::createPaymentTransactionId($order['orders_id'],'adyen',$order['payment_method']);
$merchantReference = $transaction_id; // The transaction reference you assign to the payment
//$merchantReference = $orderid; // The transaction reference you assign to the payment
$paymentAmount     = (preg_replace("/^0/",'',$order['total_amount'])*100);;  // Amount in minor units (10000 for 100.00 EUR)
$currencyCode		= "EUR";  // 3 Digit ISO Currency Code  (e.g. GBP, USD)

$shipBeforeDate    = date("Y-m-d" , mktime(date("H"), date("i"), date("s"), date("m"), date("j")+5, date("Y"))); // example: ship in 5 days
$shopperLocale     = $rs_country_iso2['countries_iso_code_2'].'_'.strtoupper($rs_country_iso2['countries_iso_code_2']); // Locale (language) to present to shopper (e.g. en_US, nl, fr, fr_BE)
$orderDataRaw	   = ""; // A description of the payment which is displayed to shoppers
$sessionValidity   = date(DATE_ATOM	, mktime(date("H")+1, date("i"), date("s"), date("m"), date("j"), date("Y"))); // example: shopper has one hour to complete
$shopperReference  = $order['customers_id']; // the shopper id in our system 
$shopperEmail      = $order['customers_email_address']; // the shopper's email address

/* ========================================================================================
==================================  process fields  ====================================
========================================================================================
$merchantSig
	The signature in Base64 encoded format. The is generated by concatenating the values of above fields and computing HMAC over this using the shared secret
	(the shared secret is configured in the Skin in the Adyen test backoffice)
$orderData
	The $orderDataRaw which is GZIP compressed and base64 encoded
*/
//GZIP and base64 encode the orderData
$orderData = base64_encode(gzencode($orderDataRaw));

// concatenate all the data needed to calculate the HMAC-string in the correct order
// (please refer to Appendix B in the Integration Manual for more details)
$hmacData = $paymentAmount . $currencyCode . $shipBeforeDate . $merchantReference . $skinCode 
			. $merchantAccount . $sessionValidity . $shopperEmail . $shopperReference;

// base64 encode the binary result of the HMAC computation. If you use a PHP version < 5.0.12 you
// you may need to use a different HMAC implementation. Please refer to "Computing the HMAC in PHP"
// example from the downloads section on https://support.adyen.com/ 
$merchantSig = base64_encode(hash_hmac('sha1',$hmacData,$sharedSecret,true));

$content .= '
<form method="post" action="'.$ms['url'].'" id="pspform" name="pspform">
<input type="hidden" name="merchantReference" value="'.$merchantReference.'" />
		<input type="hidden" name="paymentAmount"     value="'.$paymentAmount.'" />
		<input type="hidden" name="currencyCode"      value="'.$currencyCode.'" />
		<input type="hidden" name="shipBeforeDate"    value="'.$shipBeforeDate.'" />
		<input type="hidden" name="skinCode"          value="'.$skinCode.'" />
		<input type="hidden" name="merchantAccount"   value="'.$merchantAccount.'" />
		<input type="hidden" name="shopperLocale"     value="'.$shopperLocale.'" />
		<input type="hidden" name="orderData"         value="'.$orderData.'" />
		<input type="hidden" name="sessionValidity"   value="'.$sessionValidity.'" />
		<input type="hidden" name="merchantSig"       value="'.$merchantSig.'" />
		<input type="hidden" name="shopperEmail"      value="'.$shopperEmail.'" />
		<input type="hidden" name="shopperReference"  value="'.$shopperReference.'" />
		<input type="submit" name="submit2" value="Pay with Adyen" />
</form>';

if ($vars['autosubmit']=='true') {
	$content .= '<script type="text/javascript" language="JavaScript">
	jQuery(document).ready(function(){
					jQuery("#pspform").attr(\'target\',\'\');
					jQuery("#pspform").submit();
					});
	</script>';
}
?>